/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: CorePackage.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import fr.supelec.modhelx.core.java.JavaPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.supelec.modhelx.core.CoreFactory
 * @model kind="package"
 * @generated
 */
public interface CorePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "core";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.supelec.fr/modhelx/2009/core";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "modhelx_core";

	/**
	 * The package content type ID.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eCONTENT_TYPE = "fr.supelec.modhelx.core";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	CorePackage eINSTANCE = fr.supelec.modhelx.core.impl.CorePackageImpl.init();

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.ModHelXObjectImpl <em>Mod Hel XObject</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.ModHelXObjectImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getModHelXObject()
	 * @generated
	 */
	int MOD_HEL_XOBJECT = 10;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOD_HEL_XOBJECT__PARAMETERS = 0;

	/**
	 * The number of structural features of the '<em>Mod Hel XObject</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MOD_HEL_XOBJECT_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.ModelImpl <em>Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.ModelImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getModel()
	 * @generated
	 */
	int MODEL = 0;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__PARAMETERS = MOD_HEL_XOBJECT__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Moc</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__MOC = MOD_HEL_XOBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Structure</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__STRUCTURE = MOD_HEL_XOBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__NAME = MOD_HEL_XOBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_FEATURE_COUNT = MOD_HEL_XOBJECT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.ModelOfComputationImpl <em>Model Of Computation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.ModelOfComputationImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getModelOfComputation()
	 * @generated
	 */
	int MODEL_OF_COMPUTATION = 1;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OF_COMPUTATION__PARAMETERS = MOD_HEL_XOBJECT__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OF_COMPUTATION__NAME = MOD_HEL_XOBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Model Of Computation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OF_COMPUTATION_FEATURE_COUNT = MOD_HEL_XOBJECT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.BlockImpl <em>Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.BlockImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getBlock()
	 * @generated
	 */
	int BLOCK = 3;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK__PARAMETERS = MOD_HEL_XOBJECT__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK__PINS_IN = MOD_HEL_XOBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK__PINS_OUT = MOD_HEL_XOBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK__NAME = MOD_HEL_XOBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK__CONTAINER = MOD_HEL_XOBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BLOCK_FEATURE_COUNT = MOD_HEL_XOBJECT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.InterfaceBlockImpl <em>Interface Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.InterfaceBlockImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getInterfaceBlock()
	 * @generated
	 */
	int INTERFACE_BLOCK = 2;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_BLOCK__PARAMETERS = BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_BLOCK__PINS_IN = BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_BLOCK__PINS_OUT = BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_BLOCK__NAME = BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_BLOCK__CONTAINER = BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Internal Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_BLOCK__INTERNAL_MODEL = BLOCK_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Relations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_BLOCK__RELATIONS = BLOCK_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Interface Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTERFACE_BLOCK_FEATURE_COUNT = BLOCK_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.CompositeBlockImpl <em>Composite Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.CompositeBlockImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getCompositeBlock()
	 * @generated
	 */
	int COMPOSITE_BLOCK = 4;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_BLOCK__PARAMETERS = BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_BLOCK__PINS_IN = BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_BLOCK__PINS_OUT = BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_BLOCK__NAME = BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_BLOCK__CONTAINER = BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Relations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_BLOCK__RELATIONS = BLOCK_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Blocks</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_BLOCK__BLOCKS = BLOCK_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Composite Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPOSITE_BLOCK_FEATURE_COUNT = BLOCK_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.RelationImpl <em>Relation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.RelationImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getRelation()
	 * @generated
	 */
	int RELATION = 5;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__PARAMETERS = MOD_HEL_XOBJECT__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__SOURCE = MOD_HEL_XOBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__TARGET = MOD_HEL_XOBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__NAME = MOD_HEL_XOBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Relation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION_FEATURE_COUNT = MOD_HEL_XOBJECT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.PinImpl <em>Pin</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.PinImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getPin()
	 * @generated
	 */
	int PIN = 6;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN__PARAMETERS = MOD_HEL_XOBJECT__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Incoming Relations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN__INCOMING_RELATIONS = MOD_HEL_XOBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Stored Tokens</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN__STORED_TOKENS = MOD_HEL_XOBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Outgoing Relations</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN__OUTGOING_RELATIONS = MOD_HEL_XOBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN__NAME = MOD_HEL_XOBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Input Of</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN__INPUT_OF = MOD_HEL_XOBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Output Of</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN__OUTPUT_OF = MOD_HEL_XOBJECT_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Pin</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PIN_FEATURE_COUNT = MOD_HEL_XOBJECT_FEATURE_COUNT + 6;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.TokenImpl <em>Token</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.TokenImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getToken()
	 * @generated
	 */
	int TOKEN = 7;

	/**
	 * The number of structural features of the '<em>Token</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TOKEN_FEATURE_COUNT = JavaPackage.SERIALIZABLE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.AtomicBlockImpl <em>Atomic Block</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.AtomicBlockImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getAtomicBlock()
	 * @generated
	 */
	int ATOMIC_BLOCK = 8;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATOMIC_BLOCK__PARAMETERS = BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATOMIC_BLOCK__PINS_IN = BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATOMIC_BLOCK__PINS_OUT = BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATOMIC_BLOCK__NAME = BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATOMIC_BLOCK__CONTAINER = BLOCK__CONTAINER;

	/**
	 * The number of structural features of the '<em>Atomic Block</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ATOMIC_BLOCK_FEATURE_COUNT = BLOCK_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.StringToObjectMapEntryImpl <em>String To Object Map Entry</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.StringToObjectMapEntryImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getStringToObjectMapEntry()
	 * @generated
	 */
	int STRING_TO_OBJECT_MAP_ENTRY = 9;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_TO_OBJECT_MAP_ENTRY__KEY = 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_TO_OBJECT_MAP_ENTRY__VALUE = 1;

	/**
	 * The number of structural features of the '<em>String To Object Map Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_TO_OBJECT_MAP_ENTRY_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.IntParameterImpl <em>Int Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.IntParameterImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getIntParameter()
	 * @generated
	 */
	int INT_PARAMETER = 11;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_PARAMETER__KEY = STRING_TO_OBJECT_MAP_ENTRY__KEY;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_PARAMETER__VALUE = STRING_TO_OBJECT_MAP_ENTRY__VALUE;

	/**
	 * The feature id for the '<em><b>Int Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_PARAMETER__INT_VALUE = STRING_TO_OBJECT_MAP_ENTRY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Int Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INT_PARAMETER_FEATURE_COUNT = STRING_TO_OBJECT_MAP_ENTRY_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.StringParameterImpl <em>String Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.StringParameterImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getStringParameter()
	 * @generated
	 */
	int STRING_PARAMETER = 12;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_PARAMETER__KEY = STRING_TO_OBJECT_MAP_ENTRY__KEY;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_PARAMETER__VALUE = STRING_TO_OBJECT_MAP_ENTRY__VALUE;

	/**
	 * The feature id for the '<em><b>String Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_PARAMETER__STRING_VALUE = STRING_TO_OBJECT_MAP_ENTRY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>String Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_PARAMETER_FEATURE_COUNT = STRING_TO_OBJECT_MAP_ENTRY_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.BooleanParameterImpl <em>Boolean Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.BooleanParameterImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getBooleanParameter()
	 * @generated
	 */
	int BOOLEAN_PARAMETER = 13;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_PARAMETER__KEY = STRING_TO_OBJECT_MAP_ENTRY__KEY;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_PARAMETER__VALUE = STRING_TO_OBJECT_MAP_ENTRY__VALUE;

	/**
	 * The feature id for the '<em><b>Boolean Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_PARAMETER__BOOLEAN_VALUE = STRING_TO_OBJECT_MAP_ENTRY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Boolean Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOLEAN_PARAMETER_FEATURE_COUNT = STRING_TO_OBJECT_MAP_ENTRY_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.impl.DoubleParameterImpl <em>Double Parameter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.impl.DoubleParameterImpl
	 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getDoubleParameter()
	 * @generated
	 */
	int DOUBLE_PARAMETER = 14;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_PARAMETER__KEY = STRING_TO_OBJECT_MAP_ENTRY__KEY;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_PARAMETER__VALUE = STRING_TO_OBJECT_MAP_ENTRY__VALUE;

	/**
	 * The feature id for the '<em><b>Double Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_PARAMETER__DOUBLE_VALUE = STRING_TO_OBJECT_MAP_ENTRY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Double Parameter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOUBLE_PARAMETER_FEATURE_COUNT = STRING_TO_OBJECT_MAP_ENTRY_FEATURE_COUNT + 1;

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.Model <em>Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model</em>'.
	 * @see fr.supelec.modhelx.core.Model
	 * @generated
	 */
	EClass getModel();

	/**
	 * Returns the meta object for the containment reference '{@link fr.supelec.modhelx.core.Model#getMoc <em>Moc</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Moc</em>'.
	 * @see fr.supelec.modhelx.core.Model#getMoc()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Moc();

	/**
	 * Returns the meta object for the containment reference '{@link fr.supelec.modhelx.core.Model#getStructure <em>Structure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Structure</em>'.
	 * @see fr.supelec.modhelx.core.Model#getStructure()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Structure();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.core.Model#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.supelec.modhelx.core.Model#getName()
	 * @see #getModel()
	 * @generated
	 */
	EAttribute getModel_Name();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.ModelOfComputation <em>Model Of Computation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Of Computation</em>'.
	 * @see fr.supelec.modhelx.core.ModelOfComputation
	 * @generated
	 */
	EClass getModelOfComputation();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.core.ModelOfComputation#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.supelec.modhelx.core.ModelOfComputation#getName()
	 * @see #getModelOfComputation()
	 * @generated
	 */
	EAttribute getModelOfComputation_Name();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.InterfaceBlock <em>Interface Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Interface Block</em>'.
	 * @see fr.supelec.modhelx.core.InterfaceBlock
	 * @generated
	 */
	EClass getInterfaceBlock();

	/**
	 * Returns the meta object for the containment reference '{@link fr.supelec.modhelx.core.InterfaceBlock#getInternalModel <em>Internal Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Internal Model</em>'.
	 * @see fr.supelec.modhelx.core.InterfaceBlock#getInternalModel()
	 * @see #getInterfaceBlock()
	 * @generated
	 */
	EReference getInterfaceBlock_InternalModel();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.modhelx.core.InterfaceBlock#getRelations <em>Relations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Relations</em>'.
	 * @see fr.supelec.modhelx.core.InterfaceBlock#getRelations()
	 * @see #getInterfaceBlock()
	 * @generated
	 */
	EReference getInterfaceBlock_Relations();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.Block <em>Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Block</em>'.
	 * @see fr.supelec.modhelx.core.Block
	 * @generated
	 */
	EClass getBlock();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.modhelx.core.Block#getPinsIn <em>Pins In</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Pins In</em>'.
	 * @see fr.supelec.modhelx.core.Block#getPinsIn()
	 * @see #getBlock()
	 * @generated
	 */
	EReference getBlock_PinsIn();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.modhelx.core.Block#getPinsOut <em>Pins Out</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Pins Out</em>'.
	 * @see fr.supelec.modhelx.core.Block#getPinsOut()
	 * @see #getBlock()
	 * @generated
	 */
	EReference getBlock_PinsOut();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.core.Block#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.supelec.modhelx.core.Block#getName()
	 * @see #getBlock()
	 * @generated
	 */
	EAttribute getBlock_Name();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.modhelx.core.Block#getContainer <em>Container</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Container</em>'.
	 * @see fr.supelec.modhelx.core.Block#getContainer()
	 * @see #getBlock()
	 * @generated
	 */
	EReference getBlock_Container();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.CompositeBlock <em>Composite Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Composite Block</em>'.
	 * @see fr.supelec.modhelx.core.CompositeBlock
	 * @generated
	 */
	EClass getCompositeBlock();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.modhelx.core.CompositeBlock#getRelations <em>Relations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Relations</em>'.
	 * @see fr.supelec.modhelx.core.CompositeBlock#getRelations()
	 * @see #getCompositeBlock()
	 * @generated
	 */
	EReference getCompositeBlock_Relations();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.modhelx.core.CompositeBlock#getBlocks <em>Blocks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Blocks</em>'.
	 * @see fr.supelec.modhelx.core.CompositeBlock#getBlocks()
	 * @see #getCompositeBlock()
	 * @generated
	 */
	EReference getCompositeBlock_Blocks();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.Relation <em>Relation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Relation</em>'.
	 * @see fr.supelec.modhelx.core.Relation
	 * @generated
	 */
	EClass getRelation();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.modhelx.core.Relation#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source</em>'.
	 * @see fr.supelec.modhelx.core.Relation#getSource()
	 * @see #getRelation()
	 * @generated
	 */
	EReference getRelation_Source();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.modhelx.core.Relation#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see fr.supelec.modhelx.core.Relation#getTarget()
	 * @see #getRelation()
	 * @generated
	 */
	EReference getRelation_Target();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.core.Relation#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.supelec.modhelx.core.Relation#getName()
	 * @see #getRelation()
	 * @generated
	 */
	EAttribute getRelation_Name();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.Pin <em>Pin</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pin</em>'.
	 * @see fr.supelec.modhelx.core.Pin
	 * @generated
	 */
	EClass getPin();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.modhelx.core.Pin#getIncomingRelations <em>Incoming Relations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Incoming Relations</em>'.
	 * @see fr.supelec.modhelx.core.Pin#getIncomingRelations()
	 * @see #getPin()
	 * @generated
	 */
	EReference getPin_IncomingRelations();

	/**
	 * Returns the meta object for the containment reference list '{@link fr.supelec.modhelx.core.Pin#getStoredTokens <em>Stored Tokens</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Stored Tokens</em>'.
	 * @see fr.supelec.modhelx.core.Pin#getStoredTokens()
	 * @see #getPin()
	 * @generated
	 */
	EReference getPin_StoredTokens();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.modhelx.core.Pin#getOutgoingRelations <em>Outgoing Relations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Outgoing Relations</em>'.
	 * @see fr.supelec.modhelx.core.Pin#getOutgoingRelations()
	 * @see #getPin()
	 * @generated
	 */
	EReference getPin_OutgoingRelations();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.core.Pin#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see fr.supelec.modhelx.core.Pin#getName()
	 * @see #getPin()
	 * @generated
	 */
	EAttribute getPin_Name();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.modhelx.core.Pin#getInputOf <em>Input Of</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Input Of</em>'.
	 * @see fr.supelec.modhelx.core.Pin#getInputOf()
	 * @see #getPin()
	 * @generated
	 */
	EReference getPin_InputOf();

	/**
	 * Returns the meta object for the container reference '{@link fr.supelec.modhelx.core.Pin#getOutputOf <em>Output Of</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Output Of</em>'.
	 * @see fr.supelec.modhelx.core.Pin#getOutputOf()
	 * @see #getPin()
	 * @generated
	 */
	EReference getPin_OutputOf();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.Token <em>Token</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Token</em>'.
	 * @see fr.supelec.modhelx.core.Token
	 * @generated
	 */
	EClass getToken();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.AtomicBlock <em>Atomic Block</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Atomic Block</em>'.
	 * @see fr.supelec.modhelx.core.AtomicBlock
	 * @generated
	 */
	EClass getAtomicBlock();

	/**
	 * Returns the meta object for class '{@link java.util.Map.Entry <em>String To Object Map Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>String To Object Map Entry</em>'.
	 * @see java.util.Map.Entry
	 * @model keyDataType="org.eclipse.emf.ecore.EString"
	 *        valueDataType="org.eclipse.emf.ecore.EJavaObject"
	 * @generated
	 */
	EClass getStringToObjectMapEntry();

	/**
	 * Returns the meta object for the attribute '{@link java.util.Map.Entry <em>Key</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Key</em>'.
	 * @see java.util.Map.Entry
	 * @see #getStringToObjectMapEntry()
	 * @generated
	 */
	EAttribute getStringToObjectMapEntry_Key();

	/**
	 * Returns the meta object for the attribute '{@link java.util.Map.Entry <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see java.util.Map.Entry
	 * @see #getStringToObjectMapEntry()
	 * @generated
	 */
	EAttribute getStringToObjectMapEntry_Value();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.ModHelXObject <em>Mod Hel XObject</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mod Hel XObject</em>'.
	 * @see fr.supelec.modhelx.core.ModHelXObject
	 * @generated
	 */
	EClass getModHelXObject();

	/**
	 * Returns the meta object for the map '{@link fr.supelec.modhelx.core.ModHelXObject#getParameters <em>Parameters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>Parameters</em>'.
	 * @see fr.supelec.modhelx.core.ModHelXObject#getParameters()
	 * @see #getModHelXObject()
	 * @generated
	 */
	EReference getModHelXObject_Parameters();

	/**
	 * Returns the meta object for class '{@link java.util.Map.Entry <em>Int Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Int Parameter</em>'.
	 * @see java.util.Map.Entry
	 * @model features="intValue" 
	 *        intValueDefault="0" intValueDataType="org.eclipse.emf.ecore.EInt" intValueRequired="true" intValueTransient="true" intValueVolatile="true" intValueDerived="true" superTypes="fr.supelec.modhelx.core.StringToObjectMapEntry"
	 * @generated
	 */
	EClass getIntParameter();

	/**
	 * Returns the meta object for the attribute '{@link java.util.Map.Entry <em>Int Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Int Value</em>'.
	 * @see java.util.Map.Entry
	 * @see #getIntParameter()
	 * @generated
	 */
	EAttribute getIntParameter_IntValue();

	/**
	 * Returns the meta object for class '{@link java.util.Map.Entry <em>String Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>String Parameter</em>'.
	 * @see java.util.Map.Entry
	 * @model features="stringValue" 
	 *        stringValueDefault="" stringValueDataType="org.eclipse.emf.ecore.EString" stringValueRequired="true" stringValueTransient="true" stringValueVolatile="true" stringValueDerived="true" superTypes="fr.supelec.modhelx.core.StringToObjectMapEntry"
	 * @generated
	 */
	EClass getStringParameter();

	/**
	 * Returns the meta object for the attribute '{@link java.util.Map.Entry <em>String Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>String Value</em>'.
	 * @see java.util.Map.Entry
	 * @see #getStringParameter()
	 * @generated
	 */
	EAttribute getStringParameter_StringValue();

	/**
	 * Returns the meta object for class '{@link java.util.Map.Entry <em>Boolean Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Boolean Parameter</em>'.
	 * @see java.util.Map.Entry
	 * @model features="booleanValue" 
	 *        booleanValueDefault="false" booleanValueDataType="org.eclipse.emf.ecore.EBoolean" booleanValueRequired="true" booleanValueTransient="true" booleanValueVolatile="true" booleanValueDerived="true" superTypes="fr.supelec.modhelx.core.StringToObjectMapEntry"
	 * @generated
	 */
	EClass getBooleanParameter();

	/**
	 * Returns the meta object for the attribute '{@link java.util.Map.Entry <em>Boolean Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Boolean Value</em>'.
	 * @see java.util.Map.Entry
	 * @see #getBooleanParameter()
	 * @generated
	 */
	EAttribute getBooleanParameter_BooleanValue();

	/**
	 * Returns the meta object for class '{@link java.util.Map.Entry <em>Double Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Double Parameter</em>'.
	 * @see java.util.Map.Entry
	 * @model features="doubleValue" 
	 *        doubleValueDefault="0" doubleValueDataType="org.eclipse.emf.ecore.EDouble" doubleValueRequired="true" doubleValueTransient="true" doubleValueVolatile="true" doubleValueDerived="true" superTypes="fr.supelec.modhelx.core.StringToObjectMapEntry"
	 * @generated
	 */
	EClass getDoubleParameter();

	/**
	 * Returns the meta object for the attribute '{@link java.util.Map.Entry <em>Double Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Double Value</em>'.
	 * @see java.util.Map.Entry
	 * @see #getDoubleParameter()
	 * @generated
	 */
	EAttribute getDoubleParameter_DoubleValue();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	CoreFactory getCoreFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.ModelImpl <em>Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.ModelImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getModel()
		 * @generated
		 */
		EClass MODEL = eINSTANCE.getModel();

		/**
		 * The meta object literal for the '<em><b>Moc</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL__MOC = eINSTANCE.getModel_Moc();

		/**
		 * The meta object literal for the '<em><b>Structure</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL__STRUCTURE = eINSTANCE.getModel_Structure();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL__NAME = eINSTANCE.getModel_Name();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.ModelOfComputationImpl <em>Model Of Computation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.ModelOfComputationImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getModelOfComputation()
		 * @generated
		 */
		EClass MODEL_OF_COMPUTATION = eINSTANCE.getModelOfComputation();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_OF_COMPUTATION__NAME = eINSTANCE.getModelOfComputation_Name();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.InterfaceBlockImpl <em>Interface Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.InterfaceBlockImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getInterfaceBlock()
		 * @generated
		 */
		EClass INTERFACE_BLOCK = eINSTANCE.getInterfaceBlock();

		/**
		 * The meta object literal for the '<em><b>Internal Model</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE_BLOCK__INTERNAL_MODEL = eINSTANCE.getInterfaceBlock_InternalModel();

		/**
		 * The meta object literal for the '<em><b>Relations</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INTERFACE_BLOCK__RELATIONS = eINSTANCE.getInterfaceBlock_Relations();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.BlockImpl <em>Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.BlockImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getBlock()
		 * @generated
		 */
		EClass BLOCK = eINSTANCE.getBlock();

		/**
		 * The meta object literal for the '<em><b>Pins In</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BLOCK__PINS_IN = eINSTANCE.getBlock_PinsIn();

		/**
		 * The meta object literal for the '<em><b>Pins Out</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BLOCK__PINS_OUT = eINSTANCE.getBlock_PinsOut();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BLOCK__NAME = eINSTANCE.getBlock_Name();

		/**
		 * The meta object literal for the '<em><b>Container</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BLOCK__CONTAINER = eINSTANCE.getBlock_Container();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.CompositeBlockImpl <em>Composite Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.CompositeBlockImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getCompositeBlock()
		 * @generated
		 */
		EClass COMPOSITE_BLOCK = eINSTANCE.getCompositeBlock();

		/**
		 * The meta object literal for the '<em><b>Relations</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPOSITE_BLOCK__RELATIONS = eINSTANCE.getCompositeBlock_Relations();

		/**
		 * The meta object literal for the '<em><b>Blocks</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COMPOSITE_BLOCK__BLOCKS = eINSTANCE.getCompositeBlock_Blocks();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.RelationImpl <em>Relation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.RelationImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getRelation()
		 * @generated
		 */
		EClass RELATION = eINSTANCE.getRelation();

		/**
		 * The meta object literal for the '<em><b>Source</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATION__SOURCE = eINSTANCE.getRelation_Source();

		/**
		 * The meta object literal for the '<em><b>Target</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATION__TARGET = eINSTANCE.getRelation_Target();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RELATION__NAME = eINSTANCE.getRelation_Name();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.PinImpl <em>Pin</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.PinImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getPin()
		 * @generated
		 */
		EClass PIN = eINSTANCE.getPin();

		/**
		 * The meta object literal for the '<em><b>Incoming Relations</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PIN__INCOMING_RELATIONS = eINSTANCE.getPin_IncomingRelations();

		/**
		 * The meta object literal for the '<em><b>Stored Tokens</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PIN__STORED_TOKENS = eINSTANCE.getPin_StoredTokens();

		/**
		 * The meta object literal for the '<em><b>Outgoing Relations</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PIN__OUTGOING_RELATIONS = eINSTANCE.getPin_OutgoingRelations();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PIN__NAME = eINSTANCE.getPin_Name();

		/**
		 * The meta object literal for the '<em><b>Input Of</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PIN__INPUT_OF = eINSTANCE.getPin_InputOf();

		/**
		 * The meta object literal for the '<em><b>Output Of</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PIN__OUTPUT_OF = eINSTANCE.getPin_OutputOf();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.TokenImpl <em>Token</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.TokenImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getToken()
		 * @generated
		 */
		EClass TOKEN = eINSTANCE.getToken();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.AtomicBlockImpl <em>Atomic Block</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.AtomicBlockImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getAtomicBlock()
		 * @generated
		 */
		EClass ATOMIC_BLOCK = eINSTANCE.getAtomicBlock();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.StringToObjectMapEntryImpl <em>String To Object Map Entry</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.StringToObjectMapEntryImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getStringToObjectMapEntry()
		 * @generated
		 */
		EClass STRING_TO_OBJECT_MAP_ENTRY = eINSTANCE.getStringToObjectMapEntry();

		/**
		 * The meta object literal for the '<em><b>Key</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STRING_TO_OBJECT_MAP_ENTRY__KEY = eINSTANCE.getStringToObjectMapEntry_Key();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STRING_TO_OBJECT_MAP_ENTRY__VALUE = eINSTANCE.getStringToObjectMapEntry_Value();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.ModHelXObjectImpl <em>Mod Hel XObject</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.ModHelXObjectImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getModHelXObject()
		 * @generated
		 */
		EClass MOD_HEL_XOBJECT = eINSTANCE.getModHelXObject();

		/**
		 * The meta object literal for the '<em><b>Parameters</b></em>' map feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MOD_HEL_XOBJECT__PARAMETERS = eINSTANCE.getModHelXObject_Parameters();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.IntParameterImpl <em>Int Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.IntParameterImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getIntParameter()
		 * @generated
		 */
		EClass INT_PARAMETER = eINSTANCE.getIntParameter();

		/**
		 * The meta object literal for the '<em><b>Int Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INT_PARAMETER__INT_VALUE = eINSTANCE.getIntParameter_IntValue();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.StringParameterImpl <em>String Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.StringParameterImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getStringParameter()
		 * @generated
		 */
		EClass STRING_PARAMETER = eINSTANCE.getStringParameter();

		/**
		 * The meta object literal for the '<em><b>String Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STRING_PARAMETER__STRING_VALUE = eINSTANCE.getStringParameter_StringValue();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.BooleanParameterImpl <em>Boolean Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.BooleanParameterImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getBooleanParameter()
		 * @generated
		 */
		EClass BOOLEAN_PARAMETER = eINSTANCE.getBooleanParameter();

		/**
		 * The meta object literal for the '<em><b>Boolean Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BOOLEAN_PARAMETER__BOOLEAN_VALUE = eINSTANCE.getBooleanParameter_BooleanValue();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.impl.DoubleParameterImpl <em>Double Parameter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.impl.DoubleParameterImpl
		 * @see fr.supelec.modhelx.core.impl.CorePackageImpl#getDoubleParameter()
		 * @generated
		 */
		EClass DOUBLE_PARAMETER = eINSTANCE.getDoubleParameter();

		/**
		 * The meta object literal for the '<em><b>Double Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DOUBLE_PARAMETER__DOUBLE_VALUE = eINSTANCE.getDoubleParameter_DoubleValue();

	}

} //CorePackage
