/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: InterfaceBlock.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core;

import org.eclipse.emf.common.util.EList;

import fr.supelec.modhelx.core.time.InstantValue;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Interface Block</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.InterfaceBlock#getInternalModel <em>Internal Model</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.InterfaceBlock#getRelations <em>Relations</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.core.CorePackage#getInterfaceBlock()
 * @model
 * @generated
 */
public interface InterfaceBlock extends Block {
	/**
	 * Returns the value of the '<em><b>Internal Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Internal Model</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Internal Model</em>' containment reference.
	 * @see #setInternalModel(Model)
	 * @see fr.supelec.modhelx.core.CorePackage#getInterfaceBlock_InternalModel()
	 * @model containment="true" required="true" ordered="false"
	 * @generated
	 */
	Model getInternalModel();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.core.InterfaceBlock#getInternalModel <em>Internal Model</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Internal Model</em>' containment reference.
	 * @see #getInternalModel()
	 * @generated
	 */
	void setInternalModel(Model value);

	/**
	 * Returns the value of the '<em><b>Relations</b></em>' containment reference list.
	 * The list contents are of type {@link fr.supelec.modhelx.core.Relation}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Relations</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Relations</em>' containment reference list.
	 * @see fr.supelec.modhelx.core.CorePackage#getInterfaceBlock_Relations()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<Relation> getRelations();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void adaptIn(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void adaptOut(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model timeConstraintsMany="true"
	 * @generated
	 */
	void collectTimeConstraints(ModelOfComputation moc, EList<InstantValue> timeConstraints);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void update(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void startOfSnapshot(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void setup(ModelOfComputation moc, InstantValue initialTime);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void reset(ModelOfComputation moc, InstantValue time);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean validate(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void endOfSnapshot(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void wrapup(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean newSnap(ModelOfComputation moc);

} // InterfaceBlock
