/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: Pin.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Pin</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.Pin#getIncomingRelations <em>Incoming Relations</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.Pin#getStoredTokens <em>Stored Tokens</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.Pin#getOutgoingRelations <em>Outgoing Relations</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.Pin#getName <em>Name</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.Pin#getInputOf <em>Input Of</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.Pin#getOutputOf <em>Output Of</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.core.CorePackage#getPin()
 * @model
 * @generated
 */
public interface Pin extends ModHelXObject {
	/**
	 * Returns the value of the '<em><b>Incoming Relations</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.modhelx.core.Relation}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.modhelx.core.Relation#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Incoming Relations</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Incoming Relations</em>' reference list.
	 * @see fr.supelec.modhelx.core.CorePackage#getPin_IncomingRelations()
	 * @see fr.supelec.modhelx.core.Relation#getTarget
	 * @model opposite="target" ordered="false"
	 * @generated
	 */
	EList<Relation> getIncomingRelations();

	/**
	 * Returns the value of the '<em><b>Stored Tokens</b></em>' containment reference list.
	 * The list contents are of type {@link fr.supelec.modhelx.core.Token}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stored Tokens</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Stored Tokens</em>' containment reference list.
	 * @see fr.supelec.modhelx.core.CorePackage#getPin_StoredTokens()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<Token> getStoredTokens();

	/**
	 * Returns the value of the '<em><b>Outgoing Relations</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.modhelx.core.Relation}.
	 * It is bidirectional and its opposite is '{@link fr.supelec.modhelx.core.Relation#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Outgoing Relations</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Outgoing Relations</em>' reference list.
	 * @see fr.supelec.modhelx.core.CorePackage#getPin_OutgoingRelations()
	 * @see fr.supelec.modhelx.core.Relation#getSource
	 * @model opposite="source" ordered="false"
	 * @generated
	 */
	EList<Relation> getOutgoingRelations();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see fr.supelec.modhelx.core.CorePackage#getPin_Name()
	 * @model
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.core.Pin#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Input Of</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.modhelx.core.Block#getPinsIn <em>Pins In</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Input Of</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Input Of</em>' container reference.
	 * @see #setInputOf(Block)
	 * @see fr.supelec.modhelx.core.CorePackage#getPin_InputOf()
	 * @see fr.supelec.modhelx.core.Block#getPinsIn
	 * @model opposite="pinsIn" transient="false"
	 * @generated
	 */
	Block getInputOf();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.core.Pin#getInputOf <em>Input Of</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Input Of</em>' container reference.
	 * @see #getInputOf()
	 * @generated
	 */
	void setInputOf(Block value);

	/**
	 * Returns the value of the '<em><b>Output Of</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.modhelx.core.Block#getPinsOut <em>Pins Out</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Output Of</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Output Of</em>' container reference.
	 * @see #setOutputOf(Block)
	 * @see fr.supelec.modhelx.core.CorePackage#getPin_OutputOf()
	 * @see fr.supelec.modhelx.core.Block#getPinsOut
	 * @model opposite="pinsOut" transient="false"
	 * @generated
	 */
	Block getOutputOf();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.core.Pin#getOutputOf <em>Output Of</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Output Of</em>' container reference.
	 * @see #getOutputOf()
	 * @generated
	 */
	void setOutputOf(Block value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void addToken(Token token);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	Token getToken(boolean remove);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean hasTokens();

} // Pin
