/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: Relation.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Relation</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A link between an output port (from) and an input port (to). A Relation belongs to a composite block and is used to make links between ports of its components.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.Relation#getSource <em>Source</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.Relation#getTarget <em>Target</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.Relation#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.core.CorePackage#getRelation()
 * @model
 * @generated
 */
public interface Relation extends ModHelXObject {
	/**
	 * Returns the value of the '<em><b>Source</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.modhelx.core.Pin#getOutgoingRelations <em>Outgoing Relations</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source</em>' reference.
	 * @see #setSource(Pin)
	 * @see fr.supelec.modhelx.core.CorePackage#getRelation_Source()
	 * @see fr.supelec.modhelx.core.Pin#getOutgoingRelations
	 * @model opposite="outgoingRelations" required="true" ordered="false"
	 * @generated
	 */
	Pin getSource();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.core.Relation#getSource <em>Source</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Source</em>' reference.
	 * @see #getSource()
	 * @generated
	 */
	void setSource(Pin value);

	/**
	 * Returns the value of the '<em><b>Target</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link fr.supelec.modhelx.core.Pin#getIncomingRelations <em>Incoming Relations</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Target</em>' reference.
	 * @see #setTarget(Pin)
	 * @see fr.supelec.modhelx.core.CorePackage#getRelation_Target()
	 * @see fr.supelec.modhelx.core.Pin#getIncomingRelations
	 * @model opposite="incomingRelations" required="true" ordered="false"
	 * @generated
	 */
	Pin getTarget();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.core.Relation#getTarget <em>Target</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target</em>' reference.
	 * @see #getTarget()
	 * @generated
	 */
	void setTarget(Pin value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see fr.supelec.modhelx.core.CorePackage#getRelation_Name()
	 * @model default="" transient="true" changeable="false" volatile="true" derived="true"
	 * @generated
	 */
	String getName();

} // Relation
