/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: BlockImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.supelec.modhelx.core.Block;
import fr.supelec.modhelx.core.CompositeBlock;
import fr.supelec.modhelx.core.CoreFactory;
import fr.supelec.modhelx.core.CorePackage;
import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.time.InstantValue;
import fr.supelec.modhelx.engine.Platform;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Block</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.impl.BlockImpl#getPinsIn <em>Pins In</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.impl.BlockImpl#getPinsOut <em>Pins Out</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.impl.BlockImpl#getName <em>Name</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.impl.BlockImpl#getContainer <em>Container</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class BlockImpl extends ModHelXObjectImpl implements Block {
	/**
	 * The cached value of the '{@link #getPinsIn() <em>Pins In</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPinsIn()
	 * @generated
	 * @ordered
	 */
	protected EList<Pin> pinsIn;

	/**
	 * The cached value of the '{@link #getPinsOut() <em>Pins Out</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPinsOut()
	 * @generated
	 * @ordered
	 */
	protected EList<Pin> pinsOut;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BlockImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CorePackage.Literals.BLOCK;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Pin> getPinsIn() {
		if (pinsIn == null) {
			pinsIn = new EObjectContainmentWithInverseEList<Pin>(Pin.class, this, CorePackage.BLOCK__PINS_IN, CorePackage.PIN__INPUT_OF);
		}
		return pinsIn;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Pin> getPinsOut() {
		if (pinsOut == null) {
			pinsOut = new EObjectContainmentWithInverseEList<Pin>(Pin.class, this, CorePackage.BLOCK__PINS_OUT, CorePackage.PIN__OUTPUT_OF);
		}
		return pinsOut;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.BLOCK__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CompositeBlock getContainer() {
		if (eContainerFeatureID() != CorePackage.BLOCK__CONTAINER) return null;
		return (CompositeBlock)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetContainer(CompositeBlock newContainer, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newContainer, CorePackage.BLOCK__CONTAINER, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setContainer(CompositeBlock newContainer) {
		if (newContainer != eInternalContainer() || (eContainerFeatureID() != CorePackage.BLOCK__CONTAINER && newContainer != null)) {
			if (EcoreUtil.isAncestor(this, newContainer))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newContainer != null)
				msgs = ((InternalEObject)newContainer).eInverseAdd(this, CorePackage.COMPOSITE_BLOCK__BLOCKS, CompositeBlock.class, msgs);
			msgs = basicSetContainer(newContainer, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.BLOCK__CONTAINER, newContainer, newContainer));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setup(ModelOfComputation moc, InstantValue initialTime) {
		Platform.getLog().entering(getClass().getName(), "setup", new Object[] {getName(), initialTime.getDenotedInstant().get(0).getDate()});
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void startOfSnapshot(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "startOfSnapshot", getName());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void reset(ModelOfComputation moc, InstantValue time) {
		Platform.getLog().entering(getClass().getName(), "reset", new Object[] {getName(), time.getDenotedInstant().get(0).getDate()});
		
        for(Pin p : getPinsIn()){
       		while (p.getToken(true) != null)
       			/* Nothing */;
        }
        for(Pin p : getPinsOut()) {
       		while (p.getToken(true) != null)
       			/* Nothing */;
        }
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void update(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "update", getName());
		Platform.getController().enterMethod(this, "update", moc);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean validate(ModelOfComputation moc) {
		Platform.getLog().exiting(getClass().getName(), "validate", true);
		
		return true;
	}
	protected boolean validate(ModelOfComputation moc, boolean result) {
		Platform.getLog().exiting(getClass().getName(), "validate", result);
		
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void endOfSnapshot(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "endOfSnapshot", getName());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void wrapup(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "wrapup", getName());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean snapDet(ModelOfComputation moc) {
		Platform.getLog().exiting(getClass().getName(), "snapDet", true);
		
		return true;
	}
	protected boolean snapDet(ModelOfComputation moc, boolean result) {
		Platform.getLog().exiting(getClass().getName(), "snapDet", result);
		
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void collectTimeConstraints(ModelOfComputation moc, EList<InstantValue> timeConstraints) {
		Platform.getLog().entering(getClass().getName(), "collectTimeConstraints", getName());
	}
	protected void collectTimeConstraints(ModelOfComputation moc, EList<InstantValue> timeConstraints, InstantValue min) {
		Platform.getLog().entering(getClass().getName(), "collectTimeConstraints", new Object[] {getName(), min.getDenotedInstant().get(0).getDate()});
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void initialSchedule(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "initialSchedule", getName());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void prePropagate(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "prePropagate", getName());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void preSchedule(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "preSchedule", getName());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void postSchedule(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "postSchedule", getName());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void postPropagate(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "postPropagate", getName());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void finalSchedule(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "finalSchedule", getName());
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean newSnap(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "newSnap", getName());
		return false;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Pin newInputPin(String name) {
		Pin p = CoreFactory.eINSTANCE.createPin();
		p.setName(name);
		getPinsIn().add(p);
		return p;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Pin newOutputPin(String name) {
		Pin p = CoreFactory.eINSTANCE.createPin();
		p.setName(name);
		getPinsOut().add(p);
		return p;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CorePackage.BLOCK__PINS_IN:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getPinsIn()).basicAdd(otherEnd, msgs);
			case CorePackage.BLOCK__PINS_OUT:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getPinsOut()).basicAdd(otherEnd, msgs);
			case CorePackage.BLOCK__CONTAINER:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetContainer((CompositeBlock)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CorePackage.BLOCK__PINS_IN:
				return ((InternalEList<?>)getPinsIn()).basicRemove(otherEnd, msgs);
			case CorePackage.BLOCK__PINS_OUT:
				return ((InternalEList<?>)getPinsOut()).basicRemove(otherEnd, msgs);
			case CorePackage.BLOCK__CONTAINER:
				return basicSetContainer(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case CorePackage.BLOCK__CONTAINER:
				return eInternalContainer().eInverseRemove(this, CorePackage.COMPOSITE_BLOCK__BLOCKS, CompositeBlock.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CorePackage.BLOCK__PINS_IN:
				return getPinsIn();
			case CorePackage.BLOCK__PINS_OUT:
				return getPinsOut();
			case CorePackage.BLOCK__NAME:
				return getName();
			case CorePackage.BLOCK__CONTAINER:
				return getContainer();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CorePackage.BLOCK__PINS_IN:
				getPinsIn().clear();
				getPinsIn().addAll((Collection<? extends Pin>)newValue);
				return;
			case CorePackage.BLOCK__PINS_OUT:
				getPinsOut().clear();
				getPinsOut().addAll((Collection<? extends Pin>)newValue);
				return;
			case CorePackage.BLOCK__NAME:
				setName((String)newValue);
				return;
			case CorePackage.BLOCK__CONTAINER:
				setContainer((CompositeBlock)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CorePackage.BLOCK__PINS_IN:
				getPinsIn().clear();
				return;
			case CorePackage.BLOCK__PINS_OUT:
				getPinsOut().clear();
				return;
			case CorePackage.BLOCK__NAME:
				setName(NAME_EDEFAULT);
				return;
			case CorePackage.BLOCK__CONTAINER:
				setContainer((CompositeBlock)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CorePackage.BLOCK__PINS_IN:
				return pinsIn != null && !pinsIn.isEmpty();
			case CorePackage.BLOCK__PINS_OUT:
				return pinsOut != null && !pinsOut.isEmpty();
			case CorePackage.BLOCK__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case CorePackage.BLOCK__CONTAINER:
				return getContainer() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(getClass().getSimpleName());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //BlockImpl
