/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: CorePackageImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.impl;


import java.util.Map;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import fr.supelec.modhelx.core.AtomicBlock;
import fr.supelec.modhelx.core.Block;
import fr.supelec.modhelx.core.CompositeBlock;
import fr.supelec.modhelx.core.CoreFactory;
import fr.supelec.modhelx.core.CorePackage;
import fr.supelec.modhelx.core.InterfaceBlock;
import fr.supelec.modhelx.core.ModHelXObject;
import fr.supelec.modhelx.core.Model;
import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.Relation;
import fr.supelec.modhelx.core.Token;
import fr.supelec.modhelx.core.java.JavaPackage;
import fr.supelec.modhelx.core.java.impl.JavaPackageImpl;
import fr.supelec.modhelx.core.time.TimePackage;
import fr.supelec.modhelx.core.time.impl.TimePackageImpl;
import fr.supelec.modhelx.corelib.CorelibPackage;
import fr.supelec.modhelx.corelib.impl.CorelibPackageImpl;
import fr.supelec.modhelx.mocs.adapterlib.AdapterlibPackage;
import fr.supelec.modhelx.mocs.adapterlib.impl.AdapterlibPackageImpl;
import fr.supelec.modhelx.mocs.autosar.AutosarPackage;
import fr.supelec.modhelx.mocs.autosar.impl.AutosarPackageImpl;
import fr.supelec.modhelx.mocs.de.DePackage;
import fr.supelec.modhelx.mocs.de.impl.DePackageImpl;
import fr.supelec.modhelx.mocs.delib.DelibPackage;
import fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl;
import fr.supelec.modhelx.mocs.fsm.FsmPackage;
import fr.supelec.modhelx.mocs.fsm.impl.FsmPackageImpl;
import fr.supelec.modhelx.mocs.fsmlib.FsmlibPackage;
import fr.supelec.modhelx.mocs.fsmlib.impl.FsmlibPackageImpl;
import fr.supelec.modhelx.mocs.petrinet.PetrinetPackage;
import fr.supelec.modhelx.mocs.petrinet.impl.PetrinetPackageImpl;
import fr.supelec.modhelx.mocs.polymoclib.PolymoclibPackage;
import fr.supelec.modhelx.mocs.polymoclib.impl.PolymoclibPackageImpl;
import fr.supelec.modhelx.mocs.sdf.SdfPackage;
import fr.supelec.modhelx.mocs.sdf.impl.SdfPackageImpl;
import fr.supelec.modhelx.mocs.sdflib.SdflibPackage;
import fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl;
import fr.supelec.modhelx.mocs.simple.SimplePackage;
import fr.supelec.modhelx.mocs.simple.impl.SimplePackageImpl;
import fr.supelec.modhelx.mocs.tfsm.TfsmPackage;
import fr.supelec.modhelx.mocs.tfsm.impl.TfsmPackageImpl;
import fr.supelec.modhelx.mocs.tfsmlib.TfsmlibPackage;
import fr.supelec.modhelx.mocs.tfsmlib.impl.TfsmlibPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class CorePackageImpl extends EPackageImpl implements CorePackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass modelEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass modelOfComputationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass interfaceBlockEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass blockEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass compositeBlockEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass relationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass pinEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass tokenEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass atomicBlockEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass stringToObjectMapEntryEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass modHelXObjectEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass intParameterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass stringParameterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass booleanParameterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass doubleParameterEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see fr.supelec.modhelx.core.CorePackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private CorePackageImpl() {
		super(eNS_URI, CoreFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link CorePackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static CorePackage init() {
		if (isInited) return (CorePackage)EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI);

		// Obtain or create and register package
		CorePackageImpl theCorePackage = (CorePackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof CorePackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new CorePackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		TimePackageImpl theTimePackage = (TimePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI) instanceof TimePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI) : TimePackage.eINSTANCE);
		JavaPackageImpl theJavaPackage = (JavaPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(JavaPackage.eNS_URI) instanceof JavaPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(JavaPackage.eNS_URI) : JavaPackage.eINSTANCE);
		DePackageImpl theDePackage = (DePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(DePackage.eNS_URI) instanceof DePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(DePackage.eNS_URI) : DePackage.eINSTANCE);
		SimplePackageImpl theSimplePackage = (SimplePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SimplePackage.eNS_URI) instanceof SimplePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SimplePackage.eNS_URI) : SimplePackage.eINSTANCE);
		DelibPackageImpl theDelibPackage = (DelibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(DelibPackage.eNS_URI) instanceof DelibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(DelibPackage.eNS_URI) : DelibPackage.eINSTANCE);
		FsmPackageImpl theFsmPackage = (FsmPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FsmPackage.eNS_URI) instanceof FsmPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FsmPackage.eNS_URI) : FsmPackage.eINSTANCE);
		FsmlibPackageImpl theFsmlibPackage = (FsmlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FsmlibPackage.eNS_URI) instanceof FsmlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FsmlibPackage.eNS_URI) : FsmlibPackage.eINSTANCE);
		AdapterlibPackageImpl theAdapterlibPackage = (AdapterlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AdapterlibPackage.eNS_URI) instanceof AdapterlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AdapterlibPackage.eNS_URI) : AdapterlibPackage.eINSTANCE);
		SdfPackageImpl theSdfPackage = (SdfPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SdfPackage.eNS_URI) instanceof SdfPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SdfPackage.eNS_URI) : SdfPackage.eINSTANCE);
		SdflibPackageImpl theSdflibPackage = (SdflibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SdflibPackage.eNS_URI) instanceof SdflibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SdflibPackage.eNS_URI) : SdflibPackage.eINSTANCE);
		PetrinetPackageImpl thePetrinetPackage = (PetrinetPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PetrinetPackage.eNS_URI) instanceof PetrinetPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PetrinetPackage.eNS_URI) : PetrinetPackage.eINSTANCE);
		PolymoclibPackageImpl thePolymoclibPackage = (PolymoclibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PolymoclibPackage.eNS_URI) instanceof PolymoclibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PolymoclibPackage.eNS_URI) : PolymoclibPackage.eINSTANCE);
		AutosarPackageImpl theAutosarPackage = (AutosarPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) instanceof AutosarPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) : AutosarPackage.eINSTANCE);
		TfsmPackageImpl theTfsmPackage = (TfsmPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TfsmPackage.eNS_URI) instanceof TfsmPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TfsmPackage.eNS_URI) : TfsmPackage.eINSTANCE);
		TfsmlibPackageImpl theTfsmlibPackage = (TfsmlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TfsmlibPackage.eNS_URI) instanceof TfsmlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TfsmlibPackage.eNS_URI) : TfsmlibPackage.eINSTANCE);
		CorelibPackageImpl theCorelibPackage = (CorelibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CorelibPackage.eNS_URI) instanceof CorelibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CorelibPackage.eNS_URI) : CorelibPackage.eINSTANCE);

		// Create package meta-data objects
		theCorePackage.createPackageContents();
		theTimePackage.createPackageContents();
		theJavaPackage.createPackageContents();
		theDePackage.createPackageContents();
		theSimplePackage.createPackageContents();
		theDelibPackage.createPackageContents();
		theFsmPackage.createPackageContents();
		theFsmlibPackage.createPackageContents();
		theAdapterlibPackage.createPackageContents();
		theSdfPackage.createPackageContents();
		theSdflibPackage.createPackageContents();
		thePetrinetPackage.createPackageContents();
		thePolymoclibPackage.createPackageContents();
		theAutosarPackage.createPackageContents();
		theTfsmPackage.createPackageContents();
		theTfsmlibPackage.createPackageContents();
		theCorelibPackage.createPackageContents();

		// Initialize created meta-data
		theCorePackage.initializePackageContents();
		theTimePackage.initializePackageContents();
		theJavaPackage.initializePackageContents();
		theDePackage.initializePackageContents();
		theSimplePackage.initializePackageContents();
		theDelibPackage.initializePackageContents();
		theFsmPackage.initializePackageContents();
		theFsmlibPackage.initializePackageContents();
		theAdapterlibPackage.initializePackageContents();
		theSdfPackage.initializePackageContents();
		theSdflibPackage.initializePackageContents();
		thePetrinetPackage.initializePackageContents();
		thePolymoclibPackage.initializePackageContents();
		theAutosarPackage.initializePackageContents();
		theTfsmPackage.initializePackageContents();
		theTfsmlibPackage.initializePackageContents();
		theCorelibPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theCorePackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(CorePackage.eNS_URI, theCorePackage);
		return theCorePackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getModel() {
		return modelEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModel_Moc() {
		return (EReference)modelEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModel_Structure() {
		return (EReference)modelEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getModel_Name() {
		return (EAttribute)modelEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getModelOfComputation() {
		return modelOfComputationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getModelOfComputation_Name() {
		return (EAttribute)modelOfComputationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInterfaceBlock() {
		return interfaceBlockEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getInterfaceBlock_InternalModel() {
		return (EReference)interfaceBlockEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getInterfaceBlock_Relations() {
		return (EReference)interfaceBlockEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBlock() {
		return blockEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBlock_PinsIn() {
		return (EReference)blockEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBlock_PinsOut() {
		return (EReference)blockEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBlock_Name() {
		return (EAttribute)blockEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBlock_Container() {
		return (EReference)blockEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCompositeBlock() {
		return compositeBlockEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCompositeBlock_Relations() {
		return (EReference)compositeBlockEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCompositeBlock_Blocks() {
		return (EReference)compositeBlockEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRelation() {
		return relationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRelation_Source() {
		return (EReference)relationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRelation_Target() {
		return (EReference)relationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRelation_Name() {
		return (EAttribute)relationEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPin() {
		return pinEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPin_IncomingRelations() {
		return (EReference)pinEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPin_StoredTokens() {
		return (EReference)pinEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPin_OutgoingRelations() {
		return (EReference)pinEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPin_Name() {
		return (EAttribute)pinEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPin_InputOf() {
		return (EReference)pinEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPin_OutputOf() {
		return (EReference)pinEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getToken() {
		return tokenEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAtomicBlock() {
		return atomicBlockEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStringToObjectMapEntry() {
		return stringToObjectMapEntryEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getStringToObjectMapEntry_Key() {
		return (EAttribute)stringToObjectMapEntryEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getStringToObjectMapEntry_Value() {
		return (EAttribute)stringToObjectMapEntryEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getModHelXObject() {
		return modHelXObjectEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModHelXObject_Parameters() {
		return (EReference)modHelXObjectEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIntParameter() {
		return intParameterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIntParameter_IntValue() {
		return (EAttribute)intParameterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStringParameter() {
		return stringParameterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getStringParameter_StringValue() {
		return (EAttribute)stringParameterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBooleanParameter() {
		return booleanParameterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getBooleanParameter_BooleanValue() {
		return (EAttribute)booleanParameterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDoubleParameter() {
		return doubleParameterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDoubleParameter_DoubleValue() {
		return (EAttribute)doubleParameterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CoreFactory getCoreFactory() {
		return (CoreFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		modelEClass = createEClass(MODEL);
		createEReference(modelEClass, MODEL__MOC);
		createEReference(modelEClass, MODEL__STRUCTURE);
		createEAttribute(modelEClass, MODEL__NAME);

		modelOfComputationEClass = createEClass(MODEL_OF_COMPUTATION);
		createEAttribute(modelOfComputationEClass, MODEL_OF_COMPUTATION__NAME);

		interfaceBlockEClass = createEClass(INTERFACE_BLOCK);
		createEReference(interfaceBlockEClass, INTERFACE_BLOCK__INTERNAL_MODEL);
		createEReference(interfaceBlockEClass, INTERFACE_BLOCK__RELATIONS);

		blockEClass = createEClass(BLOCK);
		createEReference(blockEClass, BLOCK__PINS_IN);
		createEReference(blockEClass, BLOCK__PINS_OUT);
		createEAttribute(blockEClass, BLOCK__NAME);
		createEReference(blockEClass, BLOCK__CONTAINER);

		compositeBlockEClass = createEClass(COMPOSITE_BLOCK);
		createEReference(compositeBlockEClass, COMPOSITE_BLOCK__RELATIONS);
		createEReference(compositeBlockEClass, COMPOSITE_BLOCK__BLOCKS);

		relationEClass = createEClass(RELATION);
		createEReference(relationEClass, RELATION__SOURCE);
		createEReference(relationEClass, RELATION__TARGET);
		createEAttribute(relationEClass, RELATION__NAME);

		pinEClass = createEClass(PIN);
		createEReference(pinEClass, PIN__INCOMING_RELATIONS);
		createEReference(pinEClass, PIN__STORED_TOKENS);
		createEReference(pinEClass, PIN__OUTGOING_RELATIONS);
		createEAttribute(pinEClass, PIN__NAME);
		createEReference(pinEClass, PIN__INPUT_OF);
		createEReference(pinEClass, PIN__OUTPUT_OF);

		tokenEClass = createEClass(TOKEN);

		atomicBlockEClass = createEClass(ATOMIC_BLOCK);

		stringToObjectMapEntryEClass = createEClass(STRING_TO_OBJECT_MAP_ENTRY);
		createEAttribute(stringToObjectMapEntryEClass, STRING_TO_OBJECT_MAP_ENTRY__KEY);
		createEAttribute(stringToObjectMapEntryEClass, STRING_TO_OBJECT_MAP_ENTRY__VALUE);

		modHelXObjectEClass = createEClass(MOD_HEL_XOBJECT);
		createEReference(modHelXObjectEClass, MOD_HEL_XOBJECT__PARAMETERS);

		intParameterEClass = createEClass(INT_PARAMETER);
		createEAttribute(intParameterEClass, INT_PARAMETER__INT_VALUE);

		stringParameterEClass = createEClass(STRING_PARAMETER);
		createEAttribute(stringParameterEClass, STRING_PARAMETER__STRING_VALUE);

		booleanParameterEClass = createEClass(BOOLEAN_PARAMETER);
		createEAttribute(booleanParameterEClass, BOOLEAN_PARAMETER__BOOLEAN_VALUE);

		doubleParameterEClass = createEClass(DOUBLE_PARAMETER);
		createEAttribute(doubleParameterEClass, DOUBLE_PARAMETER__DOUBLE_VALUE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		TimePackage theTimePackage = (TimePackage)EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI);
		JavaPackage theJavaPackage = (JavaPackage)EPackage.Registry.INSTANCE.getEPackage(JavaPackage.eNS_URI);

		// Add subpackages
		getESubpackages().add(theTimePackage);
		getESubpackages().add(theJavaPackage);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		modelEClass.getESuperTypes().add(this.getModHelXObject());
		modelOfComputationEClass.getESuperTypes().add(this.getModHelXObject());
		interfaceBlockEClass.getESuperTypes().add(this.getBlock());
		blockEClass.getESuperTypes().add(this.getModHelXObject());
		compositeBlockEClass.getESuperTypes().add(this.getBlock());
		relationEClass.getESuperTypes().add(this.getModHelXObject());
		pinEClass.getESuperTypes().add(this.getModHelXObject());
		tokenEClass.getESuperTypes().add(theJavaPackage.getSerializable());
		atomicBlockEClass.getESuperTypes().add(this.getBlock());
		intParameterEClass.getESuperTypes().add(this.getStringToObjectMapEntry());
		stringParameterEClass.getESuperTypes().add(this.getStringToObjectMapEntry());
		booleanParameterEClass.getESuperTypes().add(this.getStringToObjectMapEntry());
		doubleParameterEClass.getESuperTypes().add(this.getStringToObjectMapEntry());

		// Initialize classes and features; add operations and parameters
		initEClass(modelEClass, Model.class, "Model", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModel_Moc(), this.getModelOfComputation(), null, "moc", null, 1, 1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getModel_Structure(), this.getCompositeBlock(), null, "structure", null, 1, 1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getModel_Name(), ecorePackage.getEString(), "name", null, 0, 1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		EOperation op = addEOperation(modelEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(modelEClass, null, "startOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(modelEClass, null, "computeSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(modelEClass, null, "endOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(modelEClass, ecorePackage.getEBoolean(), "newSnap", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(modelEClass, null, "wrapup", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelEClass, null, "reset", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "time", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(modelEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(modelEClass, ecorePackage.getEBoolean(), "validate", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelEClass, null, "collectTimeConstraints", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "timeConstraints", 0, -1, IS_UNIQUE, IS_ORDERED);

		initEClass(modelOfComputationEClass, ModelOfComputation.class, "ModelOfComputation", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getModelOfComputation_Name(), ecorePackage.getEString(), "name", null, 0, 1, ModelOfComputation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "startOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "reset", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "time", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "computeOneStep", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, ecorePackage.getEBoolean(), "snapDet", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, ecorePackage.getEBoolean(), "validate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "endOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "wrapup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "startOfUpdate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "endOfUpdate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, ecorePackage.getEBoolean(), "further", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, ecorePackage.getEBoolean(), "newSnap", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "collectTimeConstraints", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "timeConstraints", 0, -1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "initialSchedule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "prePropagate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "preSchedule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "postSchedule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "postPropagate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, null, "finalSchedule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModel(), "model", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modelOfComputationEClass, ecorePackage.getEJavaObject(), "getValueOfToken", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getToken(), "token", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(interfaceBlockEClass, InterfaceBlock.class, "InterfaceBlock", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getInterfaceBlock_InternalModel(), this.getModel(), null, "internalModel", null, 1, 1, InterfaceBlock.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getInterfaceBlock_Relations(), this.getRelation(), null, "relations", null, 0, -1, InterfaceBlock.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		op = addEOperation(interfaceBlockEClass, null, "adaptIn", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(interfaceBlockEClass, null, "adaptOut", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(interfaceBlockEClass, null, "collectTimeConstraints", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "timeConstraints", 0, -1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(interfaceBlockEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(interfaceBlockEClass, null, "startOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(interfaceBlockEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(interfaceBlockEClass, null, "reset", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "time", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(interfaceBlockEClass, ecorePackage.getEBoolean(), "validate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(interfaceBlockEClass, null, "endOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(interfaceBlockEClass, null, "wrapup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(interfaceBlockEClass, ecorePackage.getEBoolean(), "newSnap", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(blockEClass, Block.class, "Block", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBlock_PinsIn(), this.getPin(), this.getPin_InputOf(), "pinsIn", null, 0, -1, Block.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getBlock_PinsOut(), this.getPin(), this.getPin_OutputOf(), "pinsOut", null, 0, -1, Block.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getBlock_Name(), ecorePackage.getEString(), "name", null, 0, 1, Block.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBlock_Container(), this.getCompositeBlock(), this.getCompositeBlock_Blocks(), "container", null, 0, 1, Block.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(blockEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, null, "startOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, null, "reset", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "time", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, ecorePackage.getEBoolean(), "validate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, null, "endOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, null, "wrapup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, ecorePackage.getEBoolean(), "snapDet", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, null, "collectTimeConstraints", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "timeConstraints", 0, -1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, null, "initialSchedule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, null, "prePropagate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, null, "preSchedule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, null, "postSchedule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, null, "postPropagate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, null, "finalSchedule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, ecorePackage.getEBoolean(), "newSnap", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, this.getPin(), "newInputPin", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "name", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(blockEClass, this.getPin(), "newOutputPin", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "name", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(compositeBlockEClass, CompositeBlock.class, "CompositeBlock", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCompositeBlock_Relations(), this.getRelation(), null, "relations", null, 0, -1, CompositeBlock.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getCompositeBlock_Blocks(), this.getBlock(), this.getBlock_Container(), "blocks", null, 0, -1, CompositeBlock.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "startOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "reset", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "time", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, ecorePackage.getEBoolean(), "validate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "endOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "wrapup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, ecorePackage.getEBoolean(), "snapDet", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "collectTimeConstraints", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "timeConstraints", 0, -1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "initialSchedule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "prePropagate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "preSchedule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "postSchedule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "postPropagate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, null, "finalSchedule", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, ecorePackage.getEBoolean(), "newSnap", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, this.getRelation(), "connect", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getPin(), "from", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getPin(), "to", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(compositeBlockEClass, this.getBlock(), "addBlock", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getBlock(), "block", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "name", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(relationEClass, Relation.class, "Relation", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRelation_Source(), this.getPin(), this.getPin_OutgoingRelations(), "source", null, 1, 1, Relation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getRelation_Target(), this.getPin(), this.getPin_IncomingRelations(), "target", null, 1, 1, Relation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, !IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getRelation_Name(), ecorePackage.getEString(), "name", "", 0, 1, Relation.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEClass(pinEClass, Pin.class, "Pin", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPin_IncomingRelations(), this.getRelation(), this.getRelation_Target(), "incomingRelations", null, 0, -1, Pin.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getPin_StoredTokens(), this.getToken(), null, "storedTokens", null, 0, -1, Pin.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getPin_OutgoingRelations(), this.getRelation(), this.getRelation_Source(), "outgoingRelations", null, 0, -1, Pin.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEAttribute(getPin_Name(), ecorePackage.getEString(), "name", null, 0, 1, Pin.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPin_InputOf(), this.getBlock(), this.getBlock_PinsIn(), "inputOf", null, 0, 1, Pin.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPin_OutputOf(), this.getBlock(), this.getBlock_PinsOut(), "outputOf", null, 0, 1, Pin.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(pinEClass, null, "addToken", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getToken(), "token", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(pinEClass, this.getToken(), "getToken", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEBoolean(), "remove", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(pinEClass, ecorePackage.getEBoolean(), "hasTokens", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(tokenEClass, Token.class, "Token", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(atomicBlockEClass, AtomicBlock.class, "AtomicBlock", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(stringToObjectMapEntryEClass, Map.Entry.class, "StringToObjectMapEntry", !IS_ABSTRACT, !IS_INTERFACE, !IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getStringToObjectMapEntry_Key(), ecorePackage.getEString(), "key", null, 0, 1, Map.Entry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getStringToObjectMapEntry_Value(), ecorePackage.getEJavaObject(), "value", null, 0, 1, Map.Entry.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(modHelXObjectEClass, ModHelXObject.class, "ModHelXObject", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModHelXObject_Parameters(), this.getStringToObjectMapEntry(), null, "parameters", null, 0, -1, ModHelXObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		op = addEOperation(modHelXObjectEClass, ecorePackage.getEJavaObject(), "getValueOfParameter", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "name", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(modHelXObjectEClass, null, "setValueOfParameter", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "name", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEJavaObject(), "value", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(intParameterEClass, Map.Entry.class, "IntParameter", !IS_ABSTRACT, !IS_INTERFACE, !IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getIntParameter_IntValue(), ecorePackage.getEInt(), "intValue", "0", 1, 1, Map.Entry.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEClass(stringParameterEClass, Map.Entry.class, "StringParameter", !IS_ABSTRACT, !IS_INTERFACE, !IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getStringParameter_StringValue(), ecorePackage.getEString(), "stringValue", "", 1, 1, Map.Entry.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEClass(booleanParameterEClass, Map.Entry.class, "BooleanParameter", !IS_ABSTRACT, !IS_INTERFACE, !IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getBooleanParameter_BooleanValue(), ecorePackage.getEBoolean(), "booleanValue", "false", 1, 1, Map.Entry.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEClass(doubleParameterEClass, Map.Entry.class, "DoubleParameter", !IS_ABSTRACT, !IS_INTERFACE, !IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDoubleParameter_DoubleValue(), ecorePackage.getEDouble(), "doubleValue", "0", 1, 1, Map.Entry.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		// Create resource
		createResource(eNS_URI);
	}

} //CorePackageImpl
