/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: InterfaceBlockImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.supelec.modhelx.core.CorePackage;
import fr.supelec.modhelx.core.InterfaceBlock;
import fr.supelec.modhelx.core.Model;
import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Relation;
import fr.supelec.modhelx.core.time.InstantValue;
import fr.supelec.modhelx.engine.Platform;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Interface Block</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.impl.InterfaceBlockImpl#getInternalModel <em>Internal Model</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.impl.InterfaceBlockImpl#getRelations <em>Relations</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class InterfaceBlockImpl extends BlockImpl implements InterfaceBlock {
	/**
	 * The cached value of the '{@link #getInternalModel() <em>Internal Model</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInternalModel()
	 * @generated
	 * @ordered
	 */
	protected Model internalModel;

	/**
	 * The cached value of the '{@link #getRelations() <em>Relations</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRelations()
	 * @generated
	 * @ordered
	 */
	protected EList<Relation> relations;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InterfaceBlockImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CorePackage.Literals.INTERFACE_BLOCK;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Model getInternalModel() {
		return internalModel;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInternalModel(Model newInternalModel, NotificationChain msgs) {
		Model oldInternalModel = internalModel;
		internalModel = newInternalModel;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CorePackage.INTERFACE_BLOCK__INTERNAL_MODEL, oldInternalModel, newInternalModel);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInternalModel(Model newInternalModel) {
		if (newInternalModel != internalModel) {
			NotificationChain msgs = null;
			if (internalModel != null)
				msgs = ((InternalEObject)internalModel).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CorePackage.INTERFACE_BLOCK__INTERNAL_MODEL, null, msgs);
			if (newInternalModel != null)
				msgs = ((InternalEObject)newInternalModel).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CorePackage.INTERFACE_BLOCK__INTERNAL_MODEL, null, msgs);
			msgs = basicSetInternalModel(newInternalModel, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.INTERFACE_BLOCK__INTERNAL_MODEL, newInternalModel, newInternalModel));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Relation> getRelations() {
		if (relations == null) {
			relations = new EObjectContainmentEList<Relation>(Relation.class, this, CorePackage.INTERFACE_BLOCK__RELATIONS);
		}
		return relations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void adaptIn(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "adaptIn", getName());
		Platform.getController().enterMethod(this, "adaptIn");
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void adaptOut(ModelOfComputation moc) {
		Platform.getLog().entering(getClass().getName(), "adaptOut", getName());
		Platform.getController().enterMethod(this, "adaptOut");
	}


	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void collectTimeConstraints(ModelOfComputation moc, EList<InstantValue> timeConstraints) {
		super.collectTimeConstraints(moc, timeConstraints);
		
		// TODO
		//getInternalModel().collectTimeConstraints(timeConstraints);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void update(ModelOfComputation moc) {
		super.update(moc);
		
		Platform.getLog().entering(getClass().getName(), "update", getName());
		Platform.getController().enterMethod(this, "update");

		this.adaptIn(moc);
		if(doUpdateInternalModel(moc)) this.getInternalModel().update();
		this.adaptOut(moc);
	}
	
	/**
	 * Tells the interface block whether or not the internal model of this
	 * interface block must be updated when the interface block is update.
	 * 
	 * @param moc the MoC
	 * @return {@code true} if the internal model has to be updated, 
	 * {@code false} otherwise
	 */
	protected boolean doUpdateInternalModel(ModelOfComputation moc) {
		throw new UnsupportedOperationException("Every InterfaceBlock must implement doUpdateInternalModel");
	}


	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void startOfSnapshot(ModelOfComputation moc) {
		super.startOfSnapshot(moc);
		Platform.getLog().entering(getClass().getName(), "startOfSnapshot", getName());

		this.getInternalModel().startOfSnapshot();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setup(ModelOfComputation moc, InstantValue initialTime) {
		super.setup(moc, initialTime);
		Platform.getLog().entering(getClass().getName(), "setup", getName());

		this.getInternalModel().setup(initialTime);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void reset(ModelOfComputation moc, InstantValue time) {
		super.reset(moc, time);
		Platform.getLog().entering(getClass().getName(), "reset", getName());

		this.getInternalModel().reset(time);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean validate(ModelOfComputation moc) {
		super.validate(moc);
		Platform.getLog().entering(getClass().getName(), "validate", getName());

		return this.getInternalModel().validate();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void endOfSnapshot(ModelOfComputation moc) {
		super.endOfSnapshot(moc);
		Platform.getLog().entering(getClass().getName(), "endOfSnapshot", getName());

		this.getInternalModel().endOfSnapshot();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void wrapup(ModelOfComputation moc) {
		super.wrapup(moc);
		Platform.getLog().entering(getClass().getName(), "wrapup", getName());

		this.getInternalModel().wrapup();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean newSnap(ModelOfComputation moc) {
		super.newSnap(moc);
		Platform.getLog().entering(getClass().getName(), "newSnap", getName());
		
		return getInternalModel().newSnap();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CorePackage.INTERFACE_BLOCK__INTERNAL_MODEL:
				return basicSetInternalModel(null, msgs);
			case CorePackage.INTERFACE_BLOCK__RELATIONS:
				return ((InternalEList<?>)getRelations()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CorePackage.INTERFACE_BLOCK__INTERNAL_MODEL:
				return getInternalModel();
			case CorePackage.INTERFACE_BLOCK__RELATIONS:
				return getRelations();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CorePackage.INTERFACE_BLOCK__INTERNAL_MODEL:
				setInternalModel((Model)newValue);
				return;
			case CorePackage.INTERFACE_BLOCK__RELATIONS:
				getRelations().clear();
				getRelations().addAll((Collection<? extends Relation>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CorePackage.INTERFACE_BLOCK__INTERNAL_MODEL:
				setInternalModel((Model)null);
				return;
			case CorePackage.INTERFACE_BLOCK__RELATIONS:
				getRelations().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CorePackage.INTERFACE_BLOCK__INTERNAL_MODEL:
				return internalModel != null;
			case CorePackage.INTERFACE_BLOCK__RELATIONS:
				return relations != null && !relations.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //InterfaceBlockImpl
