/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: ModelImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
/**
 * <copyright>
 * </copyright>
 *
 * $Id: ModelImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import fr.supelec.modhelx.core.CompositeBlock;
import fr.supelec.modhelx.core.CorePackage;
import fr.supelec.modhelx.core.Model;
import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.time.InstantValue;
import fr.supelec.modhelx.engine.Platform;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Model</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.impl.ModelImpl#getMoc <em>Moc</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.impl.ModelImpl#getStructure <em>Structure</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.impl.ModelImpl#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ModelImpl extends ModHelXObjectImpl implements Model {
	/**
	 * The cached value of the '{@link #getMoc() <em>Moc</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMoc()
	 * @generated
	 * @ordered
	 */
	protected ModelOfComputation moc;

	/**
	 * The cached value of the '{@link #getStructure() <em>Structure</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStructure()
	 * @generated
	 * @ordered
	 */
	protected CompositeBlock structure;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CorePackage.Literals.MODEL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ModelOfComputation getMoc() {
		return moc;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMoc(ModelOfComputation newMoc, NotificationChain msgs) {
		ModelOfComputation oldMoc = moc;
		moc = newMoc;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CorePackage.MODEL__MOC, oldMoc, newMoc);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMoc(ModelOfComputation newMoc) {
		if (newMoc != moc) {
			NotificationChain msgs = null;
			if (moc != null)
				msgs = ((InternalEObject)moc).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CorePackage.MODEL__MOC, null, msgs);
			if (newMoc != null)
				msgs = ((InternalEObject)newMoc).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CorePackage.MODEL__MOC, null, msgs);
			msgs = basicSetMoc(newMoc, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.MODEL__MOC, newMoc, newMoc));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CompositeBlock getStructure() {
		return structure;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetStructure(CompositeBlock newStructure, NotificationChain msgs) {
		CompositeBlock oldStructure = structure;
		structure = newStructure;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CorePackage.MODEL__STRUCTURE, oldStructure, newStructure);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStructure(CompositeBlock newStructure) {
		if (newStructure != structure) {
			NotificationChain msgs = null;
			if (structure != null)
				msgs = ((InternalEObject)structure).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CorePackage.MODEL__STRUCTURE, null, msgs);
			if (newStructure != null)
				msgs = ((InternalEObject)newStructure).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CorePackage.MODEL__STRUCTURE, null, msgs);
			msgs = basicSetStructure(newStructure, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.MODEL__STRUCTURE, newStructure, newStructure));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.MODEL__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setup(InstantValue initialTime) {
		Platform.getLog().entering(getClass().getName(), "setup", new Object[] {getName(), initialTime.getDenotedInstant().get(0).getDate()});
		Platform.getController().enterMethod(this, "setup", initialTime);
		//Platform.getLog().fine("moc = " + moc);

		moc.setup(this, initialTime);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void startOfSnapshot() {
		Platform.getLog().entering(getClass().getName(), "startOfSnapshot", getName());
		Platform.getController().enterMethod(this, "startOfSnapshot");

		moc.startOfSnapshot(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void computeSnapshot() {
		Platform.getLog().entering(getClass().getName(), "computeSnapshot", getName());
		Platform.getController().enterMethod(this, "computeSnapshot");

		boolean det = false;
		while (!det){
			moc.computeOneStep(this);
		  	det = moc.snapDet(this);
		}
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void endOfSnapshot() {
		Platform.getLog().entering(getClass().getName(), "endOfSnapshot", getName());
		Platform.getController().enterMethod(this, "endOfSnapshot");

		moc.endOfSnapshot(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean newSnap() {
		Platform.getLog().entering(getClass().getName(), "newSnap", getName());
		Platform.getController().enterMethod(this, "newSnap");

		boolean result = moc.newSnap(this);
		
		Platform.getController().leaveMethod(result);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void wrapup() {
		Platform.getLog().entering(getClass().getName(), "wrapup", getName());
		Platform.getController().enterMethod(this, "wrapup");

		moc.wrapup(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void reset(InstantValue time) {
		Platform.getLog().entering(getClass().getName(), "reset", new Object[] {getName(), time.getDenotedInstant().get(0).getDate()});
		Platform.getController().enterMethod(this, "reset", time);

		moc.reset(this, time);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void update() {
		Platform.getLog().entering(getClass().getName(), "update", getName());
		Platform.getController().enterMethod(this, "update");

		/* DEBUG: print input pins */
		{
			String res = "";
			for(Pin p : getStructure().getPinsIn()) {
				res += p + ":" + p.getStoredTokens() + ";   ";
			}
			Platform.getLog().finest("Input pins: " + res);
		}
		/* DEBUG: end */
		
		moc.startOfUpdate(this);

		boolean fur = true;
		while(fur){
		    moc.computeOneStep(this);
		    fur = moc.further(this);
		}
		moc.endOfUpdate(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean validate() {
		Platform.getLog().entering(getClass().getName(), "validate", getName());
		Platform.getController().enterMethod(this, "validate");

		boolean result = moc.validate(this);
		
		Platform.getController().leaveMethod(result);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void collectTimeConstraints(EList<InstantValue> timeConstraints) {
		Platform.getLog().entering(getClass().getName(), "collectTimeConstraints", getName());
		Platform.getController().enterMethod(this, "collectTimeConstraints", timeConstraints);

		moc.collectTimeConstraints(this, timeConstraints);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CorePackage.MODEL__MOC:
				return basicSetMoc(null, msgs);
			case CorePackage.MODEL__STRUCTURE:
				return basicSetStructure(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CorePackage.MODEL__MOC:
				return getMoc();
			case CorePackage.MODEL__STRUCTURE:
				return getStructure();
			case CorePackage.MODEL__NAME:
				return getName();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CorePackage.MODEL__MOC:
				setMoc((ModelOfComputation)newValue);
				return;
			case CorePackage.MODEL__STRUCTURE:
				setStructure((CompositeBlock)newValue);
				return;
			case CorePackage.MODEL__NAME:
				setName((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CorePackage.MODEL__MOC:
				setMoc((ModelOfComputation)null);
				return;
			case CorePackage.MODEL__STRUCTURE:
				setStructure((CompositeBlock)null);
				return;
			case CorePackage.MODEL__NAME:
				setName(NAME_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CorePackage.MODEL__MOC:
				return moc != null;
			case CorePackage.MODEL__STRUCTURE:
				return structure != null;
			case CorePackage.MODEL__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //ModelImpl
