/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: ModelOfComputationImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import fr.supelec.modhelx.core.CorePackage;
import fr.supelec.modhelx.core.Model;
import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Token;
import fr.supelec.modhelx.core.time.InstantValue;
import fr.supelec.modhelx.engine.Platform;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Model Of Computation</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.impl.ModelOfComputationImpl#getName <em>Name</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ModelOfComputationImpl extends ModHelXObjectImpl implements ModelOfComputation {
	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelOfComputationImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CorePackage.Literals.MODEL_OF_COMPUTATION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.MODEL_OF_COMPUTATION__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setup(Model model, InstantValue initialTime) {
		Platform.getLog().entering(getClass().getName(), "setup", new Object[] {model.getName(), initialTime.getDenotedInstant().get(0).getDate()});
		Platform.getController().enterMethod(this, "setup", model, initialTime);

		model.getStructure().setup(this, initialTime);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void startOfSnapshot(Model model) {
		Platform.getLog().entering(getClass().getName(), "startOfSnapshot", model.getName());
		Platform.getController().enterMethod(this, "startOfSnapshot", model);

		model.getStructure().startOfSnapshot(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void reset(Model model, InstantValue time) {
		Platform.getLog().entering(getClass().getName(), "reset", new Object[] {model.getName(), time.getDenotedInstant().get(0).getDate()});
		Platform.getController().enterMethod(this, "reset", model, time);

		model.getStructure().reset(this, time);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void computeOneStep(Model model) {
		Platform.getLog().entering(getClass().getName(), "computeOneStep", model.getName());
		Platform.getController().enterMethod(this, "computeOneStep", model);

		initialSchedule(model);
	    prePropagate(model);
	    preSchedule(model);
	    update(model);
	    postSchedule(model);
	    postPropagate(model);
	    finalSchedule(model);
	    
	    Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean snapDet(Model model) {
		Platform.getLog().entering(getClass().getName(), "snapDet", model.getName());
		Platform.getController().enterMethod(this, "snapDet", model);

		boolean result = model.getStructure().snapDet(this);
		
		Platform.getController().leaveMethod(result);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean validate(Model model) {
		Platform.getLog().entering(getClass().getName(), "validate", model.getName());
		Platform.getController().enterMethod(this, "validate", model);

		boolean result = model.getStructure().validate(this);
		
		Platform.getController().leaveMethod(result);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void endOfSnapshot(Model model) {
		Platform.getLog().entering(getClass().getName(), "endOfSnapshot", model.getName());
		Platform.getController().enterMethod(this, "endOfSnapshot", model);

		model.getStructure().endOfSnapshot(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void wrapup(Model model) {
		Platform.getLog().entering(getClass().getName(), "wrapup", model.getName());
		Platform.getController().enterMethod(this, "wrapup", model);

		model.getStructure().wrapup(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void update(Model model) {
		Platform.getLog().entering(getClass().getName(), "update", model.getName());
		Platform.getController().enterMethod(this, "update", model);

		model.getStructure().update(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void startOfUpdate(Model model) {
		Platform.getLog().entering(getClass().getName(), "startOfUpdate", model.getName());
		Platform.getController().enterMethod(this, "startOfUpdate", model);
		
		Platform.getController().leaveMethod();

	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void endOfUpdate(Model model) {
		Platform.getLog().entering(getClass().getName(), "endOfUpdate", model.getName());
		Platform.getController().enterMethod(this, "endOfUpdate", model);
		
		Platform.getController().leaveMethod();

	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean further(Model model) {
		Platform.getLog().entering(getClass().getName(), "further", model.getName());
		Platform.getController().enterMethod(this, "further", model);

		Platform.getController().leaveMethod(false);
		
		return false;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean newSnap(Model model) {
		Platform.getLog().entering(getClass().getName(), "newSnap", model.getName());
		Platform.getController().enterMethod(this, "newSnap", model);

		Platform.getController().leaveMethod(false);
		
		return false;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void collectTimeConstraints(Model model, EList<InstantValue> timeConstraints) {
		Platform.getLog().entering(getClass().getName(), "collectTimeConstraints", model.getName());
		Platform.getLog().finer("Time constraints at MoC: " + timeConstraints);
		Platform.getController().enterMethod(this, "collectTimeConstraints", model, timeConstraints);

		model.getStructure().collectTimeConstraints(this, timeConstraints);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void initialSchedule(Model model) {
		Platform.getLog().entering(getClass().getName(), "initialSchedule", model.getName());
		Platform.getController().enterMethod(this, "initialSchedule", model);

		model.getStructure().initialSchedule(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void prePropagate(Model model) {
		Platform.getLog().entering(getClass().getName(), "prePropagate", model.getName());
		Platform.getController().enterMethod(this, "prePropagate", model);

		model.getStructure().prePropagate(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void preSchedule(Model model) {
		Platform.getLog().entering(getClass().getName(), "preSchedule", model.getName());
		Platform.getController().enterMethod(this, "preSchedule", model);

		model.getStructure().preSchedule(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void postSchedule(Model model) {
		Platform.getLog().entering(getClass().getName(), "postSchedule", model.getName());
		Platform.getController().enterMethod(this, "postSchedule", model);

		model.getStructure().postSchedule(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void postPropagate(Model model) {
		Platform.getLog().entering(getClass().getName(), "postPropagate", model.getName());
		Platform.getController().enterMethod(this, "postPropagate", model);

		model.getStructure().postPropagate(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void finalSchedule(Model model) {
		Platform.getLog().entering(getClass().getName(), "finalSchedule", model.getName());
		Platform.getController().enterMethod(this, "finalSchedule", model);

		model.getStructure().finalSchedule(this);
		
		Platform.getController().leaveMethod();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Object getValueOfToken(Token token) {
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CorePackage.MODEL_OF_COMPUTATION__NAME:
				return getName();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CorePackage.MODEL_OF_COMPUTATION__NAME:
				setName((String)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CorePackage.MODEL_OF_COMPUTATION__NAME:
				setName(NAME_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CorePackage.MODEL_OF_COMPUTATION__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(')');
		return result.toString();
	}

} //ModelOfComputationImpl
