/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: PinImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.supelec.modhelx.core.Block;
import fr.supelec.modhelx.core.CorePackage;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.Relation;
import fr.supelec.modhelx.core.Token;
import fr.supelec.modhelx.engine.Platform;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Pin</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.impl.PinImpl#getIncomingRelations <em>Incoming Relations</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.impl.PinImpl#getStoredTokens <em>Stored Tokens</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.impl.PinImpl#getOutgoingRelations <em>Outgoing Relations</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.impl.PinImpl#getName <em>Name</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.impl.PinImpl#getInputOf <em>Input Of</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.impl.PinImpl#getOutputOf <em>Output Of</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class PinImpl extends ModHelXObjectImpl implements Pin {
	/**
	 * The cached value of the '{@link #getIncomingRelations() <em>Incoming Relations</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIncomingRelations()
	 * @generated
	 * @ordered
	 */
	protected EList<Relation> incomingRelations;

	/**
	 * The cached value of the '{@link #getStoredTokens() <em>Stored Tokens</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStoredTokens()
	 * @generated
	 * @ordered
	 */
	protected EList<Token> storedTokens;

	/**
	 * The cached value of the '{@link #getOutgoingRelations() <em>Outgoing Relations</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getOutgoingRelations()
	 * @generated
	 * @ordered
	 */
	protected EList<Relation> outgoingRelations;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PinImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CorePackage.Literals.PIN;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Relation> getIncomingRelations() {
		if (incomingRelations == null) {
			incomingRelations = new EObjectWithInverseResolvingEList<Relation>(Relation.class, this, CorePackage.PIN__INCOMING_RELATIONS, CorePackage.RELATION__TARGET);
		}
		return incomingRelations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Token> getStoredTokens() {
		if (storedTokens == null) {
			storedTokens = new EObjectContainmentEList<Token>(Token.class, this, CorePackage.PIN__STORED_TOKENS);
		}
		return storedTokens;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Relation> getOutgoingRelations() {
		if (outgoingRelations == null) {
			outgoingRelations = new EObjectWithInverseResolvingEList<Relation>(Relation.class, this, CorePackage.PIN__OUTGOING_RELATIONS, CorePackage.RELATION__SOURCE);
		}
		return outgoingRelations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.PIN__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Block getInputOf() {
		if (eContainerFeatureID() != CorePackage.PIN__INPUT_OF) return null;
		return (Block)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInputOf(Block newInputOf, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newInputOf, CorePackage.PIN__INPUT_OF, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInputOf(Block newInputOf) {
		if (newInputOf != eInternalContainer() || (eContainerFeatureID() != CorePackage.PIN__INPUT_OF && newInputOf != null)) {
			if (EcoreUtil.isAncestor(this, newInputOf))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newInputOf != null)
				msgs = ((InternalEObject)newInputOf).eInverseAdd(this, CorePackage.BLOCK__PINS_IN, Block.class, msgs);
			msgs = basicSetInputOf(newInputOf, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.PIN__INPUT_OF, newInputOf, newInputOf));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Block getOutputOf() {
		if (eContainerFeatureID() != CorePackage.PIN__OUTPUT_OF) return null;
		return (Block)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetOutputOf(Block newOutputOf, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newOutputOf, CorePackage.PIN__OUTPUT_OF, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setOutputOf(Block newOutputOf) {
		if (newOutputOf != eInternalContainer() || (eContainerFeatureID() != CorePackage.PIN__OUTPUT_OF && newOutputOf != null)) {
			if (EcoreUtil.isAncestor(this, newOutputOf))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newOutputOf != null)
				msgs = ((InternalEObject)newOutputOf).eInverseAdd(this, CorePackage.BLOCK__PINS_OUT, Block.class, msgs);
			msgs = basicSetOutputOf(newOutputOf, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.PIN__OUTPUT_OF, newOutputOf, newOutputOf));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void addToken(Token token) {
		Platform.getLog().entering(getClass().getName(), "addToken", getName());

       	getStoredTokens().add(token);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Token getToken(boolean remove) {
		Platform.getLog().entering(getClass().getName(), "getToken", getName());

		if (getStoredTokens().isEmpty()) return null;
		if (remove) return getStoredTokens().remove(0);
		return getStoredTokens().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean hasTokens() {
		return ! getStoredTokens().isEmpty();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CorePackage.PIN__INCOMING_RELATIONS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getIncomingRelations()).basicAdd(otherEnd, msgs);
			case CorePackage.PIN__OUTGOING_RELATIONS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getOutgoingRelations()).basicAdd(otherEnd, msgs);
			case CorePackage.PIN__INPUT_OF:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetInputOf((Block)otherEnd, msgs);
			case CorePackage.PIN__OUTPUT_OF:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetOutputOf((Block)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CorePackage.PIN__INCOMING_RELATIONS:
				return ((InternalEList<?>)getIncomingRelations()).basicRemove(otherEnd, msgs);
			case CorePackage.PIN__STORED_TOKENS:
				return ((InternalEList<?>)getStoredTokens()).basicRemove(otherEnd, msgs);
			case CorePackage.PIN__OUTGOING_RELATIONS:
				return ((InternalEList<?>)getOutgoingRelations()).basicRemove(otherEnd, msgs);
			case CorePackage.PIN__INPUT_OF:
				return basicSetInputOf(null, msgs);
			case CorePackage.PIN__OUTPUT_OF:
				return basicSetOutputOf(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case CorePackage.PIN__INPUT_OF:
				return eInternalContainer().eInverseRemove(this, CorePackage.BLOCK__PINS_IN, Block.class, msgs);
			case CorePackage.PIN__OUTPUT_OF:
				return eInternalContainer().eInverseRemove(this, CorePackage.BLOCK__PINS_OUT, Block.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CorePackage.PIN__INCOMING_RELATIONS:
				return getIncomingRelations();
			case CorePackage.PIN__STORED_TOKENS:
				return getStoredTokens();
			case CorePackage.PIN__OUTGOING_RELATIONS:
				return getOutgoingRelations();
			case CorePackage.PIN__NAME:
				return getName();
			case CorePackage.PIN__INPUT_OF:
				return getInputOf();
			case CorePackage.PIN__OUTPUT_OF:
				return getOutputOf();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CorePackage.PIN__INCOMING_RELATIONS:
				getIncomingRelations().clear();
				getIncomingRelations().addAll((Collection<? extends Relation>)newValue);
				return;
			case CorePackage.PIN__STORED_TOKENS:
				getStoredTokens().clear();
				getStoredTokens().addAll((Collection<? extends Token>)newValue);
				return;
			case CorePackage.PIN__OUTGOING_RELATIONS:
				getOutgoingRelations().clear();
				getOutgoingRelations().addAll((Collection<? extends Relation>)newValue);
				return;
			case CorePackage.PIN__NAME:
				setName((String)newValue);
				return;
			case CorePackage.PIN__INPUT_OF:
				setInputOf((Block)newValue);
				return;
			case CorePackage.PIN__OUTPUT_OF:
				setOutputOf((Block)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CorePackage.PIN__INCOMING_RELATIONS:
				getIncomingRelations().clear();
				return;
			case CorePackage.PIN__STORED_TOKENS:
				getStoredTokens().clear();
				return;
			case CorePackage.PIN__OUTGOING_RELATIONS:
				getOutgoingRelations().clear();
				return;
			case CorePackage.PIN__NAME:
				setName(NAME_EDEFAULT);
				return;
			case CorePackage.PIN__INPUT_OF:
				setInputOf((Block)null);
				return;
			case CorePackage.PIN__OUTPUT_OF:
				setOutputOf((Block)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CorePackage.PIN__INCOMING_RELATIONS:
				return incomingRelations != null && !incomingRelations.isEmpty();
			case CorePackage.PIN__STORED_TOKENS:
				return storedTokens != null && !storedTokens.isEmpty();
			case CorePackage.PIN__OUTGOING_RELATIONS:
				return outgoingRelations != null && !outgoingRelations.isEmpty();
			case CorePackage.PIN__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case CorePackage.PIN__INPUT_OF:
				return getInputOf() != null;
			case CorePackage.PIN__OUTPUT_OF:
				return getOutputOf() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(getInputOf() != null ? getInputOf().getName() : (getOutputOf() != null ? getOutputOf().getName() : "<null>"));
		result.append("::");
		result.append(name);
		return result.toString();
	}

} //PinImpl
