/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: Clock.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.time;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Clock</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.time.Clock#getNature <em>Nature</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.time.Clock#getCurrentTime <em>Current Time</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.core.time.TimePackage#getClock()
 * @model abstract="true"
 *        annotation="GenModel documentation='From MARTE:\rA clock provides access to a discrete time base, and possibly to a dense time base, but through a discrete time base. The instants of this time base correspond to \"ticks\" of the clock. A clock associates time values with instants of the time base. \nThese values may be from a discrete or a dense set of values. \nA Clock accepts units (acceptedUnits property). Unit is defined in the NFP_Nature package. One of these accepted units is the defaultUnit, which is attached to the currentTime value. \nClock is an abstract class.'"
 * @generated
 */
public interface Clock extends EObject {

	/**
	 * Returns the value of the '<em><b>Nature</b></em>' attribute.
	 * The literals are from the enumeration {@link fr.supelec.modhelx.core.time.TimeNatureKind}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Nature</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Nature</em>' attribute.
	 * @see fr.supelec.modhelx.core.time.TimeNatureKind
	 * @see #setNature(TimeNatureKind)
	 * @see fr.supelec.modhelx.core.time.TimePackage#getClock_Nature()
	 * @model
	 * @generated
	 */
	TimeNatureKind getNature();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.core.time.Clock#getNature <em>Nature</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Nature</em>' attribute.
	 * @see fr.supelec.modhelx.core.time.TimeNatureKind
	 * @see #getNature()
	 * @generated
	 */
	void setNature(TimeNatureKind value);

	/**
	 * Returns the value of the '<em><b>Current Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Current Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Current Time</em>' attribute.
	 * @see fr.supelec.modhelx.core.time.TimePackage#getClock_CurrentTime()
	 * @model changeable="false"
	 * @generated
	 */
	double getCurrentTime();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model minRequired="true" maxRequired="true"
	 * @generated
	 */
	DurationValue createDurationValue(InstantValue min, InstantValue max);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model required="true"
	 * @generated
	 */
	InstantValue createInstantValue(double date);
} // Clock
