/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DurationValue.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.time;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Duration Value</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.time.DurationValue#getIntervalValue <em>Interval Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.core.time.TimePackage#getDurationValue()
 * @model annotation="GenModel documentation='From MARTE:\rA duration value is a time value that characterizes the time span of a time interval measured on its onClock clock. In the simple case when the clock has no defined maximalValue, the DurationValue of a TimeIntervalValue is defined by the difference between the max and min instant values of this time interval value. When the maximalValue property is defined, the DurationValue is defined as the difference modulo maximalValue between the max and min instant values of this time interval value.'"
 * @generated
 */
public interface DurationValue extends TimeValue {
	/**
	 * Returns the value of the '<em><b>Interval Value</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interval Value</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interval Value</em>' reference.
	 * @see #setIntervalValue(TimeIntervalValue)
	 * @see fr.supelec.modhelx.core.time.TimePackage#getDurationValue_IntervalValue()
	 * @model required="true"
	 * @generated
	 */
	TimeIntervalValue getIntervalValue();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.core.time.DurationValue#getIntervalValue <em>Interval Value</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interval Value</em>' reference.
	 * @see #getIntervalValue()
	 * @generated
	 */
	void setIntervalValue(TimeIntervalValue value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean equals(Object obj);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	int compareTo(TimeValue other);

} // DurationValue
