/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: InstantValue.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.time;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Instant Value</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.time.InstantValue#getDenotedInstant <em>Denoted Instant</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.core.time.TimePackage#getInstantValue()
 * @model annotation="GenModel documentation='From MARTE:\rAn instant value is a time value that denotes junction instants of the time base associated with its onClock clock. When the onClock clock has a maximal value, due to clock roll-over, an instant value may denote many instants.'"
 * @generated
 */
public interface InstantValue extends TimeValue {
	/**
	 * Returns the value of the '<em><b>Denoted Instant</b></em>' reference list.
	 * The list contents are of type {@link fr.supelec.modhelx.core.time.JunctionInstant}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Denoted Instant</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Denoted Instant</em>' reference list.
	 * @see fr.supelec.modhelx.core.time.TimePackage#getInstantValue_DenotedInstant()
	 * @model
	 * @generated
	 */
	EList<JunctionInstant> getDenotedInstant();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean equals(Object obj);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	int compareTo(TimeValue other);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	InstantValue add(DurationValue duration);

} // InstantValue
