/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: TimePackage.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.time;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.supelec.modhelx.core.time.TimeFactory
 * @model kind="package"
 * @generated
 */
public interface TimePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "time";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.supelec.fr/modhelx/2009/time";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "modhelx_time";

	/**
	 * The package content type ID.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eCONTENT_TYPE = "fr.supelec.modhelx.core.time";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	TimePackage eINSTANCE = fr.supelec.modhelx.core.time.impl.TimePackageImpl.init();

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.time.impl.TimeValueImpl <em>Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.time.impl.TimeValueImpl
	 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getTimeValue()
	 * @generated
	 */
	int TIME_VALUE = 0;

	/**
	 * The feature id for the '<em><b>On Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_VALUE__ON_CLOCK = 0;

	/**
	 * The number of structural features of the '<em>Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_VALUE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.time.impl.InstantValueImpl <em>Instant Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.time.impl.InstantValueImpl
	 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getInstantValue()
	 * @generated
	 */
	int INSTANT_VALUE = 1;

	/**
	 * The feature id for the '<em><b>On Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANT_VALUE__ON_CLOCK = TIME_VALUE__ON_CLOCK;

	/**
	 * The feature id for the '<em><b>Denoted Instant</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANT_VALUE__DENOTED_INSTANT = TIME_VALUE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Instant Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANT_VALUE_FEATURE_COUNT = TIME_VALUE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.time.impl.ClockImpl <em>Clock</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.time.impl.ClockImpl
	 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getClock()
	 * @generated
	 */
	int CLOCK = 2;

	/**
	 * The feature id for the '<em><b>Nature</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__NATURE = 0;

	/**
	 * The feature id for the '<em><b>Current Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__CURRENT_TIME = 1;

	/**
	 * The number of structural features of the '<em>Clock</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.time.impl.InstantImpl <em>Instant</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.time.impl.InstantImpl
	 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getInstant()
	 * @generated
	 */
	int INSTANT = 3;

	/**
	 * The feature id for the '<em><b>Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANT__DATE = 0;

	/**
	 * The number of structural features of the '<em>Instant</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANT_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.time.impl.LogicalClockImpl <em>Logical Clock</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.time.impl.LogicalClockImpl
	 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getLogicalClock()
	 * @generated
	 */
	int LOGICAL_CLOCK = 4;

	/**
	 * The feature id for the '<em><b>Nature</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOGICAL_CLOCK__NATURE = CLOCK__NATURE;

	/**
	 * The feature id for the '<em><b>Current Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOGICAL_CLOCK__CURRENT_TIME = CLOCK__CURRENT_TIME;

	/**
	 * The number of structural features of the '<em>Logical Clock</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOGICAL_CLOCK_FEATURE_COUNT = CLOCK_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.time.impl.DurationValueImpl <em>Duration Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.time.impl.DurationValueImpl
	 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getDurationValue()
	 * @generated
	 */
	int DURATION_VALUE = 5;

	/**
	 * The feature id for the '<em><b>On Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_VALUE__ON_CLOCK = TIME_VALUE__ON_CLOCK;

	/**
	 * The feature id for the '<em><b>Interval Value</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_VALUE__INTERVAL_VALUE = TIME_VALUE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Duration Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DURATION_VALUE_FEATURE_COUNT = TIME_VALUE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.time.impl.TimeIntervalValueImpl <em>Interval Value</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.time.impl.TimeIntervalValueImpl
	 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getTimeIntervalValue()
	 * @generated
	 */
	int TIME_INTERVAL_VALUE = 6;

	/**
	 * The feature id for the '<em><b>Min</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_INTERVAL_VALUE__MIN = 0;

	/**
	 * The feature id for the '<em><b>Max</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_INTERVAL_VALUE__MAX = 1;

	/**
	 * The feature id for the '<em><b>Is Min Open</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_INTERVAL_VALUE__IS_MIN_OPEN = 2;

	/**
	 * The feature id for the '<em><b>Is Max Open</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_INTERVAL_VALUE__IS_MAX_OPEN = 3;

	/**
	 * The number of structural features of the '<em>Interval Value</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_INTERVAL_VALUE_FEATURE_COUNT = 4;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.time.impl.JunctionInstantImpl <em>Junction Instant</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.time.impl.JunctionInstantImpl
	 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getJunctionInstant()
	 * @generated
	 */
	int JUNCTION_INSTANT = 7;

	/**
	 * The feature id for the '<em><b>Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JUNCTION_INSTANT__DATE = INSTANT__DATE;

	/**
	 * The number of structural features of the '<em>Junction Instant</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int JUNCTION_INSTANT_FEATURE_COUNT = INSTANT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.core.time.TimeNatureKind <em>Nature Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.core.time.TimeNatureKind
	 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getTimeNatureKind()
	 * @generated
	 */
	int TIME_NATURE_KIND = 8;


	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.time.TimeValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Value</em>'.
	 * @see fr.supelec.modhelx.core.time.TimeValue
	 * @generated
	 */
	EClass getTimeValue();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.modhelx.core.time.TimeValue#getOnClock <em>On Clock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>On Clock</em>'.
	 * @see fr.supelec.modhelx.core.time.TimeValue#getOnClock()
	 * @see #getTimeValue()
	 * @generated
	 */
	EReference getTimeValue_OnClock();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.time.InstantValue <em>Instant Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Instant Value</em>'.
	 * @see fr.supelec.modhelx.core.time.InstantValue
	 * @generated
	 */
	EClass getInstantValue();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.modhelx.core.time.InstantValue#getDenotedInstant <em>Denoted Instant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Denoted Instant</em>'.
	 * @see fr.supelec.modhelx.core.time.InstantValue#getDenotedInstant()
	 * @see #getInstantValue()
	 * @generated
	 */
	EReference getInstantValue_DenotedInstant();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.time.Clock <em>Clock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Clock</em>'.
	 * @see fr.supelec.modhelx.core.time.Clock
	 * @generated
	 */
	EClass getClock();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.core.time.Clock#getNature <em>Nature</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Nature</em>'.
	 * @see fr.supelec.modhelx.core.time.Clock#getNature()
	 * @see #getClock()
	 * @generated
	 */
	EAttribute getClock_Nature();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.core.time.Clock#getCurrentTime <em>Current Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Current Time</em>'.
	 * @see fr.supelec.modhelx.core.time.Clock#getCurrentTime()
	 * @see #getClock()
	 * @generated
	 */
	EAttribute getClock_CurrentTime();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.time.Instant <em>Instant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Instant</em>'.
	 * @see fr.supelec.modhelx.core.time.Instant
	 * @generated
	 */
	EClass getInstant();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.core.time.Instant#getDate <em>Date</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Date</em>'.
	 * @see fr.supelec.modhelx.core.time.Instant#getDate()
	 * @see #getInstant()
	 * @generated
	 */
	EAttribute getInstant_Date();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.time.LogicalClock <em>Logical Clock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Logical Clock</em>'.
	 * @see fr.supelec.modhelx.core.time.LogicalClock
	 * @generated
	 */
	EClass getLogicalClock();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.time.DurationValue <em>Duration Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Duration Value</em>'.
	 * @see fr.supelec.modhelx.core.time.DurationValue
	 * @generated
	 */
	EClass getDurationValue();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.modhelx.core.time.DurationValue#getIntervalValue <em>Interval Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Interval Value</em>'.
	 * @see fr.supelec.modhelx.core.time.DurationValue#getIntervalValue()
	 * @see #getDurationValue()
	 * @generated
	 */
	EReference getDurationValue_IntervalValue();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.time.TimeIntervalValue <em>Interval Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Interval Value</em>'.
	 * @see fr.supelec.modhelx.core.time.TimeIntervalValue
	 * @generated
	 */
	EClass getTimeIntervalValue();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.modhelx.core.time.TimeIntervalValue#getMin <em>Min</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Min</em>'.
	 * @see fr.supelec.modhelx.core.time.TimeIntervalValue#getMin()
	 * @see #getTimeIntervalValue()
	 * @generated
	 */
	EReference getTimeIntervalValue_Min();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.modhelx.core.time.TimeIntervalValue#getMax <em>Max</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Max</em>'.
	 * @see fr.supelec.modhelx.core.time.TimeIntervalValue#getMax()
	 * @see #getTimeIntervalValue()
	 * @generated
	 */
	EReference getTimeIntervalValue_Max();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.core.time.TimeIntervalValue#isMinOpen <em>Is Min Open</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Min Open</em>'.
	 * @see fr.supelec.modhelx.core.time.TimeIntervalValue#isMinOpen()
	 * @see #getTimeIntervalValue()
	 * @generated
	 */
	EAttribute getTimeIntervalValue_IsMinOpen();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.core.time.TimeIntervalValue#isMaxOpen <em>Is Max Open</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Max Open</em>'.
	 * @see fr.supelec.modhelx.core.time.TimeIntervalValue#isMaxOpen()
	 * @see #getTimeIntervalValue()
	 * @generated
	 */
	EAttribute getTimeIntervalValue_IsMaxOpen();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.core.time.JunctionInstant <em>Junction Instant</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Junction Instant</em>'.
	 * @see fr.supelec.modhelx.core.time.JunctionInstant
	 * @generated
	 */
	EClass getJunctionInstant();

	/**
	 * Returns the meta object for enum '{@link fr.supelec.modhelx.core.time.TimeNatureKind <em>Nature Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Nature Kind</em>'.
	 * @see fr.supelec.modhelx.core.time.TimeNatureKind
	 * @generated
	 */
	EEnum getTimeNatureKind();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	TimeFactory getTimeFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.time.impl.TimeValueImpl <em>Value</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.time.impl.TimeValueImpl
		 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getTimeValue()
		 * @generated
		 */
		EClass TIME_VALUE = eINSTANCE.getTimeValue();

		/**
		 * The meta object literal for the '<em><b>On Clock</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TIME_VALUE__ON_CLOCK = eINSTANCE.getTimeValue_OnClock();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.time.impl.InstantValueImpl <em>Instant Value</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.time.impl.InstantValueImpl
		 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getInstantValue()
		 * @generated
		 */
		EClass INSTANT_VALUE = eINSTANCE.getInstantValue();

		/**
		 * The meta object literal for the '<em><b>Denoted Instant</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INSTANT_VALUE__DENOTED_INSTANT = eINSTANCE.getInstantValue_DenotedInstant();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.time.impl.ClockImpl <em>Clock</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.time.impl.ClockImpl
		 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getClock()
		 * @generated
		 */
		EClass CLOCK = eINSTANCE.getClock();

		/**
		 * The meta object literal for the '<em><b>Nature</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CLOCK__NATURE = eINSTANCE.getClock_Nature();

		/**
		 * The meta object literal for the '<em><b>Current Time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CLOCK__CURRENT_TIME = eINSTANCE.getClock_CurrentTime();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.time.impl.InstantImpl <em>Instant</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.time.impl.InstantImpl
		 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getInstant()
		 * @generated
		 */
		EClass INSTANT = eINSTANCE.getInstant();

		/**
		 * The meta object literal for the '<em><b>Date</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INSTANT__DATE = eINSTANCE.getInstant_Date();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.time.impl.LogicalClockImpl <em>Logical Clock</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.time.impl.LogicalClockImpl
		 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getLogicalClock()
		 * @generated
		 */
		EClass LOGICAL_CLOCK = eINSTANCE.getLogicalClock();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.time.impl.DurationValueImpl <em>Duration Value</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.time.impl.DurationValueImpl
		 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getDurationValue()
		 * @generated
		 */
		EClass DURATION_VALUE = eINSTANCE.getDurationValue();

		/**
		 * The meta object literal for the '<em><b>Interval Value</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DURATION_VALUE__INTERVAL_VALUE = eINSTANCE.getDurationValue_IntervalValue();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.time.impl.TimeIntervalValueImpl <em>Interval Value</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.time.impl.TimeIntervalValueImpl
		 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getTimeIntervalValue()
		 * @generated
		 */
		EClass TIME_INTERVAL_VALUE = eINSTANCE.getTimeIntervalValue();

		/**
		 * The meta object literal for the '<em><b>Min</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TIME_INTERVAL_VALUE__MIN = eINSTANCE.getTimeIntervalValue_Min();

		/**
		 * The meta object literal for the '<em><b>Max</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TIME_INTERVAL_VALUE__MAX = eINSTANCE.getTimeIntervalValue_Max();

		/**
		 * The meta object literal for the '<em><b>Is Min Open</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TIME_INTERVAL_VALUE__IS_MIN_OPEN = eINSTANCE.getTimeIntervalValue_IsMinOpen();

		/**
		 * The meta object literal for the '<em><b>Is Max Open</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TIME_INTERVAL_VALUE__IS_MAX_OPEN = eINSTANCE.getTimeIntervalValue_IsMaxOpen();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.time.impl.JunctionInstantImpl <em>Junction Instant</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.time.impl.JunctionInstantImpl
		 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getJunctionInstant()
		 * @generated
		 */
		EClass JUNCTION_INSTANT = eINSTANCE.getJunctionInstant();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.core.time.TimeNatureKind <em>Nature Kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.core.time.TimeNatureKind
		 * @see fr.supelec.modhelx.core.time.impl.TimePackageImpl#getTimeNatureKind()
		 * @generated
		 */
		EEnum TIME_NATURE_KIND = eINSTANCE.getTimeNatureKind();

	}

} //TimePackage
