/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DurationValueImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.time.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import fr.supelec.modhelx.core.time.DurationValue;
import fr.supelec.modhelx.core.time.TimeIntervalValue;
import fr.supelec.modhelx.core.time.TimePackage;
import fr.supelec.modhelx.core.time.TimeValue;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Duration Value</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.time.impl.DurationValueImpl#getIntervalValue <em>Interval Value</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DurationValueImpl extends TimeValueImpl implements DurationValue {
	/**
	 * The cached value of the '{@link #getIntervalValue() <em>Interval Value</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIntervalValue()
	 * @generated
	 * @ordered
	 */
	protected TimeIntervalValue intervalValue;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DurationValueImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return TimePackage.Literals.DURATION_VALUE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeIntervalValue getIntervalValue() {
		if (intervalValue != null && intervalValue.eIsProxy()) {
			InternalEObject oldIntervalValue = (InternalEObject)intervalValue;
			intervalValue = (TimeIntervalValue)eResolveProxy(oldIntervalValue);
			if (intervalValue != oldIntervalValue) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TimePackage.DURATION_VALUE__INTERVAL_VALUE, oldIntervalValue, intervalValue));
			}
		}
		return intervalValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeIntervalValue basicGetIntervalValue() {
		return intervalValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIntervalValue(TimeIntervalValue newIntervalValue) {
		TimeIntervalValue oldIntervalValue = intervalValue;
		intervalValue = newIntervalValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TimePackage.DURATION_VALUE__INTERVAL_VALUE, oldIntervalValue, intervalValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean equals(Object obj) {
		try {
			DurationValue d = (DurationValue) obj;
			return compareTo(d) == 0;
		}
		catch (ClassCastException ex) {
			return false;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public int compareTo(TimeValue other) {
		DurationValue d = null;
		try {
			d = (DurationValue) other;
		}
		catch (ClassCastException ex) {
			throw new Error("DurationValue.compareTo : other is not an DurationValue");
		}
		
		if (getOnClock() != d.getOnClock()) {
			throw new Error("DurationValue.compareTo : differents clocks not yet supported");
		}
		
		// TODO
		return 0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case TimePackage.DURATION_VALUE__INTERVAL_VALUE:
				if (resolve) return getIntervalValue();
				return basicGetIntervalValue();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case TimePackage.DURATION_VALUE__INTERVAL_VALUE:
				setIntervalValue((TimeIntervalValue)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case TimePackage.DURATION_VALUE__INTERVAL_VALUE:
				setIntervalValue((TimeIntervalValue)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case TimePackage.DURATION_VALUE__INTERVAL_VALUE:
				return intervalValue != null;
		}
		return super.eIsSet(featureID);
	}

} //DurationValueImpl
