/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: InstantValueImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.time.impl;

import java.util.Collection;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import fr.supelec.modhelx.core.time.DurationValue;
import fr.supelec.modhelx.core.time.InstantValue;
import fr.supelec.modhelx.core.time.JunctionInstant;
import fr.supelec.modhelx.core.time.TimePackage;
import fr.supelec.modhelx.core.time.TimeValue;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Instant Value</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.time.impl.InstantValueImpl#getDenotedInstant <em>Denoted Instant</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class InstantValueImpl extends TimeValueImpl implements InstantValue {
	/**
	 * The cached value of the '{@link #getDenotedInstant() <em>Denoted Instant</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDenotedInstant()
	 * @generated
	 * @ordered
	 */
	protected EList<JunctionInstant> denotedInstant;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InstantValueImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return TimePackage.Literals.INSTANT_VALUE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<JunctionInstant> getDenotedInstant() {
		if (denotedInstant == null) {
			denotedInstant = new EObjectResolvingEList<JunctionInstant>(JunctionInstant.class, this, TimePackage.INSTANT_VALUE__DENOTED_INSTANT);
		}
		return denotedInstant;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean equals(Object obj) {
		try {
			InstantValue i = (InstantValue) obj;
			return compareTo(i) == 0;
		}
		catch (ClassCastException ex) {
			return false;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public int compareTo(TimeValue other) {
		InstantValue i = null;
		try {
			i = (InstantValue) other;
		}
		catch (ClassCastException ex) {
			throw new Error("InstantValue.compareTo : other is not an InstantValue");
		}
		
		if (getOnClock() != i.getOnClock()) {
			throw new Error("InstantValue.compareTo : differents clocks not yet supported -- InstantValue has clock " + getOnClock() + ", whereas other has clock " + other.getOnClock());
		}
		if (getDenotedInstant().size() != 1) {
			throw new Error("InstantValue.compareTo : several instants not yet supported");
		}
		if (i.getDenotedInstant().size() != 1) {
			throw new Error("InstantValue.compareTo : several instants not yet supported");
		}
		
		return getDenotedInstant().get(0).compareTo(i.getDenotedInstant().get(0));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public InstantValue add(DurationValue duration) {
		if (getOnClock() != duration.getOnClock()) {
			throw new Error("InstantValue.add: differents clocks not yet supported -- InstantValue has clock " + getOnClock() + ", whereas duration has clock " + duration.getOnClock());
		}
		if (getDenotedInstant().size() != 1) {
			throw new Error("InstantValue.add: several instants not yet supported");
		}
		if (duration.getIntervalValue().getMin().getDenotedInstant().size() != 1) {
			throw new Error("InstantValue.add: several instants not yet supported");
		}
		if (duration.getIntervalValue().getMax().getDenotedInstant().size() != 1) {
			throw new Error("InstantValue.add: several instants not yet supported");
		}
		
		double d = duration.getIntervalValue().getMax().getDenotedInstant().get(0).getDate()
	             - duration.getIntervalValue().getMin().getDenotedInstant().get(0).getDate();
		
		return getOnClock().createInstantValue(getDenotedInstant().get(0).getDate() + d);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case TimePackage.INSTANT_VALUE__DENOTED_INSTANT:
				return getDenotedInstant();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case TimePackage.INSTANT_VALUE__DENOTED_INSTANT:
				getDenotedInstant().clear();
				getDenotedInstant().addAll((Collection<? extends JunctionInstant>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case TimePackage.INSTANT_VALUE__DENOTED_INSTANT:
				getDenotedInstant().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case TimePackage.INSTANT_VALUE__DENOTED_INSTANT:
				return denotedInstant != null && !denotedInstant.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public String toString(){
		if (eIsProxy()) return super.toString();

		return "InstantValue(" + getDenotedInstant().get(0).getDate() + ")";
		/*
		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (DenotedInstants : ");
		result.append(this.getDenotedInstant().toString());
		result.append(')');
		return result.toString();*/
	}
	
} //InstantValueImpl
