/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: TimeIntervalValueImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.time.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import fr.supelec.modhelx.core.time.InstantValue;
import fr.supelec.modhelx.core.time.TimeIntervalValue;
import fr.supelec.modhelx.core.time.TimePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Interval Value</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.core.time.impl.TimeIntervalValueImpl#getMin <em>Min</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.time.impl.TimeIntervalValueImpl#getMax <em>Max</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.time.impl.TimeIntervalValueImpl#isMinOpen <em>Is Min Open</em>}</li>
 *   <li>{@link fr.supelec.modhelx.core.time.impl.TimeIntervalValueImpl#isMaxOpen <em>Is Max Open</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TimeIntervalValueImpl extends EObjectImpl implements TimeIntervalValue {
	/**
	 * The cached value of the '{@link #getMin() <em>Min</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMin()
	 * @generated
	 * @ordered
	 */
	protected InstantValue min;

	/**
	 * The cached value of the '{@link #getMax() <em>Max</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMax()
	 * @generated
	 * @ordered
	 */
	protected InstantValue max;

	/**
	 * The default value of the '{@link #isMinOpen() <em>Is Min Open</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isMinOpen()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_MIN_OPEN_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isMinOpen() <em>Is Min Open</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isMinOpen()
	 * @generated
	 * @ordered
	 */
	protected boolean isMinOpen = IS_MIN_OPEN_EDEFAULT;

	/**
	 * The default value of the '{@link #isMaxOpen() <em>Is Max Open</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isMaxOpen()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_MAX_OPEN_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isMaxOpen() <em>Is Max Open</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isMaxOpen()
	 * @generated
	 * @ordered
	 */
	protected boolean isMaxOpen = IS_MAX_OPEN_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TimeIntervalValueImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return TimePackage.Literals.TIME_INTERVAL_VALUE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InstantValue getMin() {
		if (min != null && min.eIsProxy()) {
			InternalEObject oldMin = (InternalEObject)min;
			min = (InstantValue)eResolveProxy(oldMin);
			if (min != oldMin) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TimePackage.TIME_INTERVAL_VALUE__MIN, oldMin, min));
			}
		}
		return min;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InstantValue basicGetMin() {
		return min;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMin(InstantValue newMin) {
		InstantValue oldMin = min;
		min = newMin;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TimePackage.TIME_INTERVAL_VALUE__MIN, oldMin, min));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InstantValue getMax() {
		if (max != null && max.eIsProxy()) {
			InternalEObject oldMax = (InternalEObject)max;
			max = (InstantValue)eResolveProxy(oldMax);
			if (max != oldMax) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TimePackage.TIME_INTERVAL_VALUE__MAX, oldMax, max));
			}
		}
		return max;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InstantValue basicGetMax() {
		return max;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMax(InstantValue newMax) {
		InstantValue oldMax = max;
		max = newMax;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TimePackage.TIME_INTERVAL_VALUE__MAX, oldMax, max));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isMinOpen() {
		return isMinOpen;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsMinOpen(boolean newIsMinOpen) {
		boolean oldIsMinOpen = isMinOpen;
		isMinOpen = newIsMinOpen;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TimePackage.TIME_INTERVAL_VALUE__IS_MIN_OPEN, oldIsMinOpen, isMinOpen));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isMaxOpen() {
		return isMaxOpen;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsMaxOpen(boolean newIsMaxOpen) {
		boolean oldIsMaxOpen = isMaxOpen;
		isMaxOpen = newIsMaxOpen;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TimePackage.TIME_INTERVAL_VALUE__IS_MAX_OPEN, oldIsMaxOpen, isMaxOpen));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case TimePackage.TIME_INTERVAL_VALUE__MIN:
				if (resolve) return getMin();
				return basicGetMin();
			case TimePackage.TIME_INTERVAL_VALUE__MAX:
				if (resolve) return getMax();
				return basicGetMax();
			case TimePackage.TIME_INTERVAL_VALUE__IS_MIN_OPEN:
				return isMinOpen();
			case TimePackage.TIME_INTERVAL_VALUE__IS_MAX_OPEN:
				return isMaxOpen();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case TimePackage.TIME_INTERVAL_VALUE__MIN:
				setMin((InstantValue)newValue);
				return;
			case TimePackage.TIME_INTERVAL_VALUE__MAX:
				setMax((InstantValue)newValue);
				return;
			case TimePackage.TIME_INTERVAL_VALUE__IS_MIN_OPEN:
				setIsMinOpen((Boolean)newValue);
				return;
			case TimePackage.TIME_INTERVAL_VALUE__IS_MAX_OPEN:
				setIsMaxOpen((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case TimePackage.TIME_INTERVAL_VALUE__MIN:
				setMin((InstantValue)null);
				return;
			case TimePackage.TIME_INTERVAL_VALUE__MAX:
				setMax((InstantValue)null);
				return;
			case TimePackage.TIME_INTERVAL_VALUE__IS_MIN_OPEN:
				setIsMinOpen(IS_MIN_OPEN_EDEFAULT);
				return;
			case TimePackage.TIME_INTERVAL_VALUE__IS_MAX_OPEN:
				setIsMaxOpen(IS_MAX_OPEN_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case TimePackage.TIME_INTERVAL_VALUE__MIN:
				return min != null;
			case TimePackage.TIME_INTERVAL_VALUE__MAX:
				return max != null;
			case TimePackage.TIME_INTERVAL_VALUE__IS_MIN_OPEN:
				return isMinOpen != IS_MIN_OPEN_EDEFAULT;
			case TimePackage.TIME_INTERVAL_VALUE__IS_MAX_OPEN:
				return isMaxOpen != IS_MAX_OPEN_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (isMinOpen: ");
		result.append(isMinOpen);
		result.append(", isMaxOpen: ");
		result.append(isMaxOpen);
		result.append(')');
		return result.toString();
	}

} //TimeIntervalValueImpl
