/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: TimePackageImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.core.time.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import fr.supelec.modhelx.core.CorePackage;
import fr.supelec.modhelx.core.impl.CorePackageImpl;
import fr.supelec.modhelx.core.java.JavaPackage;
import fr.supelec.modhelx.core.java.impl.JavaPackageImpl;
import fr.supelec.modhelx.core.time.Clock;
import fr.supelec.modhelx.core.time.DurationValue;
import fr.supelec.modhelx.core.time.Instant;
import fr.supelec.modhelx.core.time.InstantValue;
import fr.supelec.modhelx.core.time.JunctionInstant;
import fr.supelec.modhelx.core.time.LogicalClock;
import fr.supelec.modhelx.core.time.TimeFactory;
import fr.supelec.modhelx.core.time.TimeIntervalValue;
import fr.supelec.modhelx.core.time.TimeNatureKind;
import fr.supelec.modhelx.core.time.TimePackage;
import fr.supelec.modhelx.core.time.TimeValue;
import fr.supelec.modhelx.corelib.CorelibPackage;
import fr.supelec.modhelx.corelib.impl.CorelibPackageImpl;
import fr.supelec.modhelx.mocs.adapterlib.AdapterlibPackage;
import fr.supelec.modhelx.mocs.adapterlib.impl.AdapterlibPackageImpl;
import fr.supelec.modhelx.mocs.autosar.AutosarPackage;
import fr.supelec.modhelx.mocs.autosar.impl.AutosarPackageImpl;
import fr.supelec.modhelx.mocs.de.DePackage;
import fr.supelec.modhelx.mocs.de.impl.DePackageImpl;
import fr.supelec.modhelx.mocs.delib.DelibPackage;
import fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl;
import fr.supelec.modhelx.mocs.fsm.FsmPackage;
import fr.supelec.modhelx.mocs.fsm.impl.FsmPackageImpl;
import fr.supelec.modhelx.mocs.fsmlib.FsmlibPackage;
import fr.supelec.modhelx.mocs.fsmlib.impl.FsmlibPackageImpl;
import fr.supelec.modhelx.mocs.petrinet.PetrinetPackage;
import fr.supelec.modhelx.mocs.petrinet.impl.PetrinetPackageImpl;
import fr.supelec.modhelx.mocs.polymoclib.PolymoclibPackage;
import fr.supelec.modhelx.mocs.polymoclib.impl.PolymoclibPackageImpl;
import fr.supelec.modhelx.mocs.sdf.SdfPackage;
import fr.supelec.modhelx.mocs.sdf.impl.SdfPackageImpl;
import fr.supelec.modhelx.mocs.sdflib.SdflibPackage;
import fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl;
import fr.supelec.modhelx.mocs.simple.SimplePackage;
import fr.supelec.modhelx.mocs.simple.impl.SimplePackageImpl;
import fr.supelec.modhelx.mocs.tfsm.TfsmPackage;
import fr.supelec.modhelx.mocs.tfsm.impl.TfsmPackageImpl;
import fr.supelec.modhelx.mocs.tfsmlib.TfsmlibPackage;
import fr.supelec.modhelx.mocs.tfsmlib.impl.TfsmlibPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class TimePackageImpl extends EPackageImpl implements TimePackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass timeValueEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass instantValueEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass clockEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass instantEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass logicalClockEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass durationValueEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass timeIntervalValueEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass junctionInstantEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum timeNatureKindEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see fr.supelec.modhelx.core.time.TimePackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private TimePackageImpl() {
		super(eNS_URI, TimeFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link TimePackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static TimePackage init() {
		if (isInited) return (TimePackage)EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI);

		// Obtain or create and register package
		TimePackageImpl theTimePackage = (TimePackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof TimePackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new TimePackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		CorePackageImpl theCorePackage = (CorePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI) instanceof CorePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI) : CorePackage.eINSTANCE);
		JavaPackageImpl theJavaPackage = (JavaPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(JavaPackage.eNS_URI) instanceof JavaPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(JavaPackage.eNS_URI) : JavaPackage.eINSTANCE);
		DePackageImpl theDePackage = (DePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(DePackage.eNS_URI) instanceof DePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(DePackage.eNS_URI) : DePackage.eINSTANCE);
		SimplePackageImpl theSimplePackage = (SimplePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SimplePackage.eNS_URI) instanceof SimplePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SimplePackage.eNS_URI) : SimplePackage.eINSTANCE);
		DelibPackageImpl theDelibPackage = (DelibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(DelibPackage.eNS_URI) instanceof DelibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(DelibPackage.eNS_URI) : DelibPackage.eINSTANCE);
		FsmPackageImpl theFsmPackage = (FsmPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FsmPackage.eNS_URI) instanceof FsmPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FsmPackage.eNS_URI) : FsmPackage.eINSTANCE);
		FsmlibPackageImpl theFsmlibPackage = (FsmlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FsmlibPackage.eNS_URI) instanceof FsmlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FsmlibPackage.eNS_URI) : FsmlibPackage.eINSTANCE);
		AdapterlibPackageImpl theAdapterlibPackage = (AdapterlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AdapterlibPackage.eNS_URI) instanceof AdapterlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AdapterlibPackage.eNS_URI) : AdapterlibPackage.eINSTANCE);
		SdfPackageImpl theSdfPackage = (SdfPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SdfPackage.eNS_URI) instanceof SdfPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SdfPackage.eNS_URI) : SdfPackage.eINSTANCE);
		SdflibPackageImpl theSdflibPackage = (SdflibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SdflibPackage.eNS_URI) instanceof SdflibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SdflibPackage.eNS_URI) : SdflibPackage.eINSTANCE);
		PetrinetPackageImpl thePetrinetPackage = (PetrinetPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PetrinetPackage.eNS_URI) instanceof PetrinetPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PetrinetPackage.eNS_URI) : PetrinetPackage.eINSTANCE);
		PolymoclibPackageImpl thePolymoclibPackage = (PolymoclibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PolymoclibPackage.eNS_URI) instanceof PolymoclibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PolymoclibPackage.eNS_URI) : PolymoclibPackage.eINSTANCE);
		AutosarPackageImpl theAutosarPackage = (AutosarPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) instanceof AutosarPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) : AutosarPackage.eINSTANCE);
		TfsmPackageImpl theTfsmPackage = (TfsmPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TfsmPackage.eNS_URI) instanceof TfsmPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TfsmPackage.eNS_URI) : TfsmPackage.eINSTANCE);
		TfsmlibPackageImpl theTfsmlibPackage = (TfsmlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TfsmlibPackage.eNS_URI) instanceof TfsmlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TfsmlibPackage.eNS_URI) : TfsmlibPackage.eINSTANCE);
		CorelibPackageImpl theCorelibPackage = (CorelibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CorelibPackage.eNS_URI) instanceof CorelibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CorelibPackage.eNS_URI) : CorelibPackage.eINSTANCE);

		// Create package meta-data objects
		theTimePackage.createPackageContents();
		theCorePackage.createPackageContents();
		theJavaPackage.createPackageContents();
		theDePackage.createPackageContents();
		theSimplePackage.createPackageContents();
		theDelibPackage.createPackageContents();
		theFsmPackage.createPackageContents();
		theFsmlibPackage.createPackageContents();
		theAdapterlibPackage.createPackageContents();
		theSdfPackage.createPackageContents();
		theSdflibPackage.createPackageContents();
		thePetrinetPackage.createPackageContents();
		thePolymoclibPackage.createPackageContents();
		theAutosarPackage.createPackageContents();
		theTfsmPackage.createPackageContents();
		theTfsmlibPackage.createPackageContents();
		theCorelibPackage.createPackageContents();

		// Initialize created meta-data
		theTimePackage.initializePackageContents();
		theCorePackage.initializePackageContents();
		theJavaPackage.initializePackageContents();
		theDePackage.initializePackageContents();
		theSimplePackage.initializePackageContents();
		theDelibPackage.initializePackageContents();
		theFsmPackage.initializePackageContents();
		theFsmlibPackage.initializePackageContents();
		theAdapterlibPackage.initializePackageContents();
		theSdfPackage.initializePackageContents();
		theSdflibPackage.initializePackageContents();
		thePetrinetPackage.initializePackageContents();
		thePolymoclibPackage.initializePackageContents();
		theAutosarPackage.initializePackageContents();
		theTfsmPackage.initializePackageContents();
		theTfsmlibPackage.initializePackageContents();
		theCorelibPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theTimePackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(TimePackage.eNS_URI, theTimePackage);
		return theTimePackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTimeValue() {
		return timeValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTimeValue_OnClock() {
		return (EReference)timeValueEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInstantValue() {
		return instantValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getInstantValue_DenotedInstant() {
		return (EReference)instantValueEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getClock() {
		return clockEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getClock_Nature() {
		return (EAttribute)clockEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getClock_CurrentTime() {
		return (EAttribute)clockEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInstant() {
		return instantEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getInstant_Date() {
		return (EAttribute)instantEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLogicalClock() {
		return logicalClockEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDurationValue() {
		return durationValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDurationValue_IntervalValue() {
		return (EReference)durationValueEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTimeIntervalValue() {
		return timeIntervalValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTimeIntervalValue_Min() {
		return (EReference)timeIntervalValueEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTimeIntervalValue_Max() {
		return (EReference)timeIntervalValueEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTimeIntervalValue_IsMinOpen() {
		return (EAttribute)timeIntervalValueEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTimeIntervalValue_IsMaxOpen() {
		return (EAttribute)timeIntervalValueEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getJunctionInstant() {
		return junctionInstantEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getTimeNatureKind() {
		return timeNatureKindEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeFactory getTimeFactory() {
		return (TimeFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		timeValueEClass = createEClass(TIME_VALUE);
		createEReference(timeValueEClass, TIME_VALUE__ON_CLOCK);

		instantValueEClass = createEClass(INSTANT_VALUE);
		createEReference(instantValueEClass, INSTANT_VALUE__DENOTED_INSTANT);

		clockEClass = createEClass(CLOCK);
		createEAttribute(clockEClass, CLOCK__NATURE);
		createEAttribute(clockEClass, CLOCK__CURRENT_TIME);

		instantEClass = createEClass(INSTANT);
		createEAttribute(instantEClass, INSTANT__DATE);

		logicalClockEClass = createEClass(LOGICAL_CLOCK);

		durationValueEClass = createEClass(DURATION_VALUE);
		createEReference(durationValueEClass, DURATION_VALUE__INTERVAL_VALUE);

		timeIntervalValueEClass = createEClass(TIME_INTERVAL_VALUE);
		createEReference(timeIntervalValueEClass, TIME_INTERVAL_VALUE__MIN);
		createEReference(timeIntervalValueEClass, TIME_INTERVAL_VALUE__MAX);
		createEAttribute(timeIntervalValueEClass, TIME_INTERVAL_VALUE__IS_MIN_OPEN);
		createEAttribute(timeIntervalValueEClass, TIME_INTERVAL_VALUE__IS_MAX_OPEN);

		junctionInstantEClass = createEClass(JUNCTION_INSTANT);

		// Create enums
		timeNatureKindEEnum = createEEnum(TIME_NATURE_KIND);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		instantValueEClass.getESuperTypes().add(this.getTimeValue());
		logicalClockEClass.getESuperTypes().add(this.getClock());
		durationValueEClass.getESuperTypes().add(this.getTimeValue());
		junctionInstantEClass.getESuperTypes().add(this.getInstant());

		// Initialize classes and features; add operations and parameters
		initEClass(timeValueEClass, TimeValue.class, "TimeValue", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTimeValue_OnClock(), this.getClock(), null, "onClock", null, 1, 1, TimeValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		EOperation op = addEOperation(timeValueEClass, ecorePackage.getEBoolean(), "equals", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEJavaObject(), "obj", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(timeValueEClass, ecorePackage.getEInt(), "compareTo", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getTimeValue(), "other", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(instantValueEClass, InstantValue.class, "InstantValue", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getInstantValue_DenotedInstant(), this.getJunctionInstant(), null, "denotedInstant", null, 0, -1, InstantValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(instantValueEClass, ecorePackage.getEBoolean(), "equals", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEJavaObject(), "obj", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(instantValueEClass, ecorePackage.getEInt(), "compareTo", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getTimeValue(), "other", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(instantValueEClass, this.getInstantValue(), "add", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getDurationValue(), "duration", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(clockEClass, Clock.class, "Clock", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getClock_Nature(), this.getTimeNatureKind(), "nature", null, 0, 1, Clock.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getClock_CurrentTime(), ecorePackage.getEDouble(), "currentTime", null, 0, 1, Clock.class, !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(clockEClass, this.getDurationValue(), "createDurationValue", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getInstantValue(), "min", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getInstantValue(), "max", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(clockEClass, this.getInstantValue(), "createInstantValue", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "date", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(instantEClass, Instant.class, "Instant", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getInstant_Date(), ecorePackage.getEDouble(), "date", null, 0, 1, Instant.class, !IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(instantEClass, ecorePackage.getEInt(), "compareTo", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getInstant(), "other", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(instantEClass, ecorePackage.getEBoolean(), "equals", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEJavaObject(), "obj", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(logicalClockEClass, LogicalClock.class, "LogicalClock", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		addEOperation(logicalClockEClass, this.getInstantValue(), "createInstantValue", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(logicalClockEClass, this.getInstantValue(), "createInstantValue", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "date", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(durationValueEClass, DurationValue.class, "DurationValue", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDurationValue_IntervalValue(), this.getTimeIntervalValue(), null, "intervalValue", null, 1, 1, DurationValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(durationValueEClass, ecorePackage.getEBoolean(), "equals", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEJavaObject(), "obj", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(durationValueEClass, ecorePackage.getEInt(), "compareTo", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getTimeValue(), "other", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(timeIntervalValueEClass, TimeIntervalValue.class, "TimeIntervalValue", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getTimeIntervalValue_Min(), this.getInstantValue(), null, "min", null, 1, 1, TimeIntervalValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTimeIntervalValue_Max(), this.getInstantValue(), null, "max", null, 1, 1, TimeIntervalValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTimeIntervalValue_IsMinOpen(), ecorePackage.getEBoolean(), "isMinOpen", "false", 1, 1, TimeIntervalValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTimeIntervalValue_IsMaxOpen(), ecorePackage.getEBoolean(), "isMaxOpen", "false", 1, 1, TimeIntervalValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(junctionInstantEClass, JunctionInstant.class, "JunctionInstant", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(junctionInstantEClass, ecorePackage.getEBoolean(), "equals", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEJavaObject(), "obj", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(junctionInstantEClass, ecorePackage.getEInt(), "compareTo", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getInstant(), "other", 0, 1, IS_UNIQUE, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(timeNatureKindEEnum, TimeNatureKind.class, "TimeNatureKind");
		addEEnumLiteral(timeNatureKindEEnum, TimeNatureKind.DISCRETE);
		addEEnumLiteral(timeNatureKindEEnum, TimeNatureKind.DENSE);

		// Create annotations
		// GenModel
		createGenModelAnnotations();
	}

	/**
	 * Initializes the annotations for <b>GenModel</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createGenModelAnnotations() {
		String source = "GenModel";		
		addAnnotation
		  (timeValueEClass, 
		   source, 
		   new String[] {
			 "documentation", "From MARTE:\rTimeValue is an abstract class for expressing instant values and duration values. Time values are related to a clock."
		   });		
		addAnnotation
		  (timeNatureKindEEnum, 
		   source, 
		   new String[] {
			 "documentation", "From MARTE:\rTimeNatureKind is an enumeration type that defines literals used to specify the nature discrete or dense of a time base or \na time value."
		   });		
		addAnnotation
		  (instantValueEClass, 
		   source, 
		   new String[] {
			 "documentation", "From MARTE:\rAn instant value is a time value that denotes junction instants of the time base associated with its onClock clock. When the onClock clock has a maximal value, due to clock roll-over, an instant value may denote many instants."
		   });		
		addAnnotation
		  (clockEClass, 
		   source, 
		   new String[] {
			 "documentation", "From MARTE:\rA clock provides access to a discrete time base, and possibly to a dense time base, but through a discrete time base. The instants of this time base correspond to \"ticks\" of the clock. A clock associates time values with instants of the time base. \nThese values may be from a discrete or a dense set of values. \nA Clock accepts units (acceptedUnits property). Unit is defined in the NFP_Nature package. One of these accepted units is the defaultUnit, which is attached to the currentTime value. \nClock is an abstract class."
		   });		
		addAnnotation
		  (instantEClass, 
		   source, 
		   new String[] {
			 "documentation", "From MARTE:\rAn instant represents a point in time. It is owned by a time base in which it occupies a unique position with respect to the other instants of this time base."
		   });		
		addAnnotation
		  (logicalClockEClass, 
		   source, 
		   new String[] {
			 "documentation", "From MARTE:\rA logical clock provides access to a logical time, that is, a model of time in which only the ordering of instants is meaningful. There is no implicit reference to the physical time. Logical clocks are often used in conjunction with a time structure model accessible through its timeBase property. A logical clock can also be defined by any event (its definingEvent). In this case, the logical clock ticks at each occurrence of this event."
		   });		
		addAnnotation
		  (durationValueEClass, 
		   source, 
		   new String[] {
			 "documentation", "From MARTE:\rA duration value is a time value that characterizes the time span of a time interval measured on its onClock clock. In the simple case when the clock has no defined maximalValue, the DurationValue of a TimeIntervalValue is defined by the difference between the max and min instant values of this time interval value. When the maximalValue property is defined, the DurationValue is defined as the difference modulo maximalValue between the max and min instant values of this time interval value."
		   });		
		addAnnotation
		  (timeIntervalValueEClass, 
		   source, 
		   new String[] {
			 "documentation", "From MARTE:\rA time interval value is a set of instants values specified by a pair of instant values. A time interval value denotes 0 or many time intervals in the time base associated with the onClock clock of its bounds. When the onClock clock has a maximal value, due to clock roll-over, a time interval value may denote many time intervals.\rWhen used in a time value specification, a time interval value designates any time value of the interval (including or not the bound values according to the isMinOpen et isMaxOpen attribute values)."
		   });		
		addAnnotation
		  (junctionInstantEClass, 
		   source, 
		   new String[] {
			 "documentation", "From MARTE:\rA junction instant represents a point in time. All instants owned by a discrete time base are junction instants. Some instants of a dense time base may be junction instants"
		   });
	}

} //TimePackageImpl
