package fr.supelec.modhelx.engine.instrumentation;

import java.util.HashMap;
import java.util.Map;

import fr.supelec.modhelx.core.ModelOfComputation;

public abstract class Controller {
	private Map<ModelOfComputation, Map<String, Object>> internalData =
		new HashMap<ModelOfComputation, Map<String, Object>>();
	
	public abstract void enterMethod(Object callee, String methodName, Object ... params);
	public abstract void leaveMethod(Object ... returnValues);
	public abstract void beginSnapshot(int number);
	public abstract void endSnapshot();
	
	public void changeMoCInternalData(ModelOfComputation moc,  String variableName, Object variableValue) {
		Map<String, Object> mocMap = internalData.get(moc);
		if(mocMap == null) {
			mocMap = new HashMap<String, Object>();
			internalData.put(moc, mocMap);
		}
		mocMap.put(variableName, variableValue);
	}

	public Object getInternalMoCVariable(ModelOfComputation moc, String variableName) {
		Map<String, Object> mocMap = internalData.get(moc);
		if(mocMap == null) return null;
		return mocMap.get(variableName);
	}
}
