/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: AdapterlibFactory.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.adapterlib;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see fr.supelec.modhelx.mocs.adapterlib.AdapterlibPackage
 * @generated
 */
public interface AdapterlibFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	AdapterlibFactory eINSTANCE = fr.supelec.modhelx.mocs.adapterlib.impl.AdapterlibFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>De Fsm Adapter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Fsm Adapter</em>'.
	 * @generated
	 */
	DeFsmAdapter createDeFsmAdapter();

	/**
	 * Returns a new object of class '<em>De Sdf Adapter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Sdf Adapter</em>'.
	 * @generated
	 */
	DeSdfAdapter createDeSdfAdapter();

	/**
	 * Returns a new object of class '<em>De Tfsm Adapter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Tfsm Adapter</em>'.
	 * @generated
	 */
	DeTfsmAdapter createDeTfsmAdapter();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	AdapterlibPackage getAdapterlibPackage();

} //AdapterlibFactory
