/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: AdapterlibPackage.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.adapterlib;

import fr.supelec.modhelx.core.CorePackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.supelec.modhelx.mocs.adapterlib.AdapterlibFactory
 * @model kind="package"
 * @generated
 */
public interface AdapterlibPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "adapterlib";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.supelec.fr/modhelx/2009/adapterlib";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "modhelx_adapterlib";

	/**
	 * The package content type ID.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eCONTENT_TYPE = "fr.supelec.modhelx.mocs.adapterlib";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	AdapterlibPackage eINSTANCE = fr.supelec.modhelx.mocs.adapterlib.impl.AdapterlibPackageImpl.init();

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.adapterlib.impl.DeFsmAdapterImpl <em>De Fsm Adapter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.adapterlib.impl.DeFsmAdapterImpl
	 * @see fr.supelec.modhelx.mocs.adapterlib.impl.AdapterlibPackageImpl#getDeFsmAdapter()
	 * @generated
	 */
	int DE_FSM_ADAPTER = 0;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_FSM_ADAPTER__PARAMETERS = CorePackage.INTERFACE_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_FSM_ADAPTER__PINS_IN = CorePackage.INTERFACE_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_FSM_ADAPTER__PINS_OUT = CorePackage.INTERFACE_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_FSM_ADAPTER__NAME = CorePackage.INTERFACE_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_FSM_ADAPTER__CONTAINER = CorePackage.INTERFACE_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Internal Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_FSM_ADAPTER__INTERNAL_MODEL = CorePackage.INTERFACE_BLOCK__INTERNAL_MODEL;

	/**
	 * The feature id for the '<em><b>Relations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_FSM_ADAPTER__RELATIONS = CorePackage.INTERFACE_BLOCK__RELATIONS;

	/**
	 * The feature id for the '<em><b>Preparation Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_FSM_ADAPTER__PREPARATION_TIME = CorePackage.INTERFACE_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>De Fsm Adapter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_FSM_ADAPTER_FEATURE_COUNT = CorePackage.INTERFACE_BLOCK_FEATURE_COUNT + 1;


	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.adapterlib.impl.DeSdfAdapterImpl <em>De Sdf Adapter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.adapterlib.impl.DeSdfAdapterImpl
	 * @see fr.supelec.modhelx.mocs.adapterlib.impl.AdapterlibPackageImpl#getDeSdfAdapter()
	 * @generated
	 */
	int DE_SDF_ADAPTER = 1;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SDF_ADAPTER__PARAMETERS = CorePackage.INTERFACE_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SDF_ADAPTER__PINS_IN = CorePackage.INTERFACE_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SDF_ADAPTER__PINS_OUT = CorePackage.INTERFACE_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SDF_ADAPTER__NAME = CorePackage.INTERFACE_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SDF_ADAPTER__CONTAINER = CorePackage.INTERFACE_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Internal Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SDF_ADAPTER__INTERNAL_MODEL = CorePackage.INTERFACE_BLOCK__INTERNAL_MODEL;

	/**
	 * The feature id for the '<em><b>Relations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SDF_ADAPTER__RELATIONS = CorePackage.INTERFACE_BLOCK__RELATIONS;

	/**
	 * The feature id for the '<em><b>Sample Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SDF_ADAPTER__SAMPLE_TIME = CorePackage.INTERFACE_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>De Sdf Adapter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SDF_ADAPTER_FEATURE_COUNT = CorePackage.INTERFACE_BLOCK_FEATURE_COUNT + 1;


	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.adapterlib.impl.DeTfsmAdapterImpl <em>De Tfsm Adapter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.adapterlib.impl.DeTfsmAdapterImpl
	 * @see fr.supelec.modhelx.mocs.adapterlib.impl.AdapterlibPackageImpl#getDeTfsmAdapter()
	 * @generated
	 */
	int DE_TFSM_ADAPTER = 2;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_TFSM_ADAPTER__PARAMETERS = CorePackage.INTERFACE_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_TFSM_ADAPTER__PINS_IN = CorePackage.INTERFACE_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_TFSM_ADAPTER__PINS_OUT = CorePackage.INTERFACE_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_TFSM_ADAPTER__NAME = CorePackage.INTERFACE_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_TFSM_ADAPTER__CONTAINER = CorePackage.INTERFACE_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Internal Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_TFSM_ADAPTER__INTERNAL_MODEL = CorePackage.INTERFACE_BLOCK__INTERNAL_MODEL;

	/**
	 * The feature id for the '<em><b>Relations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_TFSM_ADAPTER__RELATIONS = CorePackage.INTERFACE_BLOCK__RELATIONS;

	/**
	 * The number of structural features of the '<em>De Tfsm Adapter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_TFSM_ADAPTER_FEATURE_COUNT = CorePackage.INTERFACE_BLOCK_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.adapterlib.DeFsmAdapter <em>De Fsm Adapter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Fsm Adapter</em>'.
	 * @see fr.supelec.modhelx.mocs.adapterlib.DeFsmAdapter
	 * @generated
	 */
	EClass getDeFsmAdapter();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.adapterlib.DeFsmAdapter#getPreparationTime <em>Preparation Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Preparation Time</em>'.
	 * @see fr.supelec.modhelx.mocs.adapterlib.DeFsmAdapter#getPreparationTime()
	 * @see #getDeFsmAdapter()
	 * @generated
	 */
	EAttribute getDeFsmAdapter_PreparationTime();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.adapterlib.DeSdfAdapter <em>De Sdf Adapter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Sdf Adapter</em>'.
	 * @see fr.supelec.modhelx.mocs.adapterlib.DeSdfAdapter
	 * @generated
	 */
	EClass getDeSdfAdapter();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.adapterlib.DeSdfAdapter#getSampleTime <em>Sample Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Sample Time</em>'.
	 * @see fr.supelec.modhelx.mocs.adapterlib.DeSdfAdapter#getSampleTime()
	 * @see #getDeSdfAdapter()
	 * @generated
	 */
	EAttribute getDeSdfAdapter_SampleTime();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.adapterlib.DeTfsmAdapter <em>De Tfsm Adapter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Tfsm Adapter</em>'.
	 * @see fr.supelec.modhelx.mocs.adapterlib.DeTfsmAdapter
	 * @generated
	 */
	EClass getDeTfsmAdapter();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	AdapterlibFactory getAdapterlibFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.adapterlib.impl.DeFsmAdapterImpl <em>De Fsm Adapter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.adapterlib.impl.DeFsmAdapterImpl
		 * @see fr.supelec.modhelx.mocs.adapterlib.impl.AdapterlibPackageImpl#getDeFsmAdapter()
		 * @generated
		 */
		EClass DE_FSM_ADAPTER = eINSTANCE.getDeFsmAdapter();
		/**
		 * The meta object literal for the '<em><b>Preparation Time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_FSM_ADAPTER__PREPARATION_TIME = eINSTANCE.getDeFsmAdapter_PreparationTime();
		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.adapterlib.impl.DeSdfAdapterImpl <em>De Sdf Adapter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.adapterlib.impl.DeSdfAdapterImpl
		 * @see fr.supelec.modhelx.mocs.adapterlib.impl.AdapterlibPackageImpl#getDeSdfAdapter()
		 * @generated
		 */
		EClass DE_SDF_ADAPTER = eINSTANCE.getDeSdfAdapter();
		/**
		 * The meta object literal for the '<em><b>Sample Time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_SDF_ADAPTER__SAMPLE_TIME = eINSTANCE.getDeSdfAdapter_SampleTime();
		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.adapterlib.impl.DeTfsmAdapterImpl <em>De Tfsm Adapter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.adapterlib.impl.DeTfsmAdapterImpl
		 * @see fr.supelec.modhelx.mocs.adapterlib.impl.AdapterlibPackageImpl#getDeTfsmAdapter()
		 * @generated
		 */
		EClass DE_TFSM_ADAPTER = eINSTANCE.getDeTfsmAdapter();

	}

} //AdapterlibPackage
