/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DeFsmAdapter.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.adapterlib;

import fr.supelec.modhelx.core.InterfaceBlock;
import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.time.InstantValue;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>De Fsm Adapter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.adapterlib.DeFsmAdapter#getPreparationTime <em>Preparation Time</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.mocs.adapterlib.AdapterlibPackage#getDeFsmAdapter()
 * @model
 * @generated
 */
public interface DeFsmAdapter extends InterfaceBlock {

	/**
	 * Returns the value of the '<em><b>Preparation Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Preparation Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Preparation Time</em>' attribute.
	 * @see #setPreparationTime(int)
	 * @see fr.supelec.modhelx.mocs.adapterlib.AdapterlibPackage#getDeFsmAdapter_PreparationTime()
	 * @model transient="true" volatile="true" derived="true"
	 * @generated
	 */
	int getPreparationTime();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.adapterlib.DeFsmAdapter#getPreparationTime <em>Preparation Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Preparation Time</em>' attribute.
	 * @see #getPreparationTime()
	 * @generated
	 */
	void setPreparationTime(int value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void adaptIn(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void adaptOut(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void setup(ModelOfComputation moc, InstantValue initialTime);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	Pin createCoinPin();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	Pin createCoffeePin();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	Pin createServedPin();
} // DeFsmAdapter
