/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DeSdfAdapter.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.adapterlib;

import fr.supelec.modhelx.core.InterfaceBlock;
import fr.supelec.modhelx.core.ModelOfComputation;

import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.time.InstantValue;
import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>De Sdf Adapter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.adapterlib.DeSdfAdapter#getSampleTime <em>Sample Time</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.mocs.adapterlib.AdapterlibPackage#getDeSdfAdapter()
 * @model
 * @generated
 */
public interface DeSdfAdapter extends InterfaceBlock {
	/**
	 * Returns the value of the '<em><b>Sample Time</b></em>' attribute.
	 * The default value is <code>"-1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sample Time</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Sample Time</em>' attribute.
	 * @see #setSampleTime(int)
	 * @see fr.supelec.modhelx.mocs.adapterlib.AdapterlibPackage#getDeSdfAdapter_SampleTime()
	 * @model default="-1" required="true" volatile="true" derived="true"
	 * @generated
	 */
	int getSampleTime();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.adapterlib.DeSdfAdapter#getSampleTime <em>Sample Time</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sample Time</em>' attribute.
	 * @see #getSampleTime()
	 * @generated
	 */
	void setSampleTime(int value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void adaptIn(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void adaptOut(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void setup(ModelOfComputation moc, InstantValue initialTime);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model timeConstraintsMany="true"
	 * @generated
	 */
	void collectTimeConstraints(ModelOfComputation moc, EList<InstantValue> timeConstraints);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model pinRequired="true" valueRequired="true"
	 * @generated
	 */
	void setInitialValue(Pin pin, Object value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model pinRequired="true"
	 * @generated
	 */
	Object getInitialValue(Pin pin);

} // DeSdfAdapter
