/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: AdapterlibPackageImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.adapterlib.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import fr.supelec.modhelx.core.CorePackage;
import fr.supelec.modhelx.core.impl.CorePackageImpl;
import fr.supelec.modhelx.core.java.JavaPackage;
import fr.supelec.modhelx.core.java.impl.JavaPackageImpl;
import fr.supelec.modhelx.core.time.TimePackage;
import fr.supelec.modhelx.core.time.impl.TimePackageImpl;
import fr.supelec.modhelx.corelib.CorelibPackage;
import fr.supelec.modhelx.corelib.impl.CorelibPackageImpl;
import fr.supelec.modhelx.mocs.adapterlib.AdapterlibFactory;
import fr.supelec.modhelx.mocs.adapterlib.AdapterlibPackage;
import fr.supelec.modhelx.mocs.adapterlib.DeFsmAdapter;
import fr.supelec.modhelx.mocs.adapterlib.DeSdfAdapter;
import fr.supelec.modhelx.mocs.adapterlib.DeTfsmAdapter;
import fr.supelec.modhelx.mocs.autosar.AutosarPackage;
import fr.supelec.modhelx.mocs.autosar.impl.AutosarPackageImpl;
import fr.supelec.modhelx.mocs.de.DePackage;
import fr.supelec.modhelx.mocs.de.impl.DePackageImpl;
import fr.supelec.modhelx.mocs.delib.DelibPackage;
import fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl;
import fr.supelec.modhelx.mocs.fsm.FsmPackage;
import fr.supelec.modhelx.mocs.fsm.impl.FsmPackageImpl;
import fr.supelec.modhelx.mocs.fsmlib.FsmlibPackage;
import fr.supelec.modhelx.mocs.fsmlib.impl.FsmlibPackageImpl;
import fr.supelec.modhelx.mocs.petrinet.PetrinetPackage;
import fr.supelec.modhelx.mocs.petrinet.impl.PetrinetPackageImpl;
import fr.supelec.modhelx.mocs.polymoclib.PolymoclibPackage;
import fr.supelec.modhelx.mocs.polymoclib.impl.PolymoclibPackageImpl;
import fr.supelec.modhelx.mocs.sdf.SdfPackage;
import fr.supelec.modhelx.mocs.sdf.impl.SdfPackageImpl;
import fr.supelec.modhelx.mocs.sdflib.SdflibPackage;
import fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl;
import fr.supelec.modhelx.mocs.simple.SimplePackage;
import fr.supelec.modhelx.mocs.simple.impl.SimplePackageImpl;
import fr.supelec.modhelx.mocs.tfsm.TfsmPackage;
import fr.supelec.modhelx.mocs.tfsm.impl.TfsmPackageImpl;
import fr.supelec.modhelx.mocs.tfsmlib.TfsmlibPackage;
import fr.supelec.modhelx.mocs.tfsmlib.impl.TfsmlibPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class AdapterlibPackageImpl extends EPackageImpl implements AdapterlibPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deFsmAdapterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deSdfAdapterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deTfsmAdapterEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see fr.supelec.modhelx.mocs.adapterlib.AdapterlibPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private AdapterlibPackageImpl() {
		super(eNS_URI, AdapterlibFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link AdapterlibPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static AdapterlibPackage init() {
		if (isInited) return (AdapterlibPackage)EPackage.Registry.INSTANCE.getEPackage(AdapterlibPackage.eNS_URI);

		// Obtain or create and register package
		AdapterlibPackageImpl theAdapterlibPackage = (AdapterlibPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof AdapterlibPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new AdapterlibPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		CorePackageImpl theCorePackage = (CorePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI) instanceof CorePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI) : CorePackage.eINSTANCE);
		TimePackageImpl theTimePackage = (TimePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI) instanceof TimePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI) : TimePackage.eINSTANCE);
		JavaPackageImpl theJavaPackage = (JavaPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(JavaPackage.eNS_URI) instanceof JavaPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(JavaPackage.eNS_URI) : JavaPackage.eINSTANCE);
		DePackageImpl theDePackage = (DePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(DePackage.eNS_URI) instanceof DePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(DePackage.eNS_URI) : DePackage.eINSTANCE);
		SimplePackageImpl theSimplePackage = (SimplePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SimplePackage.eNS_URI) instanceof SimplePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SimplePackage.eNS_URI) : SimplePackage.eINSTANCE);
		DelibPackageImpl theDelibPackage = (DelibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(DelibPackage.eNS_URI) instanceof DelibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(DelibPackage.eNS_URI) : DelibPackage.eINSTANCE);
		FsmPackageImpl theFsmPackage = (FsmPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FsmPackage.eNS_URI) instanceof FsmPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FsmPackage.eNS_URI) : FsmPackage.eINSTANCE);
		FsmlibPackageImpl theFsmlibPackage = (FsmlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FsmlibPackage.eNS_URI) instanceof FsmlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FsmlibPackage.eNS_URI) : FsmlibPackage.eINSTANCE);
		SdfPackageImpl theSdfPackage = (SdfPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SdfPackage.eNS_URI) instanceof SdfPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SdfPackage.eNS_URI) : SdfPackage.eINSTANCE);
		SdflibPackageImpl theSdflibPackage = (SdflibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SdflibPackage.eNS_URI) instanceof SdflibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SdflibPackage.eNS_URI) : SdflibPackage.eINSTANCE);
		PetrinetPackageImpl thePetrinetPackage = (PetrinetPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PetrinetPackage.eNS_URI) instanceof PetrinetPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PetrinetPackage.eNS_URI) : PetrinetPackage.eINSTANCE);
		PolymoclibPackageImpl thePolymoclibPackage = (PolymoclibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PolymoclibPackage.eNS_URI) instanceof PolymoclibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PolymoclibPackage.eNS_URI) : PolymoclibPackage.eINSTANCE);
		AutosarPackageImpl theAutosarPackage = (AutosarPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) instanceof AutosarPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) : AutosarPackage.eINSTANCE);
		TfsmPackageImpl theTfsmPackage = (TfsmPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TfsmPackage.eNS_URI) instanceof TfsmPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TfsmPackage.eNS_URI) : TfsmPackage.eINSTANCE);
		TfsmlibPackageImpl theTfsmlibPackage = (TfsmlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TfsmlibPackage.eNS_URI) instanceof TfsmlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TfsmlibPackage.eNS_URI) : TfsmlibPackage.eINSTANCE);
		CorelibPackageImpl theCorelibPackage = (CorelibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CorelibPackage.eNS_URI) instanceof CorelibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CorelibPackage.eNS_URI) : CorelibPackage.eINSTANCE);

		// Create package meta-data objects
		theAdapterlibPackage.createPackageContents();
		theCorePackage.createPackageContents();
		theTimePackage.createPackageContents();
		theJavaPackage.createPackageContents();
		theDePackage.createPackageContents();
		theSimplePackage.createPackageContents();
		theDelibPackage.createPackageContents();
		theFsmPackage.createPackageContents();
		theFsmlibPackage.createPackageContents();
		theSdfPackage.createPackageContents();
		theSdflibPackage.createPackageContents();
		thePetrinetPackage.createPackageContents();
		thePolymoclibPackage.createPackageContents();
		theAutosarPackage.createPackageContents();
		theTfsmPackage.createPackageContents();
		theTfsmlibPackage.createPackageContents();
		theCorelibPackage.createPackageContents();

		// Initialize created meta-data
		theAdapterlibPackage.initializePackageContents();
		theCorePackage.initializePackageContents();
		theTimePackage.initializePackageContents();
		theJavaPackage.initializePackageContents();
		theDePackage.initializePackageContents();
		theSimplePackage.initializePackageContents();
		theDelibPackage.initializePackageContents();
		theFsmPackage.initializePackageContents();
		theFsmlibPackage.initializePackageContents();
		theSdfPackage.initializePackageContents();
		theSdflibPackage.initializePackageContents();
		thePetrinetPackage.initializePackageContents();
		thePolymoclibPackage.initializePackageContents();
		theAutosarPackage.initializePackageContents();
		theTfsmPackage.initializePackageContents();
		theTfsmlibPackage.initializePackageContents();
		theCorelibPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theAdapterlibPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(AdapterlibPackage.eNS_URI, theAdapterlibPackage);
		return theAdapterlibPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeFsmAdapter() {
		return deFsmAdapterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeFsmAdapter_PreparationTime() {
		return (EAttribute)deFsmAdapterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeSdfAdapter() {
		return deSdfAdapterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeSdfAdapter_SampleTime() {
		return (EAttribute)deSdfAdapterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeTfsmAdapter() {
		return deTfsmAdapterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdapterlibFactory getAdapterlibFactory() {
		return (AdapterlibFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		deFsmAdapterEClass = createEClass(DE_FSM_ADAPTER);
		createEAttribute(deFsmAdapterEClass, DE_FSM_ADAPTER__PREPARATION_TIME);

		deSdfAdapterEClass = createEClass(DE_SDF_ADAPTER);
		createEAttribute(deSdfAdapterEClass, DE_SDF_ADAPTER__SAMPLE_TIME);

		deTfsmAdapterEClass = createEClass(DE_TFSM_ADAPTER);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		CorePackage theCorePackage = (CorePackage)EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI);
		TimePackage theTimePackage = (TimePackage)EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		deFsmAdapterEClass.getESuperTypes().add(theCorePackage.getInterfaceBlock());
		deSdfAdapterEClass.getESuperTypes().add(theCorePackage.getInterfaceBlock());
		deTfsmAdapterEClass.getESuperTypes().add(theCorePackage.getInterfaceBlock());

		// Initialize classes and features; add operations and parameters
		initEClass(deFsmAdapterEClass, DeFsmAdapter.class, "DeFsmAdapter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeFsmAdapter_PreparationTime(), ecorePackage.getEInt(), "preparationTime", null, 0, 1, DeFsmAdapter.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		EOperation op = addEOperation(deFsmAdapterEClass, null, "adaptIn", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deFsmAdapterEClass, null, "adaptOut", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deFsmAdapterEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(deFsmAdapterEClass, theCorePackage.getPin(), "createCoinPin", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(deFsmAdapterEClass, theCorePackage.getPin(), "createCoffeePin", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(deFsmAdapterEClass, theCorePackage.getPin(), "createServedPin", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(deSdfAdapterEClass, DeSdfAdapter.class, "DeSdfAdapter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeSdfAdapter_SampleTime(), ecorePackage.getEInt(), "sampleTime", "-1", 1, 1, DeSdfAdapter.class, !IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		op = addEOperation(deSdfAdapterEClass, null, "adaptIn", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deSdfAdapterEClass, null, "adaptOut", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deSdfAdapterEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deSdfAdapterEClass, null, "collectTimeConstraints", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "timeConstraints", 0, -1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deSdfAdapterEClass, null, "setInitialValue", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEJavaObject(), "value", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deSdfAdapterEClass, ecorePackage.getEJavaObject(), "getInitialValue", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(deTfsmAdapterEClass, DeTfsmAdapter.class, "DeTfsmAdapter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(deTfsmAdapterEClass, null, "adaptIn", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deTfsmAdapterEClass, null, "adaptOut", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deTfsmAdapterEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deTfsmAdapterEClass, null, "collectTimeConstraints", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "timeConstraints", 0, -1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deTfsmAdapterEClass, null, "setValueAssociatedWithInterfaceRelation", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getRelation(), "relation", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEJavaObject(), "value", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deTfsmAdapterEClass, null, "setIgnoredValuesOnPin", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 0, 1, IS_UNIQUE, IS_ORDERED);
		EGenericType g1 = createEGenericType(ecorePackage.getEEList());
		EGenericType g2 = createEGenericType(ecorePackage.getEJavaObject());
		g1.getETypeArguments().add(g2);
		addEParameter(op, g1, "value", 0, 1, IS_UNIQUE, IS_ORDERED);

		// Create resource
		createResource(eNS_URI);
	}

} //AdapterlibPackageImpl
