/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DeCoffeeMachineUser.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.delib;

import org.eclipse.emf.common.util.EList;

import fr.supelec.modhelx.core.AtomicBlock;
import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.time.InstantValue;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>De Coffee Machine User</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUser#getFirstTimeOfEmit <em>First Time Of Emit</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.mocs.delib.DelibPackage#getDeCoffeeMachineUser()
 * @model
 * @generated
 */
public interface DeCoffeeMachineUser extends AtomicBlock {
	/**
	 * Returns the value of the '<em><b>First Time Of Emit</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>First Time Of Emit</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>First Time Of Emit</em>' attribute.
	 * @see #setFirstTimeOfEmit(int)
	 * @see fr.supelec.modhelx.mocs.delib.DelibPackage#getDeCoffeeMachineUser_FirstTimeOfEmit()
	 * @model default="0" transient="true" volatile="true" derived="true"
	 * @generated
	 */
	int getFirstTimeOfEmit();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUser#getFirstTimeOfEmit <em>First Time Of Emit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>First Time Of Emit</em>' attribute.
	 * @see #getFirstTimeOfEmit()
	 * @generated
	 */
	void setFirstTimeOfEmit(int value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void update(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void setup(ModelOfComputation moc, InstantValue initialTime);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model timeConstraintsMany="true"
	 * @generated
	 */
	void collectTimeConstraints(ModelOfComputation moc, EList<InstantValue> timeConstraints);

} // DeCoffeeMachineUser
