/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DeEventPrinter.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.delib;

import fr.supelec.modhelx.core.AtomicBlock;
import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.time.InstantValue;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>De Event Printer</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.delib.DeEventPrinter#getPrintStream <em>Print Stream</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.mocs.delib.DelibPackage#getDeEventPrinter()
 * @model
 * @generated
 */
public interface DeEventPrinter extends AtomicBlock {

	/**
	 * Returns the value of the '<em><b>Print Stream</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Print Stream</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Print Stream</em>' attribute.
	 * @see #setPrintStream(Object)
	 * @see fr.supelec.modhelx.mocs.delib.DelibPackage#getDeEventPrinter_PrintStream()
	 * @model transient="true"
	 * @generated
	 */
	Object getPrintStream();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.delib.DeEventPrinter#getPrintStream <em>Print Stream</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Print Stream</em>' attribute.
	 * @see #getPrintStream()
	 * @generated
	 */
	void setPrintStream(Object value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void update(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void setup(ModelOfComputation moc, InstantValue initialTime);
} // DeEventPrinter
