/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DeRampEmitter.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.delib;

import fr.supelec.modhelx.core.AtomicBlock;
import fr.supelec.modhelx.core.ModelOfComputation;

import fr.supelec.modhelx.core.time.InstantValue;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>De Ramp Emitter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter#getInitialValueToEmit <em>Initial Value To Emit</em>}</li>
 *   <li>{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter#getTimeStep <em>Time Step</em>}</li>
 *   <li>{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter#getFirstTimeOfEmit <em>First Time Of Emit</em>}</li>
 *   <li>{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter#getIncrement <em>Increment</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.mocs.delib.DelibPackage#getDeRampEmitter()
 * @model
 * @generated
 */
public interface DeRampEmitter extends AtomicBlock {
	/**
	 * Returns the value of the '<em><b>Initial Value To Emit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Initial Value To Emit</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Initial Value To Emit</em>' attribute.
	 * @see #setInitialValueToEmit(Object)
	 * @see fr.supelec.modhelx.mocs.delib.DelibPackage#getDeRampEmitter_InitialValueToEmit()
	 * @model transient="true" volatile="true" derived="true"
	 * @generated
	 */
	Object getInitialValueToEmit();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter#getInitialValueToEmit <em>Initial Value To Emit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Initial Value To Emit</em>' attribute.
	 * @see #getInitialValueToEmit()
	 * @generated
	 */
	void setInitialValueToEmit(Object value);

	/**
	 * Returns the value of the '<em><b>Time Step</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Time Step</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Time Step</em>' attribute.
	 * @see #setTimeStep(int)
	 * @see fr.supelec.modhelx.mocs.delib.DelibPackage#getDeRampEmitter_TimeStep()
	 * @model default="1" transient="true" volatile="true" derived="true"
	 * @generated
	 */
	int getTimeStep();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter#getTimeStep <em>Time Step</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Time Step</em>' attribute.
	 * @see #getTimeStep()
	 * @generated
	 */
	void setTimeStep(int value);

	/**
	 * Returns the value of the '<em><b>First Time Of Emit</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>First Time Of Emit</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>First Time Of Emit</em>' attribute.
	 * @see #setFirstTimeOfEmit(int)
	 * @see fr.supelec.modhelx.mocs.delib.DelibPackage#getDeRampEmitter_FirstTimeOfEmit()
	 * @model default="0" transient="true" volatile="true" derived="true"
	 * @generated
	 */
	int getFirstTimeOfEmit();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter#getFirstTimeOfEmit <em>First Time Of Emit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>First Time Of Emit</em>' attribute.
	 * @see #getFirstTimeOfEmit()
	 * @generated
	 */
	void setFirstTimeOfEmit(int value);

	/**
	 * Returns the value of the '<em><b>Increment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Increment</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Increment</em>' attribute.
	 * @see #setIncrement(Object)
	 * @see fr.supelec.modhelx.mocs.delib.DelibPackage#getDeRampEmitter_Increment()
	 * @model
	 * @generated
	 */
	Object getIncrement();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter#getIncrement <em>Increment</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Increment</em>' attribute.
	 * @see #getIncrement()
	 * @generated
	 */
	void setIncrement(Object value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model timeConstraintsMany="true"
	 * @generated
	 */
	void collectTimeConstraints(ModelOfComputation moc, EList<InstantValue> timeConstraints);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void update(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void setup(ModelOfComputation moc, InstantValue initialTime);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void endOfSnapshot(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean newSnap(ModelOfComputation moc);

} // DeRampEmitter
