/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DelibFactory.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.delib;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see fr.supelec.modhelx.mocs.delib.DelibPackage
 * @generated
 */
public interface DelibFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	DelibFactory eINSTANCE = fr.supelec.modhelx.mocs.delib.impl.DelibFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>De Ramp Emitter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Ramp Emitter</em>'.
	 * @generated
	 */
	DeRampEmitter createDeRampEmitter();

	/**
	 * Returns a new object of class '<em>De Duplicator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Duplicator</em>'.
	 * @generated
	 */
	DeDuplicator createDeDuplicator();

	/**
	 * Returns a new object of class '<em>De Adder</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Adder</em>'.
	 * @generated
	 */
	DeAdder createDeAdder();

	/**
	 * Returns a new object of class '<em>De Event Printer</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Event Printer</em>'.
	 * @generated
	 */
	DeEventPrinter createDeEventPrinter();

	/**
	 * Returns a new object of class '<em>De Delay</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Delay</em>'.
	 * @generated
	 */
	DeDelay createDeDelay();

	/**
	 * Returns a new object of class '<em>De Coffee Machine User</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Coffee Machine User</em>'.
	 * @generated
	 */
	DeCoffeeMachineUser createDeCoffeeMachineUser();

	/**
	 * Returns a new object of class '<em>De Coffee Machine User Without Input</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Coffee Machine User Without Input</em>'.
	 * @generated
	 */
	DeCoffeeMachineUserWithoutInput createDeCoffeeMachineUserWithoutInput();

	/**
	 * Returns a new object of class '<em>De Constant Emitter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Constant Emitter</em>'.
	 * @generated
	 */
	DeConstantEmitter createDeConstantEmitter();

	/**
	 * Returns a new object of class '<em>De Scenario Player</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Scenario Player</em>'.
	 * @generated
	 */
	DeScenarioPlayer createDeScenarioPlayer();

	/**
	 * Returns a new object of class '<em>De Scenario Event</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>De Scenario Event</em>'.
	 * @generated
	 */
	DeScenarioEvent createDeScenarioEvent();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	DelibPackage getDelibPackage();

} //DelibFactory
