/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DelibPackage.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.delib;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.EReference;
import fr.supelec.modhelx.core.CorePackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.supelec.modhelx.mocs.delib.DelibFactory
 * @model kind="package"
 * @generated
 */
public interface DelibPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "delib";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.supelec.fr/modhelx/2009/delib";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "modhelx_delib";

	/**
	 * The package content type ID.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eCONTENT_TYPE = "fr.supelec.modhelx.mocs.delib";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	DelibPackage eINSTANCE = fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl.init();

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeRampEmitterImpl <em>De Ramp Emitter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.delib.impl.DeRampEmitterImpl
	 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeRampEmitter()
	 * @generated
	 */
	int DE_RAMP_EMITTER = 0;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_RAMP_EMITTER__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_RAMP_EMITTER__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_RAMP_EMITTER__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_RAMP_EMITTER__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_RAMP_EMITTER__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Initial Value To Emit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_RAMP_EMITTER__INITIAL_VALUE_TO_EMIT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Time Step</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_RAMP_EMITTER__TIME_STEP = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>First Time Of Emit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_RAMP_EMITTER__FIRST_TIME_OF_EMIT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Increment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_RAMP_EMITTER__INCREMENT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>De Ramp Emitter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_RAMP_EMITTER_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeDuplicatorImpl <em>De Duplicator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.delib.impl.DeDuplicatorImpl
	 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeDuplicator()
	 * @generated
	 */
	int DE_DUPLICATOR = 1;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DUPLICATOR__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DUPLICATOR__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DUPLICATOR__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DUPLICATOR__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DUPLICATOR__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The number of structural features of the '<em>De Duplicator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DUPLICATOR_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeAdderImpl <em>De Adder</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.delib.impl.DeAdderImpl
	 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeAdder()
	 * @generated
	 */
	int DE_ADDER = 2;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_ADDER__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_ADDER__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_ADDER__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_ADDER__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_ADDER__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The number of structural features of the '<em>De Adder</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_ADDER_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeEventPrinterImpl <em>De Event Printer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.delib.impl.DeEventPrinterImpl
	 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeEventPrinter()
	 * @generated
	 */
	int DE_EVENT_PRINTER = 3;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_EVENT_PRINTER__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_EVENT_PRINTER__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_EVENT_PRINTER__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_EVENT_PRINTER__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_EVENT_PRINTER__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Print Stream</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_EVENT_PRINTER__PRINT_STREAM = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>De Event Printer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_EVENT_PRINTER_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;


	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeDelayImpl <em>De Delay</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.delib.impl.DeDelayImpl
	 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeDelay()
	 * @generated
	 */
	int DE_DELAY = 4;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DELAY__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DELAY__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DELAY__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DELAY__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DELAY__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Time Delay</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DELAY__TIME_DELAY = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>De Delay</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_DELAY_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;


	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeCoffeeMachineUserImpl <em>De Coffee Machine User</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.delib.impl.DeCoffeeMachineUserImpl
	 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeCoffeeMachineUser()
	 * @generated
	 */
	int DE_COFFEE_MACHINE_USER = 5;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>First Time Of Emit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER__FIRST_TIME_OF_EMIT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>De Coffee Machine User</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeCoffeeMachineUserWithoutInputImpl <em>De Coffee Machine User Without Input</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.delib.impl.DeCoffeeMachineUserWithoutInputImpl
	 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeCoffeeMachineUserWithoutInput()
	 * @generated
	 */
	int DE_COFFEE_MACHINE_USER_WITHOUT_INPUT = 6;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER_WITHOUT_INPUT__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER_WITHOUT_INPUT__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER_WITHOUT_INPUT__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER_WITHOUT_INPUT__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER_WITHOUT_INPUT__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Time Between Coin And Coffee</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER_WITHOUT_INPUT__TIME_BETWEEN_COIN_AND_COFFEE = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>De Coffee Machine User Without Input</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_COFFEE_MACHINE_USER_WITHOUT_INPUT_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeConstantEmitterImpl <em>De Constant Emitter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.delib.impl.DeConstantEmitterImpl
	 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeConstantEmitter()
	 * @generated
	 */
	int DE_CONSTANT_EMITTER = 7;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_CONSTANT_EMITTER__PARAMETERS = DE_RAMP_EMITTER__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_CONSTANT_EMITTER__PINS_IN = DE_RAMP_EMITTER__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_CONSTANT_EMITTER__PINS_OUT = DE_RAMP_EMITTER__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_CONSTANT_EMITTER__NAME = DE_RAMP_EMITTER__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_CONSTANT_EMITTER__CONTAINER = DE_RAMP_EMITTER__CONTAINER;

	/**
	 * The feature id for the '<em><b>Initial Value To Emit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_CONSTANT_EMITTER__INITIAL_VALUE_TO_EMIT = DE_RAMP_EMITTER__INITIAL_VALUE_TO_EMIT;

	/**
	 * The feature id for the '<em><b>Time Step</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_CONSTANT_EMITTER__TIME_STEP = DE_RAMP_EMITTER__TIME_STEP;

	/**
	 * The feature id for the '<em><b>First Time Of Emit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_CONSTANT_EMITTER__FIRST_TIME_OF_EMIT = DE_RAMP_EMITTER__FIRST_TIME_OF_EMIT;

	/**
	 * The feature id for the '<em><b>Increment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_CONSTANT_EMITTER__INCREMENT = DE_RAMP_EMITTER__INCREMENT;

	/**
	 * The feature id for the '<em><b>Value To Emit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_CONSTANT_EMITTER__VALUE_TO_EMIT = DE_RAMP_EMITTER_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>De Constant Emitter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_CONSTANT_EMITTER_FEATURE_COUNT = DE_RAMP_EMITTER_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeScenarioPlayerImpl <em>De Scenario Player</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.delib.impl.DeScenarioPlayerImpl
	 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeScenarioPlayer()
	 * @generated
	 */
	int DE_SCENARIO_PLAYER = 8;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SCENARIO_PLAYER__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SCENARIO_PLAYER__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SCENARIO_PLAYER__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SCENARIO_PLAYER__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SCENARIO_PLAYER__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Events</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SCENARIO_PLAYER__EVENTS = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>De Scenario Player</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SCENARIO_PLAYER_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeScenarioEventImpl <em>De Scenario Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.delib.impl.DeScenarioEventImpl
	 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeScenarioEvent()
	 * @generated
	 */
	int DE_SCENARIO_EVENT = 9;

	/**
	 * The feature id for the '<em><b>Time</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SCENARIO_EVENT__TIME = 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SCENARIO_EVENT__VALUE = 1;

	/**
	 * The feature id for the '<em><b>Pin</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SCENARIO_EVENT__PIN = 2;

	/**
	 * The number of structural features of the '<em>De Scenario Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DE_SCENARIO_EVENT_FEATURE_COUNT = 3;

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter <em>De Ramp Emitter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Ramp Emitter</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeRampEmitter
	 * @generated
	 */
	EClass getDeRampEmitter();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter#getInitialValueToEmit <em>Initial Value To Emit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Initial Value To Emit</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeRampEmitter#getInitialValueToEmit()
	 * @see #getDeRampEmitter()
	 * @generated
	 */
	EAttribute getDeRampEmitter_InitialValueToEmit();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter#getTimeStep <em>Time Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Time Step</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeRampEmitter#getTimeStep()
	 * @see #getDeRampEmitter()
	 * @generated
	 */
	EAttribute getDeRampEmitter_TimeStep();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter#getFirstTimeOfEmit <em>First Time Of Emit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>First Time Of Emit</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeRampEmitter#getFirstTimeOfEmit()
	 * @see #getDeRampEmitter()
	 * @generated
	 */
	EAttribute getDeRampEmitter_FirstTimeOfEmit();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.delib.DeRampEmitter#getIncrement <em>Increment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Increment</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeRampEmitter#getIncrement()
	 * @see #getDeRampEmitter()
	 * @generated
	 */
	EAttribute getDeRampEmitter_Increment();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.delib.DeDuplicator <em>De Duplicator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Duplicator</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeDuplicator
	 * @generated
	 */
	EClass getDeDuplicator();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.delib.DeAdder <em>De Adder</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Adder</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeAdder
	 * @generated
	 */
	EClass getDeAdder();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.delib.DeEventPrinter <em>De Event Printer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Event Printer</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeEventPrinter
	 * @generated
	 */
	EClass getDeEventPrinter();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.delib.DeEventPrinter#getPrintStream <em>Print Stream</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Print Stream</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeEventPrinter#getPrintStream()
	 * @see #getDeEventPrinter()
	 * @generated
	 */
	EAttribute getDeEventPrinter_PrintStream();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.delib.DeDelay <em>De Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Delay</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeDelay
	 * @generated
	 */
	EClass getDeDelay();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.delib.DeDelay#getTimeDelay <em>Time Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Time Delay</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeDelay#getTimeDelay()
	 * @see #getDeDelay()
	 * @generated
	 */
	EAttribute getDeDelay_TimeDelay();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUser <em>De Coffee Machine User</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Coffee Machine User</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUser
	 * @generated
	 */
	EClass getDeCoffeeMachineUser();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUser#getFirstTimeOfEmit <em>First Time Of Emit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>First Time Of Emit</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUser#getFirstTimeOfEmit()
	 * @see #getDeCoffeeMachineUser()
	 * @generated
	 */
	EAttribute getDeCoffeeMachineUser_FirstTimeOfEmit();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUserWithoutInput <em>De Coffee Machine User Without Input</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Coffee Machine User Without Input</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUserWithoutInput
	 * @generated
	 */
	EClass getDeCoffeeMachineUserWithoutInput();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUserWithoutInput#getTimeBetweenCoinAndCoffee <em>Time Between Coin And Coffee</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Time Between Coin And Coffee</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUserWithoutInput#getTimeBetweenCoinAndCoffee()
	 * @see #getDeCoffeeMachineUserWithoutInput()
	 * @generated
	 */
	EAttribute getDeCoffeeMachineUserWithoutInput_TimeBetweenCoinAndCoffee();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.delib.DeConstantEmitter <em>De Constant Emitter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Constant Emitter</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeConstantEmitter
	 * @generated
	 */
	EClass getDeConstantEmitter();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.delib.DeConstantEmitter#getValueToEmit <em>Value To Emit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value To Emit</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeConstantEmitter#getValueToEmit()
	 * @see #getDeConstantEmitter()
	 * @generated
	 */
	EAttribute getDeConstantEmitter_ValueToEmit();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.delib.DeScenarioPlayer <em>De Scenario Player</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Scenario Player</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeScenarioPlayer
	 * @generated
	 */
	EClass getDeScenarioPlayer();

	/**
	 * Returns the meta object for the reference list '{@link fr.supelec.modhelx.mocs.delib.DeScenarioPlayer#getEvents <em>Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Events</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeScenarioPlayer#getEvents()
	 * @see #getDeScenarioPlayer()
	 * @generated
	 */
	EReference getDeScenarioPlayer_Events();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.delib.DeScenarioEvent <em>De Scenario Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>De Scenario Event</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeScenarioEvent
	 * @generated
	 */
	EClass getDeScenarioEvent();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.delib.DeScenarioEvent#getTime <em>Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Time</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeScenarioEvent#getTime()
	 * @see #getDeScenarioEvent()
	 * @generated
	 */
	EAttribute getDeScenarioEvent_Time();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.delib.DeScenarioEvent#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeScenarioEvent#getValue()
	 * @see #getDeScenarioEvent()
	 * @generated
	 */
	EAttribute getDeScenarioEvent_Value();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.modhelx.mocs.delib.DeScenarioEvent#getPin <em>Pin</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Pin</em>'.
	 * @see fr.supelec.modhelx.mocs.delib.DeScenarioEvent#getPin()
	 * @see #getDeScenarioEvent()
	 * @generated
	 */
	EReference getDeScenarioEvent_Pin();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	DelibFactory getDelibFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeRampEmitterImpl <em>De Ramp Emitter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.delib.impl.DeRampEmitterImpl
		 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeRampEmitter()
		 * @generated
		 */
		EClass DE_RAMP_EMITTER = eINSTANCE.getDeRampEmitter();

		/**
		 * The meta object literal for the '<em><b>Initial Value To Emit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_RAMP_EMITTER__INITIAL_VALUE_TO_EMIT = eINSTANCE.getDeRampEmitter_InitialValueToEmit();

		/**
		 * The meta object literal for the '<em><b>Time Step</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_RAMP_EMITTER__TIME_STEP = eINSTANCE.getDeRampEmitter_TimeStep();

		/**
		 * The meta object literal for the '<em><b>First Time Of Emit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_RAMP_EMITTER__FIRST_TIME_OF_EMIT = eINSTANCE.getDeRampEmitter_FirstTimeOfEmit();

		/**
		 * The meta object literal for the '<em><b>Increment</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_RAMP_EMITTER__INCREMENT = eINSTANCE.getDeRampEmitter_Increment();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeDuplicatorImpl <em>De Duplicator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.delib.impl.DeDuplicatorImpl
		 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeDuplicator()
		 * @generated
		 */
		EClass DE_DUPLICATOR = eINSTANCE.getDeDuplicator();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeAdderImpl <em>De Adder</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.delib.impl.DeAdderImpl
		 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeAdder()
		 * @generated
		 */
		EClass DE_ADDER = eINSTANCE.getDeAdder();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeEventPrinterImpl <em>De Event Printer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.delib.impl.DeEventPrinterImpl
		 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeEventPrinter()
		 * @generated
		 */
		EClass DE_EVENT_PRINTER = eINSTANCE.getDeEventPrinter();

		/**
		 * The meta object literal for the '<em><b>Print Stream</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_EVENT_PRINTER__PRINT_STREAM = eINSTANCE.getDeEventPrinter_PrintStream();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeDelayImpl <em>De Delay</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.delib.impl.DeDelayImpl
		 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeDelay()
		 * @generated
		 */
		EClass DE_DELAY = eINSTANCE.getDeDelay();

		/**
		 * The meta object literal for the '<em><b>Time Delay</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_DELAY__TIME_DELAY = eINSTANCE.getDeDelay_TimeDelay();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeCoffeeMachineUserImpl <em>De Coffee Machine User</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.delib.impl.DeCoffeeMachineUserImpl
		 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeCoffeeMachineUser()
		 * @generated
		 */
		EClass DE_COFFEE_MACHINE_USER = eINSTANCE.getDeCoffeeMachineUser();

		/**
		 * The meta object literal for the '<em><b>First Time Of Emit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_COFFEE_MACHINE_USER__FIRST_TIME_OF_EMIT = eINSTANCE.getDeCoffeeMachineUser_FirstTimeOfEmit();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeCoffeeMachineUserWithoutInputImpl <em>De Coffee Machine User Without Input</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.delib.impl.DeCoffeeMachineUserWithoutInputImpl
		 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeCoffeeMachineUserWithoutInput()
		 * @generated
		 */
		EClass DE_COFFEE_MACHINE_USER_WITHOUT_INPUT = eINSTANCE.getDeCoffeeMachineUserWithoutInput();

		/**
		 * The meta object literal for the '<em><b>Time Between Coin And Coffee</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_COFFEE_MACHINE_USER_WITHOUT_INPUT__TIME_BETWEEN_COIN_AND_COFFEE = eINSTANCE.getDeCoffeeMachineUserWithoutInput_TimeBetweenCoinAndCoffee();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeConstantEmitterImpl <em>De Constant Emitter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.delib.impl.DeConstantEmitterImpl
		 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeConstantEmitter()
		 * @generated
		 */
		EClass DE_CONSTANT_EMITTER = eINSTANCE.getDeConstantEmitter();

		/**
		 * The meta object literal for the '<em><b>Value To Emit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_CONSTANT_EMITTER__VALUE_TO_EMIT = eINSTANCE.getDeConstantEmitter_ValueToEmit();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeScenarioPlayerImpl <em>De Scenario Player</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.delib.impl.DeScenarioPlayerImpl
		 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeScenarioPlayer()
		 * @generated
		 */
		EClass DE_SCENARIO_PLAYER = eINSTANCE.getDeScenarioPlayer();

		/**
		 * The meta object literal for the '<em><b>Events</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DE_SCENARIO_PLAYER__EVENTS = eINSTANCE.getDeScenarioPlayer_Events();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.delib.impl.DeScenarioEventImpl <em>De Scenario Event</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.delib.impl.DeScenarioEventImpl
		 * @see fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl#getDeScenarioEvent()
		 * @generated
		 */
		EClass DE_SCENARIO_EVENT = eINSTANCE.getDeScenarioEvent();

		/**
		 * The meta object literal for the '<em><b>Time</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_SCENARIO_EVENT__TIME = eINSTANCE.getDeScenarioEvent_Time();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DE_SCENARIO_EVENT__VALUE = eINSTANCE.getDeScenarioEvent_Value();

		/**
		 * The meta object literal for the '<em><b>Pin</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DE_SCENARIO_EVENT__PIN = eINSTANCE.getDeScenarioEvent_Pin();

	}

} //DelibPackage
