/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DeAdderImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.delib.impl;

import org.eclipse.emf.ecore.EClass;

import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.Token;
import fr.supelec.modhelx.core.impl.AtomicBlockImpl;
import fr.supelec.modhelx.core.time.InstantValue;
import fr.supelec.modhelx.mocs.de.DeModelOfComputation;
import fr.supelec.modhelx.mocs.delib.DeAdder;
import fr.supelec.modhelx.mocs.delib.DelibPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>De Adder</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class DeAdderImpl extends AtomicBlockImpl implements DeAdder {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DeAdderImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DelibPackage.Literals.DE_ADDER;
	}
	
	private DeModelOfComputation getMoc(ModelOfComputation moc) {
		try {
			DeModelOfComputation m = (DeModelOfComputation)moc;
			return m;
		}
		catch (ClassCastException ex) {
			throw new Error("DeAdder : moc is not DE");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public void update(ModelOfComputation moc_) {
		DeModelOfComputation moc = getMoc(moc_);
		super.update(moc);
		
		int result = 0;
		
		for (Pin pIn : getPinsIn()) {
			while (pIn.hasTokens()) {
				Token evIn = pIn.getToken(true);
				if (! moc.getTimestampOfEvent(evIn).equals(moc.getTimeOfCurrentSnapshot())) {
					throw new Error("DeAdder.update : event has invalid date");
				}
				Integer i = null;
				try {
					i = (Integer) moc.getValueOfToken(evIn);
				}
				catch (ClassCastException ex) {
					throw new Error("DeAdder.update : value of event is not an Integer");
				}
				result += i.intValue();
			}
		}
		
		for (Pin p : getPinsOut()) {
			Token evOut = moc.createEvent(moc.getTimeOfCurrentSnapshot(), new Integer(result));
			p.addToken(evOut);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public void setup(ModelOfComputation moc_, InstantValue initialTime) {
		DeModelOfComputation moc = getMoc(moc_);
		super.setup(moc, initialTime);
		
		if (getPinsIn().size() == 0) {
			throw new Error("DeAdder.setup : at least one input pin is expected");
		}
		if (getPinsOut().size() == 0) {
			throw new Error("DeAdder.setup : at least one output pin is expected");
		}
	}

} //DeAdderImpl
