/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DeConstantEmitterImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.delib.impl;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import fr.supelec.modhelx.mocs.delib.DeConstantEmitter;
import fr.supelec.modhelx.mocs.delib.DelibPackage;
import org.eclipse.emf.common.notify.Notification;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>De Constant Emitter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.delib.impl.DeConstantEmitterImpl#getValueToEmit <em>Value To Emit</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DeConstantEmitterImpl extends DeRampEmitterImpl implements DeConstantEmitter {
	/**
	 * The default value of the '{@link #getValueToEmit() <em>Value To Emit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValueToEmit()
	 * @generated
	 * @ordered
	 */
	protected static final Object VALUE_TO_EMIT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getValueToEmit() <em>Value To Emit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getValueToEmit()
	 * @generated
	 * @ordered
	 */
	protected Object valueToEmit = VALUE_TO_EMIT_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected DeConstantEmitterImpl() {
		// no increment for a constant
		setIncrement(null);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DelibPackage.Literals.DE_CONSTANT_EMITTER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Object getValueToEmit() {
		return getInitialValueToEmit();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setValueToEmit(Object newValueToEmit) {
		setInitialValueToEmit(newValueToEmit);
	}
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case DelibPackage.DE_CONSTANT_EMITTER__VALUE_TO_EMIT:
				return getValueToEmit();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case DelibPackage.DE_CONSTANT_EMITTER__VALUE_TO_EMIT:
				setValueToEmit(newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case DelibPackage.DE_CONSTANT_EMITTER__VALUE_TO_EMIT:
				setValueToEmit(VALUE_TO_EMIT_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case DelibPackage.DE_CONSTANT_EMITTER__VALUE_TO_EMIT:
				return VALUE_TO_EMIT_EDEFAULT == null ? valueToEmit != null : !VALUE_TO_EMIT_EDEFAULT.equals(valueToEmit);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (valueToEmit: ");
		result.append(valueToEmit);
		result.append(')');
		return result.toString();
	}

} //DeConstantEmitterImpl
