/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DeRampEmitterImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.delib.impl;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.Token;
import fr.supelec.modhelx.core.impl.AtomicBlockImpl;
import fr.supelec.modhelx.core.time.DurationValue;
import fr.supelec.modhelx.core.time.InstantValue;
import fr.supelec.modhelx.engine.Platform;
import fr.supelec.modhelx.mocs.de.DeModelOfComputation;
import fr.supelec.modhelx.mocs.delib.DeRampEmitter;
import fr.supelec.modhelx.mocs.delib.DelibPackage;
import org.eclipse.emf.common.notify.Notification;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>De Ramp Emitter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.delib.impl.DeRampEmitterImpl#getInitialValueToEmit <em>Initial Value To Emit</em>}</li>
 *   <li>{@link fr.supelec.modhelx.mocs.delib.impl.DeRampEmitterImpl#getTimeStep <em>Time Step</em>}</li>
 *   <li>{@link fr.supelec.modhelx.mocs.delib.impl.DeRampEmitterImpl#getFirstTimeOfEmit <em>First Time Of Emit</em>}</li>
 *   <li>{@link fr.supelec.modhelx.mocs.delib.impl.DeRampEmitterImpl#getIncrement <em>Increment</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class DeRampEmitterImpl extends AtomicBlockImpl implements DeRampEmitter {
	/**
	 * The default value of the '{@link #getInitialValueToEmit() <em>Initial Value To Emit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInitialValueToEmit()
	 * @generated
	 * @ordered
	 */
	protected static final Object INITIAL_VALUE_TO_EMIT_EDEFAULT = null;

	/**
	 * The default value of the '{@link #getTimeStep() <em>Time Step</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTimeStep()
	 * @generated
	 * @ordered
	 */
	protected static final int TIME_STEP_EDEFAULT = 1;

	/**
	 * The default value of the '{@link #getFirstTimeOfEmit() <em>First Time Of Emit</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFirstTimeOfEmit()
	 * @generated
	 * @ordered
	 */
	protected static final int FIRST_TIME_OF_EMIT_EDEFAULT = 0;

	/**
	 * The default value of the '{@link #getIncrement() <em>Increment</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIncrement()
	 * @generated
	 * @ordered
	 */
	protected static final Object INCREMENT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getIncrement() <em>Increment</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIncrement()
	 * @generated
	 * @ordered
	 */
	protected Object increment = INCREMENT_EDEFAULT;

	private InstantValue nextTimeOfEmit;
	private Object nextValueToEmit;
	private Object currentValue;   // latest emitted value, for display purposes only
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DeRampEmitterImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DelibPackage.Literals.DE_RAMP_EMITTER;
	}
	
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Object getInitialValueToEmit() {
		Object value = getValueOfParameter("initialValueToEmit");
		if (value == null) {
			return INITIAL_VALUE_TO_EMIT_EDEFAULT;
		}
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setInitialValueToEmit(Object newInitialValueToEmit) {
		setValueOfParameter("initialValueToEmit", newInitialValueToEmit);
	}

	private DeModelOfComputation getMoc(ModelOfComputation moc) {
		try {
			DeModelOfComputation m = (DeModelOfComputation)moc;
			return m;
		}
		catch (ClassCastException ex) {
			throw new Error("DeConstantEmitter : moc is not DE");
		}
	}


	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public int getTimeStep() {
		Object value = getValueOfParameter("timeStep");
		if (value == null) {
			return TIME_STEP_EDEFAULT;
		}
		try {
			Integer v = (Integer) value;
			return v.intValue();
		}
		catch (ClassCastException ex) {
			throw new Error("DeConstantEmitter.getTimeStep : timeStep is not an Integer");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setTimeStep(int newTimeStep) {
		setValueOfParameter("timeStep", new Integer(newTimeStep));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public int getFirstTimeOfEmit() {
		Object value = getValueOfParameter("firstTimeOfEmit");
		if (value == null) {
			return FIRST_TIME_OF_EMIT_EDEFAULT;
		}
		try {
			Integer v = (Integer) value;
			return v.intValue();
		}
		catch (ClassCastException ex) {
			throw new Error("DeConstantEmitter.getFirstTimeOfEmit : firstTimeOfEmit is not an Integer");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setFirstTimeOfEmit(int newFirstTimeOfEmit) {
		setValueOfParameter("firstTimeOfEmit", new Integer(newFirstTimeOfEmit));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Object getIncrement() {
		Object value = getValueOfParameter("increment");
		if (value == null) {
			return INCREMENT_EDEFAULT;
		}
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setIncrement(Object newIncrement) {
		setValueOfParameter("increment", newIncrement);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public void collectTimeConstraints(ModelOfComputation moc_, EList<InstantValue> timeConstraints) {
		DeModelOfComputation moc = getMoc(moc_);
		//super.collectTimeConstraints(moc, timeConstraints);
		
		if (nextTimeOfEmit == null) {
			nextTimeOfEmit = moc.getClock().createInstantValue(getFirstTimeOfEmit());
			nextValueToEmit = getInitialValueToEmit();
		}
		
		Platform.getLog().finer("Before: " + timeConstraints);
		timeConstraints.add(nextTimeOfEmit);
		
		Platform.getLog().finer("Just added constraint: " + nextTimeOfEmit + ", constraint list=" + timeConstraints);
		
		/*
		DurationValue d = moc.getClock().createDurationValue(
				moc.getClock().createInstantValue(0),
				moc.getClock().createInstantValue(getTimeStep()));
		timeAfterNextTimeOfEmit = nextTimeOfEmit.add(d);
		timeConstraints.add(timeAfterNextTimeOfEmit);
		*/
		
		super.collectTimeConstraints(moc, timeConstraints, nextTimeOfEmit);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public void update(ModelOfComputation moc_) {
		DeModelOfComputation moc = getMoc(moc_);
		super.update(moc);
		
		if (moc.getTimeOfCurrentSnapshot().compareTo(nextTimeOfEmit) > 0) {
			throw new Error("DeConstantEmitter.update : should not be updated");
		}
		if (moc.getTimeOfCurrentSnapshot().compareTo(nextTimeOfEmit) < 0) {
			throw new Error("DeConstantEmitter.update : the time has advanced too much");
		}
		
		currentValue = nextValueToEmit;
		for (Pin p : getPinsOut()) {
			Token ev = moc.createEvent(nextTimeOfEmit, nextValueToEmit);
			p.addToken(ev);
			Platform.getLog().finer("New event added on pin " + p.getName() + ": time=" + nextTimeOfEmit + ", val=" + nextValueToEmit);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public void setup(ModelOfComputation moc_, InstantValue initialTime) {
		DeModelOfComputation moc = getMoc(moc_);
		super.setup(moc, initialTime);
		
		if (getPinsIn().size() != 0) {
			throw new Error("DeConstantEmitter.setup : input pins are not expected");
		}
		if (getPinsOut().size() == 0) {
			throw new Error("DeConstantEmitter.setup : at least one output pin is expected");
		}
	}


	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void endOfSnapshot(ModelOfComputation moc_) {
		DeModelOfComputation moc = getMoc(moc_);
		super.endOfSnapshot(moc);
		
		Platform.getLog().finer("With nextTimeOfEmit=" + nextTimeOfEmit + ", timeOfCurrentSnapshot=" + moc.getTimeOfCurrentSnapshot());
		
		if(moc.getTimeOfCurrentSnapshot().equals(nextTimeOfEmit)) {
			DurationValue d = moc.getClock().createDurationValue(
					moc.getClock().createInstantValue(0),
					moc.getClock().createInstantValue(getTimeStep()));
			nextTimeOfEmit = nextTimeOfEmit.add(d);
			
			// at the moment, the ramp can only handle integer increments
			if(getIncrement() != null && getIncrement() instanceof Integer && nextValueToEmit != null && nextValueToEmit instanceof Integer) {
				nextValueToEmit = ((Integer)nextValueToEmit).intValue() + ((Integer)getIncrement());
			}
			
			Platform.getLog().finer("Snapshot happened at the right time! nextTimeOfEmit=" + nextTimeOfEmit + ", nextValueToEmit=" + nextValueToEmit);
			
			//nextTimeOfEmit = timeAfterNextTimeOfEmit;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public boolean newSnap(ModelOfComputation moc) {
		// TODO: tenir compte de la valeur du timestep : pas de newSnap si 0
		super.newSnap(moc);
		return true;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case DelibPackage.DE_RAMP_EMITTER__INITIAL_VALUE_TO_EMIT:
				return getInitialValueToEmit();
			case DelibPackage.DE_RAMP_EMITTER__TIME_STEP:
				return getTimeStep();
			case DelibPackage.DE_RAMP_EMITTER__FIRST_TIME_OF_EMIT:
				return getFirstTimeOfEmit();
			case DelibPackage.DE_RAMP_EMITTER__INCREMENT:
				return getIncrement();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case DelibPackage.DE_RAMP_EMITTER__INITIAL_VALUE_TO_EMIT:
				setInitialValueToEmit(newValue);
				return;
			case DelibPackage.DE_RAMP_EMITTER__TIME_STEP:
				setTimeStep((Integer)newValue);
				return;
			case DelibPackage.DE_RAMP_EMITTER__FIRST_TIME_OF_EMIT:
				setFirstTimeOfEmit((Integer)newValue);
				return;
			case DelibPackage.DE_RAMP_EMITTER__INCREMENT:
				setIncrement(newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case DelibPackage.DE_RAMP_EMITTER__INITIAL_VALUE_TO_EMIT:
				setInitialValueToEmit(INITIAL_VALUE_TO_EMIT_EDEFAULT);
				return;
			case DelibPackage.DE_RAMP_EMITTER__TIME_STEP:
				setTimeStep(TIME_STEP_EDEFAULT);
				return;
			case DelibPackage.DE_RAMP_EMITTER__FIRST_TIME_OF_EMIT:
				setFirstTimeOfEmit(FIRST_TIME_OF_EMIT_EDEFAULT);
				return;
			case DelibPackage.DE_RAMP_EMITTER__INCREMENT:
				setIncrement(INCREMENT_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case DelibPackage.DE_RAMP_EMITTER__INITIAL_VALUE_TO_EMIT:
				return INITIAL_VALUE_TO_EMIT_EDEFAULT == null ? getInitialValueToEmit() != null : !INITIAL_VALUE_TO_EMIT_EDEFAULT.equals(getInitialValueToEmit());
			case DelibPackage.DE_RAMP_EMITTER__TIME_STEP:
				return getTimeStep() != TIME_STEP_EDEFAULT;
			case DelibPackage.DE_RAMP_EMITTER__FIRST_TIME_OF_EMIT:
				return getFirstTimeOfEmit() != FIRST_TIME_OF_EMIT_EDEFAULT;
			case DelibPackage.DE_RAMP_EMITTER__INCREMENT:
				return INCREMENT_EDEFAULT == null ? increment != null : !INCREMENT_EDEFAULT.equals(increment);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (increment: ");
		result.append(increment);
		result.append(')');
		return result.toString();
	}
	
	public Object getCurrentValue() {
		return currentValue;
	}

} //DeRampEmitterImpl
