/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DelibFactoryImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.delib.impl;

import fr.supelec.modhelx.mocs.delib.*;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

import fr.supelec.modhelx.mocs.delib.DeAdder;
import fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUser;
import fr.supelec.modhelx.mocs.delib.DeConstantEmitter;
import fr.supelec.modhelx.mocs.delib.DeDelay;
import fr.supelec.modhelx.mocs.delib.DeDuplicator;
import fr.supelec.modhelx.mocs.delib.DeEventPrinter;
import fr.supelec.modhelx.mocs.delib.DelibFactory;
import fr.supelec.modhelx.mocs.delib.DelibPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class DelibFactoryImpl extends EFactoryImpl implements DelibFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DelibFactory init() {
		try {
			DelibFactory theDelibFactory = (DelibFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.supelec.fr/modhelx/2009/delib"); 
			if (theDelibFactory != null) {
				return theDelibFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new DelibFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DelibFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case DelibPackage.DE_RAMP_EMITTER: return createDeRampEmitter();
			case DelibPackage.DE_DUPLICATOR: return createDeDuplicator();
			case DelibPackage.DE_ADDER: return createDeAdder();
			case DelibPackage.DE_EVENT_PRINTER: return createDeEventPrinter();
			case DelibPackage.DE_DELAY: return createDeDelay();
			case DelibPackage.DE_COFFEE_MACHINE_USER: return createDeCoffeeMachineUser();
			case DelibPackage.DE_COFFEE_MACHINE_USER_WITHOUT_INPUT: return createDeCoffeeMachineUserWithoutInput();
			case DelibPackage.DE_CONSTANT_EMITTER: return createDeConstantEmitter();
			case DelibPackage.DE_SCENARIO_PLAYER: return createDeScenarioPlayer();
			case DelibPackage.DE_SCENARIO_EVENT: return createDeScenarioEvent();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeRampEmitter createDeRampEmitter() {
		DeRampEmitterImpl deRampEmitter = new DeRampEmitterImpl();
		return deRampEmitter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeDuplicator createDeDuplicator() {
		DeDuplicatorImpl deDuplicator = new DeDuplicatorImpl();
		return deDuplicator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeAdder createDeAdder() {
		DeAdderImpl deAdder = new DeAdderImpl();
		return deAdder;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeEventPrinter createDeEventPrinter() {
		DeEventPrinterImpl deEventPrinter = new DeEventPrinterImpl();
		return deEventPrinter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeDelay createDeDelay() {
		DeDelayImpl deDelay = new DeDelayImpl();
		return deDelay;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeCoffeeMachineUser createDeCoffeeMachineUser() {
		DeCoffeeMachineUserImpl deCoffeeMachineUser = new DeCoffeeMachineUserImpl();
		return deCoffeeMachineUser;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeCoffeeMachineUserWithoutInput createDeCoffeeMachineUserWithoutInput() {
		DeCoffeeMachineUserWithoutInputImpl deCoffeeMachineUserWithoutInput = new DeCoffeeMachineUserWithoutInputImpl();
		return deCoffeeMachineUserWithoutInput;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeConstantEmitter createDeConstantEmitter() {
		DeConstantEmitterImpl deConstantEmitter = new DeConstantEmitterImpl();
		return deConstantEmitter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeScenarioPlayer createDeScenarioPlayer() {
		DeScenarioPlayerImpl deScenarioPlayer = new DeScenarioPlayerImpl();
		return deScenarioPlayer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeScenarioEvent createDeScenarioEvent() {
		DeScenarioEventImpl deScenarioEvent = new DeScenarioEventImpl();
		return deScenarioEvent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DelibPackage getDelibPackage() {
		return (DelibPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static DelibPackage getPackage() {
		return DelibPackage.eINSTANCE;
	}

} //DelibFactoryImpl
