/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: DelibPackageImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.delib.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import fr.supelec.modhelx.core.CorePackage;
import fr.supelec.modhelx.core.impl.CorePackageImpl;
import fr.supelec.modhelx.core.java.JavaPackage;
import fr.supelec.modhelx.core.java.impl.JavaPackageImpl;
import fr.supelec.modhelx.core.time.TimePackage;
import fr.supelec.modhelx.core.time.impl.TimePackageImpl;
import fr.supelec.modhelx.corelib.CorelibPackage;
import fr.supelec.modhelx.corelib.impl.CorelibPackageImpl;
import fr.supelec.modhelx.mocs.adapterlib.AdapterlibPackage;
import fr.supelec.modhelx.mocs.adapterlib.impl.AdapterlibPackageImpl;
import fr.supelec.modhelx.mocs.autosar.AutosarPackage;
import fr.supelec.modhelx.mocs.autosar.impl.AutosarPackageImpl;
import fr.supelec.modhelx.mocs.de.DePackage;
import fr.supelec.modhelx.mocs.de.impl.DePackageImpl;
import fr.supelec.modhelx.mocs.delib.DeAdder;
import fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUser;
import fr.supelec.modhelx.mocs.delib.DeCoffeeMachineUserWithoutInput;
import fr.supelec.modhelx.mocs.delib.DeConstantEmitter;
import fr.supelec.modhelx.mocs.delib.DeDelay;
import fr.supelec.modhelx.mocs.delib.DeDuplicator;
import fr.supelec.modhelx.mocs.delib.DeEventPrinter;
import fr.supelec.modhelx.mocs.delib.DeRampEmitter;
import fr.supelec.modhelx.mocs.delib.DeScenarioEvent;
import fr.supelec.modhelx.mocs.delib.DeScenarioPlayer;
import fr.supelec.modhelx.mocs.delib.DelibFactory;
import fr.supelec.modhelx.mocs.delib.DelibPackage;
import fr.supelec.modhelx.mocs.fsm.FsmPackage;
import fr.supelec.modhelx.mocs.fsm.impl.FsmPackageImpl;
import fr.supelec.modhelx.mocs.fsmlib.FsmlibPackage;
import fr.supelec.modhelx.mocs.fsmlib.impl.FsmlibPackageImpl;
import fr.supelec.modhelx.mocs.petrinet.PetrinetPackage;
import fr.supelec.modhelx.mocs.petrinet.impl.PetrinetPackageImpl;
import fr.supelec.modhelx.mocs.polymoclib.PolymoclibPackage;
import fr.supelec.modhelx.mocs.polymoclib.impl.PolymoclibPackageImpl;
import fr.supelec.modhelx.mocs.sdf.SdfPackage;
import fr.supelec.modhelx.mocs.sdf.impl.SdfPackageImpl;
import fr.supelec.modhelx.mocs.sdflib.SdflibPackage;
import fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl;
import fr.supelec.modhelx.mocs.simple.SimplePackage;
import fr.supelec.modhelx.mocs.simple.impl.SimplePackageImpl;
import fr.supelec.modhelx.mocs.tfsm.TfsmPackage;
import fr.supelec.modhelx.mocs.tfsm.impl.TfsmPackageImpl;
import fr.supelec.modhelx.mocs.tfsmlib.TfsmlibPackage;
import fr.supelec.modhelx.mocs.tfsmlib.impl.TfsmlibPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class DelibPackageImpl extends EPackageImpl implements DelibPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deRampEmitterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deDuplicatorEClass = null;
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deAdderEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deEventPrinterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deDelayEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deCoffeeMachineUserEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deCoffeeMachineUserWithoutInputEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deConstantEmitterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deScenarioPlayerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deScenarioEventEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see fr.supelec.modhelx.mocs.delib.DelibPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private DelibPackageImpl() {
		super(eNS_URI, DelibFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link DelibPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static DelibPackage init() {
		if (isInited) return (DelibPackage)EPackage.Registry.INSTANCE.getEPackage(DelibPackage.eNS_URI);

		// Obtain or create and register package
		DelibPackageImpl theDelibPackage = (DelibPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof DelibPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new DelibPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		CorePackageImpl theCorePackage = (CorePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI) instanceof CorePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI) : CorePackage.eINSTANCE);
		TimePackageImpl theTimePackage = (TimePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI) instanceof TimePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI) : TimePackage.eINSTANCE);
		JavaPackageImpl theJavaPackage = (JavaPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(JavaPackage.eNS_URI) instanceof JavaPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(JavaPackage.eNS_URI) : JavaPackage.eINSTANCE);
		DePackageImpl theDePackage = (DePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(DePackage.eNS_URI) instanceof DePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(DePackage.eNS_URI) : DePackage.eINSTANCE);
		SimplePackageImpl theSimplePackage = (SimplePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SimplePackage.eNS_URI) instanceof SimplePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SimplePackage.eNS_URI) : SimplePackage.eINSTANCE);
		FsmPackageImpl theFsmPackage = (FsmPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FsmPackage.eNS_URI) instanceof FsmPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FsmPackage.eNS_URI) : FsmPackage.eINSTANCE);
		FsmlibPackageImpl theFsmlibPackage = (FsmlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FsmlibPackage.eNS_URI) instanceof FsmlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FsmlibPackage.eNS_URI) : FsmlibPackage.eINSTANCE);
		AdapterlibPackageImpl theAdapterlibPackage = (AdapterlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AdapterlibPackage.eNS_URI) instanceof AdapterlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AdapterlibPackage.eNS_URI) : AdapterlibPackage.eINSTANCE);
		SdfPackageImpl theSdfPackage = (SdfPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SdfPackage.eNS_URI) instanceof SdfPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SdfPackage.eNS_URI) : SdfPackage.eINSTANCE);
		SdflibPackageImpl theSdflibPackage = (SdflibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SdflibPackage.eNS_URI) instanceof SdflibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SdflibPackage.eNS_URI) : SdflibPackage.eINSTANCE);
		PetrinetPackageImpl thePetrinetPackage = (PetrinetPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PetrinetPackage.eNS_URI) instanceof PetrinetPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PetrinetPackage.eNS_URI) : PetrinetPackage.eINSTANCE);
		PolymoclibPackageImpl thePolymoclibPackage = (PolymoclibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PolymoclibPackage.eNS_URI) instanceof PolymoclibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PolymoclibPackage.eNS_URI) : PolymoclibPackage.eINSTANCE);
		AutosarPackageImpl theAutosarPackage = (AutosarPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) instanceof AutosarPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) : AutosarPackage.eINSTANCE);
		TfsmPackageImpl theTfsmPackage = (TfsmPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TfsmPackage.eNS_URI) instanceof TfsmPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TfsmPackage.eNS_URI) : TfsmPackage.eINSTANCE);
		TfsmlibPackageImpl theTfsmlibPackage = (TfsmlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TfsmlibPackage.eNS_URI) instanceof TfsmlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TfsmlibPackage.eNS_URI) : TfsmlibPackage.eINSTANCE);
		CorelibPackageImpl theCorelibPackage = (CorelibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CorelibPackage.eNS_URI) instanceof CorelibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CorelibPackage.eNS_URI) : CorelibPackage.eINSTANCE);

		// Create package meta-data objects
		theDelibPackage.createPackageContents();
		theCorePackage.createPackageContents();
		theTimePackage.createPackageContents();
		theJavaPackage.createPackageContents();
		theDePackage.createPackageContents();
		theSimplePackage.createPackageContents();
		theFsmPackage.createPackageContents();
		theFsmlibPackage.createPackageContents();
		theAdapterlibPackage.createPackageContents();
		theSdfPackage.createPackageContents();
		theSdflibPackage.createPackageContents();
		thePetrinetPackage.createPackageContents();
		thePolymoclibPackage.createPackageContents();
		theAutosarPackage.createPackageContents();
		theTfsmPackage.createPackageContents();
		theTfsmlibPackage.createPackageContents();
		theCorelibPackage.createPackageContents();

		// Initialize created meta-data
		theDelibPackage.initializePackageContents();
		theCorePackage.initializePackageContents();
		theTimePackage.initializePackageContents();
		theJavaPackage.initializePackageContents();
		theDePackage.initializePackageContents();
		theSimplePackage.initializePackageContents();
		theFsmPackage.initializePackageContents();
		theFsmlibPackage.initializePackageContents();
		theAdapterlibPackage.initializePackageContents();
		theSdfPackage.initializePackageContents();
		theSdflibPackage.initializePackageContents();
		thePetrinetPackage.initializePackageContents();
		thePolymoclibPackage.initializePackageContents();
		theAutosarPackage.initializePackageContents();
		theTfsmPackage.initializePackageContents();
		theTfsmlibPackage.initializePackageContents();
		theCorelibPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theDelibPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(DelibPackage.eNS_URI, theDelibPackage);
		return theDelibPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeRampEmitter() {
		return deRampEmitterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeRampEmitter_InitialValueToEmit() {
		return (EAttribute)deRampEmitterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeRampEmitter_TimeStep() {
		return (EAttribute)deRampEmitterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeRampEmitter_FirstTimeOfEmit() {
		return (EAttribute)deRampEmitterEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeRampEmitter_Increment() {
		return (EAttribute)deRampEmitterEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeDuplicator() {
		return deDuplicatorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeAdder() {
		return deAdderEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeEventPrinter() {
		return deEventPrinterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeEventPrinter_PrintStream() {
		return (EAttribute)deEventPrinterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeDelay() {
		return deDelayEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeDelay_TimeDelay() {
		return (EAttribute)deDelayEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeCoffeeMachineUser() {
		return deCoffeeMachineUserEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeCoffeeMachineUser_FirstTimeOfEmit() {
		return (EAttribute)deCoffeeMachineUserEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeCoffeeMachineUserWithoutInput() {
		return deCoffeeMachineUserWithoutInputEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeCoffeeMachineUserWithoutInput_TimeBetweenCoinAndCoffee() {
		return (EAttribute)deCoffeeMachineUserWithoutInputEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeConstantEmitter() {
		return deConstantEmitterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeConstantEmitter_ValueToEmit() {
		return (EAttribute)deConstantEmitterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeScenarioPlayer() {
		return deScenarioPlayerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDeScenarioPlayer_Events() {
		return (EReference)deScenarioPlayerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeScenarioEvent() {
		return deScenarioEventEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeScenarioEvent_Time() {
		return (EAttribute)deScenarioEventEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeScenarioEvent_Value() {
		return (EAttribute)deScenarioEventEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDeScenarioEvent_Pin() {
		return (EReference)deScenarioEventEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DelibFactory getDelibFactory() {
		return (DelibFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		deRampEmitterEClass = createEClass(DE_RAMP_EMITTER);
		createEAttribute(deRampEmitterEClass, DE_RAMP_EMITTER__INITIAL_VALUE_TO_EMIT);
		createEAttribute(deRampEmitterEClass, DE_RAMP_EMITTER__TIME_STEP);
		createEAttribute(deRampEmitterEClass, DE_RAMP_EMITTER__FIRST_TIME_OF_EMIT);
		createEAttribute(deRampEmitterEClass, DE_RAMP_EMITTER__INCREMENT);

		deDuplicatorEClass = createEClass(DE_DUPLICATOR);

		deAdderEClass = createEClass(DE_ADDER);

		deEventPrinterEClass = createEClass(DE_EVENT_PRINTER);
		createEAttribute(deEventPrinterEClass, DE_EVENT_PRINTER__PRINT_STREAM);

		deDelayEClass = createEClass(DE_DELAY);
		createEAttribute(deDelayEClass, DE_DELAY__TIME_DELAY);

		deCoffeeMachineUserEClass = createEClass(DE_COFFEE_MACHINE_USER);
		createEAttribute(deCoffeeMachineUserEClass, DE_COFFEE_MACHINE_USER__FIRST_TIME_OF_EMIT);

		deCoffeeMachineUserWithoutInputEClass = createEClass(DE_COFFEE_MACHINE_USER_WITHOUT_INPUT);
		createEAttribute(deCoffeeMachineUserWithoutInputEClass, DE_COFFEE_MACHINE_USER_WITHOUT_INPUT__TIME_BETWEEN_COIN_AND_COFFEE);

		deConstantEmitterEClass = createEClass(DE_CONSTANT_EMITTER);
		createEAttribute(deConstantEmitterEClass, DE_CONSTANT_EMITTER__VALUE_TO_EMIT);

		deScenarioPlayerEClass = createEClass(DE_SCENARIO_PLAYER);
		createEReference(deScenarioPlayerEClass, DE_SCENARIO_PLAYER__EVENTS);

		deScenarioEventEClass = createEClass(DE_SCENARIO_EVENT);
		createEAttribute(deScenarioEventEClass, DE_SCENARIO_EVENT__TIME);
		createEAttribute(deScenarioEventEClass, DE_SCENARIO_EVENT__VALUE);
		createEReference(deScenarioEventEClass, DE_SCENARIO_EVENT__PIN);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		CorePackage theCorePackage = (CorePackage)EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI);
		TimePackage theTimePackage = (TimePackage)EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		deRampEmitterEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		deDuplicatorEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		deAdderEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		deEventPrinterEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		deDelayEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		deCoffeeMachineUserEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		deCoffeeMachineUserWithoutInputEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		deConstantEmitterEClass.getESuperTypes().add(this.getDeRampEmitter());
		deScenarioPlayerEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());

		// Initialize classes and features; add operations and parameters
		initEClass(deRampEmitterEClass, DeRampEmitter.class, "DeRampEmitter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeRampEmitter_InitialValueToEmit(), ecorePackage.getEJavaObject(), "initialValueToEmit", null, 0, 1, DeRampEmitter.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getDeRampEmitter_TimeStep(), ecorePackage.getEInt(), "timeStep", "1", 0, 1, DeRampEmitter.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getDeRampEmitter_FirstTimeOfEmit(), ecorePackage.getEInt(), "firstTimeOfEmit", "0", 0, 1, DeRampEmitter.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getDeRampEmitter_Increment(), ecorePackage.getEJavaObject(), "increment", null, 0, 1, DeRampEmitter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		EOperation op = addEOperation(deRampEmitterEClass, null, "collectTimeConstraints", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "timeConstraints", 0, -1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deRampEmitterEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deRampEmitterEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deRampEmitterEClass, null, "endOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deRampEmitterEClass, ecorePackage.getEBoolean(), "newSnap", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(deDuplicatorEClass, DeDuplicator.class, "DeDuplicator", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(deDuplicatorEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deDuplicatorEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(deAdderEClass, DeAdder.class, "DeAdder", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(deAdderEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deAdderEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(deEventPrinterEClass, DeEventPrinter.class, "DeEventPrinter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeEventPrinter_PrintStream(), ecorePackage.getEJavaObject(), "printStream", null, 0, 1, DeEventPrinter.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(deEventPrinterEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deEventPrinterEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(deDelayEClass, DeDelay.class, "DeDelay", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeDelay_TimeDelay(), ecorePackage.getEInt(), "timeDelay", "1", 0, 1, DeDelay.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		op = addEOperation(deDelayEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deDelayEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deDelayEClass, null, "startOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deDelayEClass, null, "endOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(deCoffeeMachineUserEClass, DeCoffeeMachineUser.class, "DeCoffeeMachineUser", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeCoffeeMachineUser_FirstTimeOfEmit(), ecorePackage.getEInt(), "firstTimeOfEmit", "0", 0, 1, DeCoffeeMachineUser.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		op = addEOperation(deCoffeeMachineUserEClass, null, "collectTimeConstraints", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "timeConstraints", 0, -1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deCoffeeMachineUserEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deCoffeeMachineUserEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(deCoffeeMachineUserWithoutInputEClass, DeCoffeeMachineUserWithoutInput.class, "DeCoffeeMachineUserWithoutInput", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeCoffeeMachineUserWithoutInput_TimeBetweenCoinAndCoffee(), ecorePackage.getEInt(), "timeBetweenCoinAndCoffee", "1", 0, 1, DeCoffeeMachineUserWithoutInput.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		op = addEOperation(deCoffeeMachineUserWithoutInputEClass, null, "collectTimeConstraints", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "timeConstraints", 0, -1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deCoffeeMachineUserWithoutInputEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deCoffeeMachineUserWithoutInputEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(deCoffeeMachineUserWithoutInputEClass, theCorePackage.getPin(), "createCoinPin", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(deCoffeeMachineUserWithoutInputEClass, theCorePackage.getPin(), "createCoffeePin", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(deConstantEmitterEClass, DeConstantEmitter.class, "DeConstantEmitter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeConstantEmitter_ValueToEmit(), ecorePackage.getEJavaObject(), "valueToEmit", null, 0, 1, DeConstantEmitter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(deScenarioPlayerEClass, DeScenarioPlayer.class, "DeScenarioPlayer", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDeScenarioPlayer_Events(), this.getDeScenarioEvent(), null, "events", null, 0, -1, DeScenarioPlayer.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		getDeScenarioPlayer_Events().getEKeys().add(this.getDeScenarioEvent_Time());

		op = addEOperation(deScenarioPlayerEClass, null, "collectTimeConstraints", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "timeConstraints", 0, -1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deScenarioPlayerEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deScenarioPlayerEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(deScenarioEventEClass, DeScenarioEvent.class, "DeScenarioEvent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeScenarioEvent_Time(), ecorePackage.getEInt(), "time", null, 1, 1, DeScenarioEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDeScenarioEvent_Value(), ecorePackage.getEJavaObject(), "value", null, 1, 1, DeScenarioEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDeScenarioEvent_Pin(), theCorePackage.getPin(), null, "pin", null, 1, 1, DeScenarioEvent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Create resource
		createResource(eNS_URI);
	}

} //DelibPackageImpl
