/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: FsmlibPackage.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.fsmlib;

import fr.supelec.modhelx.core.CorePackage;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.supelec.modhelx.mocs.fsmlib.FsmlibFactory
 * @model kind="package"
 * @generated
 */
public interface FsmlibPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "fsmlib";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.supelec.fr/modhelx/2009/fsmlib";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "modhelx_fsmlib";

	/**
	 * The package content type ID.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eCONTENT_TYPE = "fr.supelec.modhelx.mocs.fsmlib";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	FsmlibPackage eINSTANCE = fr.supelec.modhelx.mocs.fsmlib.impl.FsmlibPackageImpl.init();

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.fsmlib.impl.FsmAndConditionImpl <em>Fsm And Condition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.fsmlib.impl.FsmAndConditionImpl
	 * @see fr.supelec.modhelx.mocs.fsmlib.impl.FsmlibPackageImpl#getFsmAndCondition()
	 * @generated
	 */
	int FSM_AND_CONDITION = 0;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FSM_AND_CONDITION__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FSM_AND_CONDITION__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FSM_AND_CONDITION__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FSM_AND_CONDITION__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FSM_AND_CONDITION__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The number of structural features of the '<em>Fsm And Condition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FSM_AND_CONDITION_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.fsmlib.impl.FsmOrConditionImpl <em>Fsm Or Condition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.fsmlib.impl.FsmOrConditionImpl
	 * @see fr.supelec.modhelx.mocs.fsmlib.impl.FsmlibPackageImpl#getFsmOrCondition()
	 * @generated
	 */
	int FSM_OR_CONDITION = 1;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FSM_OR_CONDITION__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FSM_OR_CONDITION__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FSM_OR_CONDITION__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FSM_OR_CONDITION__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FSM_OR_CONDITION__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The number of structural features of the '<em>Fsm Or Condition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FSM_OR_CONDITION_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.fsmlib.FsmAndCondition <em>Fsm And Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Fsm And Condition</em>'.
	 * @see fr.supelec.modhelx.mocs.fsmlib.FsmAndCondition
	 * @generated
	 */
	EClass getFsmAndCondition();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.fsmlib.FsmOrCondition <em>Fsm Or Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Fsm Or Condition</em>'.
	 * @see fr.supelec.modhelx.mocs.fsmlib.FsmOrCondition
	 * @generated
	 */
	EClass getFsmOrCondition();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	FsmlibFactory getFsmlibFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.fsmlib.impl.FsmAndConditionImpl <em>Fsm And Condition</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.fsmlib.impl.FsmAndConditionImpl
		 * @see fr.supelec.modhelx.mocs.fsmlib.impl.FsmlibPackageImpl#getFsmAndCondition()
		 * @generated
		 */
		EClass FSM_AND_CONDITION = eINSTANCE.getFsmAndCondition();
		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.fsmlib.impl.FsmOrConditionImpl <em>Fsm Or Condition</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.fsmlib.impl.FsmOrConditionImpl
		 * @see fr.supelec.modhelx.mocs.fsmlib.impl.FsmlibPackageImpl#getFsmOrCondition()
		 * @generated
		 */
		EClass FSM_OR_CONDITION = eINSTANCE.getFsmOrCondition();

	}

} //FsmlibPackage
