/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: FsmAndConditionImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.fsmlib.impl;

import org.eclipse.emf.ecore.EClass;

import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.impl.AtomicBlockImpl;
import fr.supelec.modhelx.mocs.fsmlib.FsmAndCondition;
import fr.supelec.modhelx.mocs.fsmlib.FsmlibPackage;
import fr.supelec.modhelx.util.ModelBuilder;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Fsm And Condition</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class FsmAndConditionImpl extends AtomicBlockImpl implements FsmAndCondition {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FsmAndConditionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return FsmlibPackage.Literals.FSM_AND_CONDITION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void update(ModelOfComputation moc) {
		super.update(moc);
		
		boolean willEmit = true;
		
		for (Pin p : getPinsIn()) {
			if (! p.hasTokens()) {
				willEmit = false;
			}
			while (p.hasTokens()) {
				p.getToken(true);
			}
		}
		
		if (willEmit) {
			for (Pin p : getPinsOut()) {
				p.addToken(ModelBuilder.createFSMEvent(moc));
			}
		}
	}

} //FsmAndConditionImpl
