/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: FsmOrConditionImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.fsmlib.impl;

import org.eclipse.emf.ecore.EClass;

import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.impl.AtomicBlockImpl;
import fr.supelec.modhelx.engine.Platform;
import fr.supelec.modhelx.mocs.fsmlib.FsmOrCondition;
import fr.supelec.modhelx.mocs.fsmlib.FsmlibPackage;
import fr.supelec.modhelx.util.ModelBuilder;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Fsm Or Condition</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * </p>
 *
 * @generated
 */
public class FsmOrConditionImpl extends AtomicBlockImpl implements FsmOrCondition {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FsmOrConditionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return FsmlibPackage.Literals.FSM_OR_CONDITION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void update(ModelOfComputation moc) {
		super.update(moc);
		
		boolean willEmit = false;
		boolean first = true;   // the first pin (trigger) must have a token
		
		String situation = "";
		
		for (Pin p : getPinsIn()) {
			// log
			situation += p.getName() + "=";
			if(p.hasTokens()) situation += "X "; else situation += "_ ";
			
			if(first) {
				if(! p.hasTokens()) break;
				first = false;
				
				// if only one pin, then we need to emit tokens
				willEmit = getPinsIn().size() == 1;
			} else {
				if (p.hasTokens()) {
					willEmit = true;
				}
			}
			while (p.hasTokens()) {
				p.getToken(true);
			}
		}
		
		// log
		Platform.getLog().finest("Pre-situation of guard '" + getName() + "' input: " + situation);
		situation = "";
		
		if (willEmit) {
			Platform.getLog().finer("Guard " + getName() + " fires!");
			for (Pin p : getPinsOut()) {
				p.addToken(ModelBuilder.createFSMEvent(moc));
				
				situation += p.getName() + "=" + p.getStoredTokens();
			}
		}
		
		// log
		Platform.getLog().finest("Post-situation of guard '" + getName() + "' output: " + situation);
	}

} //FsmOrConditionImpl
