/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: PetrinetPackage.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.petrinet;

import fr.supelec.modhelx.core.CorePackage;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.supelec.modhelx.mocs.petrinet.PetrinetFactory
 * @model kind="package"
 * @generated
 */
public interface PetrinetPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "petrinet";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.supelec.fr/modhelx/2009/petrinet";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "modhelx_petrinet";

	/**
	 * The package content type ID.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eCONTENT_TYPE = "fr.supelec.modhelx.mocs.petrinet";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	PetrinetPackage eINSTANCE = fr.supelec.modhelx.mocs.petrinet.impl.PetrinetPackageImpl.init();

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.petrinet.impl.PetriNetModelOfComputationImpl <em>Petri Net Model Of Computation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.petrinet.impl.PetriNetModelOfComputationImpl
	 * @see fr.supelec.modhelx.mocs.petrinet.impl.PetrinetPackageImpl#getPetriNetModelOfComputation()
	 * @generated
	 */
	int PETRI_NET_MODEL_OF_COMPUTATION = 0;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PETRI_NET_MODEL_OF_COMPUTATION__PARAMETERS = CorePackage.MODEL_OF_COMPUTATION__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PETRI_NET_MODEL_OF_COMPUTATION__NAME = CorePackage.MODEL_OF_COMPUTATION__NAME;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PETRI_NET_MODEL_OF_COMPUTATION__CLOCK = CorePackage.MODEL_OF_COMPUTATION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Time Of Current Snapshot</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PETRI_NET_MODEL_OF_COMPUTATION__TIME_OF_CURRENT_SNAPSHOT = CorePackage.MODEL_OF_COMPUTATION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Petri Net Model Of Computation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PETRI_NET_MODEL_OF_COMPUTATION_FEATURE_COUNT = CorePackage.MODEL_OF_COMPUTATION_FEATURE_COUNT + 2;


	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.petrinet.PetriNetModelOfComputation <em>Petri Net Model Of Computation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Petri Net Model Of Computation</em>'.
	 * @see fr.supelec.modhelx.mocs.petrinet.PetriNetModelOfComputation
	 * @generated
	 */
	EClass getPetriNetModelOfComputation();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.modhelx.mocs.petrinet.PetriNetModelOfComputation#getClock <em>Clock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Clock</em>'.
	 * @see fr.supelec.modhelx.mocs.petrinet.PetriNetModelOfComputation#getClock()
	 * @see #getPetriNetModelOfComputation()
	 * @generated
	 */
	EReference getPetriNetModelOfComputation_Clock();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.modhelx.mocs.petrinet.PetriNetModelOfComputation#getTimeOfCurrentSnapshot <em>Time Of Current Snapshot</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Time Of Current Snapshot</em>'.
	 * @see fr.supelec.modhelx.mocs.petrinet.PetriNetModelOfComputation#getTimeOfCurrentSnapshot()
	 * @see #getPetriNetModelOfComputation()
	 * @generated
	 */
	EReference getPetriNetModelOfComputation_TimeOfCurrentSnapshot();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	PetrinetFactory getPetrinetFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.petrinet.impl.PetriNetModelOfComputationImpl <em>Petri Net Model Of Computation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.petrinet.impl.PetriNetModelOfComputationImpl
		 * @see fr.supelec.modhelx.mocs.petrinet.impl.PetrinetPackageImpl#getPetriNetModelOfComputation()
		 * @generated
		 */
		EClass PETRI_NET_MODEL_OF_COMPUTATION = eINSTANCE.getPetriNetModelOfComputation();

		/**
		 * The meta object literal for the '<em><b>Clock</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PETRI_NET_MODEL_OF_COMPUTATION__CLOCK = eINSTANCE.getPetriNetModelOfComputation_Clock();

		/**
		 * The meta object literal for the '<em><b>Time Of Current Snapshot</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PETRI_NET_MODEL_OF_COMPUTATION__TIME_OF_CURRENT_SNAPSHOT = eINSTANCE.getPetriNetModelOfComputation_TimeOfCurrentSnapshot();

	}

} //PetrinetPackage
