/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: OrConstantEmitter.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.polymoclib;

import fr.supelec.modhelx.core.AtomicBlock;
import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Token;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Or Constant Emitter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * An atomic block which emits on all its output ports tokenToEmit if at least one of its input ports has tokens. If there are no input ports, nothing is outputed.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.polymoclib.OrConstantEmitter#getTokenToEmit <em>Token To Emit</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.mocs.polymoclib.PolymoclibPackage#getOrConstantEmitter()
 * @model
 * @generated
 */
public interface OrConstantEmitter extends AtomicBlock {
	/**
	 * Returns the value of the '<em><b>Token To Emit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Token To Emit</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Token To Emit</em>' reference.
	 * @see #setTokenToEmit(Token)
	 * @see fr.supelec.modhelx.mocs.polymoclib.PolymoclibPackage#getOrConstantEmitter_TokenToEmit()
	 * @model resolveProxies="false" required="true" transient="true" volatile="true" derived="true"
	 * @generated
	 */
	Token getTokenToEmit();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.polymoclib.OrConstantEmitter#getTokenToEmit <em>Token To Emit</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Token To Emit</em>' reference.
	 * @see #getTokenToEmit()
	 * @generated
	 */
	void setTokenToEmit(Token value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void update(ModelOfComputation moc);

} // OrConstantEmitter
