/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: PolymoclibPackage.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.polymoclib;

import fr.supelec.modhelx.core.CorePackage;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.supelec.modhelx.mocs.polymoclib.PolymoclibFactory
 * @model kind="package"
 * @generated
 */
public interface PolymoclibPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "polymoclib";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.supelec.fr/modhelx/2009/polymoclib";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "modhelx_polymoclib";

	/**
	 * The package content type ID.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eCONTENT_TYPE = "fr.supelec.modhelx.mocs.polymoclib";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	PolymoclibPackage eINSTANCE = fr.supelec.modhelx.mocs.polymoclib.impl.PolymoclibPackageImpl.init();

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.polymoclib.impl.AndConstantEmitterImpl <em>And Constant Emitter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.polymoclib.impl.AndConstantEmitterImpl
	 * @see fr.supelec.modhelx.mocs.polymoclib.impl.PolymoclibPackageImpl#getAndConstantEmitter()
	 * @generated
	 */
	int AND_CONSTANT_EMITTER = 0;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_CONSTANT_EMITTER__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_CONSTANT_EMITTER__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_CONSTANT_EMITTER__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_CONSTANT_EMITTER__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_CONSTANT_EMITTER__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Token To Emit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_CONSTANT_EMITTER__TOKEN_TO_EMIT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>And Constant Emitter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_CONSTANT_EMITTER_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.polymoclib.impl.OrConstantEmitterImpl <em>Or Constant Emitter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.polymoclib.impl.OrConstantEmitterImpl
	 * @see fr.supelec.modhelx.mocs.polymoclib.impl.PolymoclibPackageImpl#getOrConstantEmitter()
	 * @generated
	 */
	int OR_CONSTANT_EMITTER = 1;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_CONSTANT_EMITTER__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_CONSTANT_EMITTER__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_CONSTANT_EMITTER__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_CONSTANT_EMITTER__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_CONSTANT_EMITTER__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Token To Emit</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_CONSTANT_EMITTER__TOKEN_TO_EMIT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Or Constant Emitter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_CONSTANT_EMITTER_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.polymoclib.AndConstantEmitter <em>And Constant Emitter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>And Constant Emitter</em>'.
	 * @see fr.supelec.modhelx.mocs.polymoclib.AndConstantEmitter
	 * @generated
	 */
	EClass getAndConstantEmitter();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.modhelx.mocs.polymoclib.AndConstantEmitter#getTokenToEmit <em>Token To Emit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Token To Emit</em>'.
	 * @see fr.supelec.modhelx.mocs.polymoclib.AndConstantEmitter#getTokenToEmit()
	 * @see #getAndConstantEmitter()
	 * @generated
	 */
	EReference getAndConstantEmitter_TokenToEmit();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.polymoclib.OrConstantEmitter <em>Or Constant Emitter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Or Constant Emitter</em>'.
	 * @see fr.supelec.modhelx.mocs.polymoclib.OrConstantEmitter
	 * @generated
	 */
	EClass getOrConstantEmitter();

	/**
	 * Returns the meta object for the reference '{@link fr.supelec.modhelx.mocs.polymoclib.OrConstantEmitter#getTokenToEmit <em>Token To Emit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Token To Emit</em>'.
	 * @see fr.supelec.modhelx.mocs.polymoclib.OrConstantEmitter#getTokenToEmit()
	 * @see #getOrConstantEmitter()
	 * @generated
	 */
	EReference getOrConstantEmitter_TokenToEmit();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	PolymoclibFactory getPolymoclibFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.polymoclib.impl.AndConstantEmitterImpl <em>And Constant Emitter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.polymoclib.impl.AndConstantEmitterImpl
		 * @see fr.supelec.modhelx.mocs.polymoclib.impl.PolymoclibPackageImpl#getAndConstantEmitter()
		 * @generated
		 */
		EClass AND_CONSTANT_EMITTER = eINSTANCE.getAndConstantEmitter();

		/**
		 * The meta object literal for the '<em><b>Token To Emit</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AND_CONSTANT_EMITTER__TOKEN_TO_EMIT = eINSTANCE.getAndConstantEmitter_TokenToEmit();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.polymoclib.impl.OrConstantEmitterImpl <em>Or Constant Emitter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.polymoclib.impl.OrConstantEmitterImpl
		 * @see fr.supelec.modhelx.mocs.polymoclib.impl.PolymoclibPackageImpl#getOrConstantEmitter()
		 * @generated
		 */
		EClass OR_CONSTANT_EMITTER = eINSTANCE.getOrConstantEmitter();

		/**
		 * The meta object literal for the '<em><b>Token To Emit</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OR_CONSTANT_EMITTER__TOKEN_TO_EMIT = eINSTANCE.getOrConstantEmitter_TokenToEmit();

	}

} //PolymoclibPackage
