/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: AndConstantEmitterImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.polymoclib.impl;

import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.Token;

import fr.supelec.modhelx.core.impl.AtomicBlockImpl;

import fr.supelec.modhelx.mocs.polymoclib.AndConstantEmitter;
import fr.supelec.modhelx.mocs.polymoclib.PolymoclibPackage;

import org.eclipse.emf.ecore.EClass;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>And Constant Emitter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.polymoclib.impl.AndConstantEmitterImpl#getTokenToEmit <em>Token To Emit</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AndConstantEmitterImpl extends AtomicBlockImpl implements AndConstantEmitter {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AndConstantEmitterImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PolymoclibPackage.Literals.AND_CONSTANT_EMITTER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Token getTokenToEmit() {
		Object value = getValueOfParameter("tokenToEmit");
		if (value == null) {
			throw new Error("AndConstantEmitter.getTokenToEmit : no parameter tokenToEmit");
		}
		try {
			Token t = (Token) value;
			return t;
		}
		catch (ClassCastException ex) {
			throw new Error("AndConstantEmitter.getTokenToEmit : tokenToEmit is not a Token");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setTokenToEmit(Token newTokenToEmit) {
		setValueOfParameter("tokenToEmit", newTokenToEmit);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void update(ModelOfComputation moc) {
		super.update(moc);
		
		boolean willEmit = true;
		
		for (Pin p : getPinsIn()) {
			if (! p.hasTokens()) {
				willEmit = false;
			}
			while (p.hasTokens()) {
				p.getToken(true);
			}
		}
		
		if (willEmit) {
			for (Pin p : getPinsOut()) {
				// FIXME attention, le token n'est pas cloné, donc il est enlevé du pin sur lequel il a été placé au tour précédent..
				// voir si cloner ?
				p.addToken(getTokenToEmit());
			}
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PolymoclibPackage.AND_CONSTANT_EMITTER__TOKEN_TO_EMIT:
				return getTokenToEmit();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PolymoclibPackage.AND_CONSTANT_EMITTER__TOKEN_TO_EMIT:
				setTokenToEmit((Token)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PolymoclibPackage.AND_CONSTANT_EMITTER__TOKEN_TO_EMIT:
				setTokenToEmit((Token)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PolymoclibPackage.AND_CONSTANT_EMITTER__TOKEN_TO_EMIT:
				return getTokenToEmit() != null;
		}
		return super.eIsSet(featureID);
	}

} //AndConstantEmitterImpl
