/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: SdfAccumulator.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.sdflib;

import fr.supelec.modhelx.core.AtomicBlock;
import fr.supelec.modhelx.core.ModelOfComputation;

import fr.supelec.modhelx.core.time.InstantValue;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Sdf Accumulator</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.sdflib.SdfAccumulator#getInitialAccumulatorValue <em>Initial Accumulator Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage#getSdfAccumulator()
 * @model
 * @generated
 */
public interface SdfAccumulator extends AtomicBlock {
	/**
	 * Returns the value of the '<em><b>Initial Accumulator Value</b></em>' attribute.
	 * The default value is <code>"0.0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Initial Accumulator Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Initial Accumulator Value</em>' attribute.
	 * @see #setInitialAccumulatorValue(double)
	 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage#getSdfAccumulator_InitialAccumulatorValue()
	 * @model default="0.0" transient="true" volatile="true" derived="true"
	 * @generated
	 */
	double getInitialAccumulatorValue();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.sdflib.SdfAccumulator#getInitialAccumulatorValue <em>Initial Accumulator Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Initial Accumulator Value</em>' attribute.
	 * @see #getInitialAccumulatorValue()
	 * @generated
	 */
	void setInitialAccumulatorValue(double value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void update(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void setup(ModelOfComputation moc, InstantValue initialTime);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation"
	 * @generated
	 */
	double getCurrentValue();

} // SdfAccumulator
