/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: SdfLimiter.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.sdflib;

import fr.supelec.modhelx.core.AtomicBlock;
import fr.supelec.modhelx.core.ModelOfComputation;

import fr.supelec.modhelx.core.time.InstantValue;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Sdf Limiter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.sdflib.SdfLimiter#getLowerBound <em>Lower Bound</em>}</li>
 *   <li>{@link fr.supelec.modhelx.mocs.sdflib.SdfLimiter#getUpperBound <em>Upper Bound</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage#getSdfLimiter()
 * @model
 * @generated
 */
public interface SdfLimiter extends AtomicBlock {
	/**
	 * Returns the value of the '<em><b>Lower Bound</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Lower Bound</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Lower Bound</em>' attribute.
	 * @see #setLowerBound(Object)
	 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage#getSdfLimiter_LowerBound()
	 * @model transient="true" derived="true"
	 * @generated
	 */
	Object getLowerBound();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.sdflib.SdfLimiter#getLowerBound <em>Lower Bound</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Lower Bound</em>' attribute.
	 * @see #getLowerBound()
	 * @generated
	 */
	void setLowerBound(Object value);

	/**
	 * Returns the value of the '<em><b>Upper Bound</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Upper Bound</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Upper Bound</em>' attribute.
	 * @see #setUpperBound(Object)
	 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage#getSdfLimiter_UpperBound()
	 * @model transient="true" derived="true"
	 * @generated
	 */
	Object getUpperBound();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.sdflib.SdfLimiter#getUpperBound <em>Upper Bound</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Upper Bound</em>' attribute.
	 * @see #getUpperBound()
	 * @generated
	 */
	void setUpperBound(Object value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void update(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void setup(ModelOfComputation moc, InstantValue initialTime);

} // SdfLimiter
