/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: SdfPluginBlock.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.sdflib;

import fr.supelec.modhelx.core.AtomicBlock;
import fr.supelec.modhelx.core.ModelOfComputation;

import fr.supelec.modhelx.core.time.InstantValue;

import fr.supelec.modhelx.mocs.sdf.SdfModelOfComputation;
import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Sdf Plugin Block</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.sdflib.SdfPluginBlock#getPluggedInClassName <em>Plugged In Class Name</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage#getSdfPluginBlock()
 * @model
 * @generated
 */
public interface SdfPluginBlock extends AtomicBlock {
	/**
	 * Returns the value of the '<em><b>Plugged In Class Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Plugged In Class Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Plugged In Class Name</em>' attribute.
	 * @see #setPluggedInClassName(String)
	 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage#getSdfPluginBlock_PluggedInClassName()
	 * @model transient="true" volatile="true" derived="true"
	 * @generated
	 */
	String getPluggedInClassName();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.sdflib.SdfPluginBlock#getPluggedInClassName <em>Plugged In Class Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Plugged In Class Name</em>' attribute.
	 * @see #getPluggedInClassName()
	 * @generated
	 */
	void setPluggedInClassName(String value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void setup(ModelOfComputation moc, InstantValue initialTime);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void startOfSnapshot(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void reset(ModelOfComputation moc, InstantValue time);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void update(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean validate(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void endOfSnapshot(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void wrapup(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean snapDet(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model timeConstraintsMany="true"
	 * @generated
	 */
	void collectTimeConstraints(ModelOfComputation moc, EList<InstantValue> timeConstraints);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	boolean newSnap(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model kind="operation"
	 * @generated
	 */
	SdfModelOfComputation getMoC();

} // SdfPluginBlock
