/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: SdfRamp.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.sdflib;

import fr.supelec.modhelx.core.AtomicBlock;
import fr.supelec.modhelx.core.ModelOfComputation;

import fr.supelec.modhelx.core.time.InstantValue;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Sdf Ramp</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.sdflib.SdfRamp#getInitialValue <em>Initial Value</em>}</li>
 *   <li>{@link fr.supelec.modhelx.mocs.sdflib.SdfRamp#getStep <em>Step</em>}</li>
 *   <li>{@link fr.supelec.modhelx.mocs.sdflib.SdfRamp#getModulo <em>Modulo</em>}</li>
 * </ul>
 * </p>
 *
 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage#getSdfRamp()
 * @model
 * @generated
 */
public interface SdfRamp extends AtomicBlock {
	/**
	 * Returns the value of the '<em><b>Initial Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Initial Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Initial Value</em>' attribute.
	 * @see #setInitialValue(Object)
	 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage#getSdfRamp_InitialValue()
	 * @model transient="true" volatile="true" derived="true"
	 * @generated
	 */
	Object getInitialValue();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.sdflib.SdfRamp#getInitialValue <em>Initial Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Initial Value</em>' attribute.
	 * @see #getInitialValue()
	 * @generated
	 */
	void setInitialValue(Object value);

	/**
	 * Returns the value of the '<em><b>Step</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Step</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Step</em>' attribute.
	 * @see #setStep(Object)
	 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage#getSdfRamp_Step()
	 * @model transient="true" volatile="true" derived="true"
	 * @generated
	 */
	Object getStep();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.sdflib.SdfRamp#getStep <em>Step</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Step</em>' attribute.
	 * @see #getStep()
	 * @generated
	 */
	void setStep(Object value);

	/**
	 * Returns the value of the '<em><b>Modulo</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Modulo</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Modulo</em>' attribute.
	 * @see #setModulo(Object)
	 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage#getSdfRamp_Modulo()
	 * @model transient="true" volatile="true" derived="true"
	 * @generated
	 */
	Object getModulo();

	/**
	 * Sets the value of the '{@link fr.supelec.modhelx.mocs.sdflib.SdfRamp#getModulo <em>Modulo</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Modulo</em>' attribute.
	 * @see #getModulo()
	 * @generated
	 */
	void setModulo(Object value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void update(ModelOfComputation moc);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void setup(ModelOfComputation moc, InstantValue initialTime);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void reset(ModelOfComputation moc, InstantValue time);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @model
	 * @generated
	 */
	void endOfSnapshot(ModelOfComputation moc);

} // SdfRamp
