/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: SdflibFactory.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.sdflib;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage
 * @generated
 */
public interface SdflibFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SdflibFactory eINSTANCE = fr.supelec.modhelx.mocs.sdflib.impl.SdflibFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Sdf Constant Emitter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sdf Constant Emitter</em>'.
	 * @generated
	 */
	SdfConstantEmitter createSdfConstantEmitter();

	/**
	 * Returns a new object of class '<em>Sdf Duplicator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sdf Duplicator</em>'.
	 * @generated
	 */
	SdfDuplicator createSdfDuplicator();

	/**
	 * Returns a new object of class '<em>Sdf Adder</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sdf Adder</em>'.
	 * @generated
	 */
	SdfAdder createSdfAdder();

	/**
	 * Returns a new object of class '<em>Sdf Printer</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sdf Printer</em>'.
	 * @generated
	 */
	SdfPrinter createSdfPrinter();

	/**
	 * Returns a new object of class '<em>Sdf Accumulator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sdf Accumulator</em>'.
	 * @generated
	 */
	SdfAccumulator createSdfAccumulator();

	/**
	 * Returns a new object of class '<em>Sdf Threshold</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sdf Threshold</em>'.
	 * @generated
	 */
	SdfThreshold createSdfThreshold();

	/**
	 * Returns a new object of class '<em>Sdf Limiter</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sdf Limiter</em>'.
	 * @generated
	 */
	SdfLimiter createSdfLimiter();

	/**
	 * Returns a new object of class '<em>Sdf Multiplier</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sdf Multiplier</em>'.
	 * @generated
	 */
	SdfMultiplier createSdfMultiplier();

	/**
	 * Returns a new object of class '<em>Sdf Delay</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sdf Delay</em>'.
	 * @generated
	 */
	SdfDelay createSdfDelay();

	/**
	 * Returns a new object of class '<em>Sdf Ramp</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Sdf Ramp</em>'.
	 * @generated
	 */
	SdfRamp createSdfRamp();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	SdflibPackage getSdflibPackage();

} //SdflibFactory
