/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: SdflibPackage.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.sdflib;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

import fr.supelec.modhelx.core.CorePackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.supelec.modhelx.mocs.sdflib.SdflibFactory
 * @model kind="package"
 * @generated
 */
public interface SdflibPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "sdflib";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.supelec.fr/modhelx/2009/sdflib";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "modhelx_sdflib";

	/**
	 * The package content type ID.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eCONTENT_TYPE = "fr.supelec.modhelx.mocs.sdflib";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SdflibPackage eINSTANCE = fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl.init();

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfConstantEmitterImpl <em>Sdf Constant Emitter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfConstantEmitterImpl
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfConstantEmitter()
	 * @generated
	 */
	int SDF_CONSTANT_EMITTER = 0;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_CONSTANT_EMITTER__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_CONSTANT_EMITTER__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_CONSTANT_EMITTER__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_CONSTANT_EMITTER__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_CONSTANT_EMITTER__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Value To Emit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_CONSTANT_EMITTER__VALUE_TO_EMIT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Sdf Constant Emitter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_CONSTANT_EMITTER_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;


	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfDuplicatorImpl <em>Sdf Duplicator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfDuplicatorImpl
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfDuplicator()
	 * @generated
	 */
	int SDF_DUPLICATOR = 1;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DUPLICATOR__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DUPLICATOR__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DUPLICATOR__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DUPLICATOR__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DUPLICATOR__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The number of structural features of the '<em>Sdf Duplicator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DUPLICATOR_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfAdderImpl <em>Sdf Adder</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfAdderImpl
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfAdder()
	 * @generated
	 */
	int SDF_ADDER = 2;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ADDER__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ADDER__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ADDER__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ADDER__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ADDER__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The number of structural features of the '<em>Sdf Adder</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ADDER_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;


	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfPrinterImpl <em>Sdf Printer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfPrinterImpl
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfPrinter()
	 * @generated
	 */
	int SDF_PRINTER = 3;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_PRINTER__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_PRINTER__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_PRINTER__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_PRINTER__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_PRINTER__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Print Stream</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_PRINTER__PRINT_STREAM = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Sdf Printer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_PRINTER_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfAccumulatorImpl <em>Sdf Accumulator</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfAccumulatorImpl
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfAccumulator()
	 * @generated
	 */
	int SDF_ACCUMULATOR = 4;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ACCUMULATOR__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ACCUMULATOR__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ACCUMULATOR__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ACCUMULATOR__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ACCUMULATOR__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Initial Accumulator Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ACCUMULATOR__INITIAL_ACCUMULATOR_VALUE = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Sdf Accumulator</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_ACCUMULATOR_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfThresholdImpl <em>Sdf Threshold</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfThresholdImpl
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfThreshold()
	 * @generated
	 */
	int SDF_THRESHOLD = 5;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_THRESHOLD__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_THRESHOLD__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_THRESHOLD__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_THRESHOLD__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_THRESHOLD__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The number of structural features of the '<em>Sdf Threshold</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_THRESHOLD_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfLimiterImpl <em>Sdf Limiter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfLimiterImpl
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfLimiter()
	 * @generated
	 */
	int SDF_LIMITER = 6;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_LIMITER__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_LIMITER__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_LIMITER__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_LIMITER__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_LIMITER__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Lower Bound</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_LIMITER__LOWER_BOUND = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Upper Bound</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_LIMITER__UPPER_BOUND = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Sdf Limiter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_LIMITER_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfMultiplierImpl <em>Sdf Multiplier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfMultiplierImpl
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfMultiplier()
	 * @generated
	 */
	int SDF_MULTIPLIER = 7;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_MULTIPLIER__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_MULTIPLIER__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_MULTIPLIER__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_MULTIPLIER__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_MULTIPLIER__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The number of structural features of the '<em>Sdf Multiplier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_MULTIPLIER_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfDelayImpl <em>Sdf Delay</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfDelayImpl
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfDelay()
	 * @generated
	 */
	int SDF_DELAY = 8;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DELAY__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DELAY__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DELAY__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DELAY__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DELAY__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Initial Data</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DELAY__INITIAL_DATA = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Sdf Delay</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_DELAY_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfRampImpl <em>Sdf Ramp</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfRampImpl
	 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfRamp()
	 * @generated
	 */
	int SDF_RAMP = 9;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_RAMP__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_RAMP__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_RAMP__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_RAMP__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_RAMP__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Initial Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_RAMP__INITIAL_VALUE = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Step</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_RAMP__STEP = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Modulo</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_RAMP__MODULO = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Sdf Ramp</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SDF_RAMP_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 3;

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.sdflib.SdfConstantEmitter <em>Sdf Constant Emitter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdf Constant Emitter</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfConstantEmitter
	 * @generated
	 */
	EClass getSdfConstantEmitter();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.sdflib.SdfConstantEmitter#getValueToEmit <em>Value To Emit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value To Emit</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfConstantEmitter#getValueToEmit()
	 * @see #getSdfConstantEmitter()
	 * @generated
	 */
	EAttribute getSdfConstantEmitter_ValueToEmit();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.sdflib.SdfDuplicator <em>Sdf Duplicator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdf Duplicator</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfDuplicator
	 * @generated
	 */
	EClass getSdfDuplicator();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.sdflib.SdfAdder <em>Sdf Adder</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdf Adder</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfAdder
	 * @generated
	 */
	EClass getSdfAdder();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.sdflib.SdfPrinter <em>Sdf Printer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdf Printer</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfPrinter
	 * @generated
	 */
	EClass getSdfPrinter();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.sdflib.SdfPrinter#getPrintStream <em>Print Stream</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Print Stream</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfPrinter#getPrintStream()
	 * @see #getSdfPrinter()
	 * @generated
	 */
	EAttribute getSdfPrinter_PrintStream();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.sdflib.SdfAccumulator <em>Sdf Accumulator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdf Accumulator</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfAccumulator
	 * @generated
	 */
	EClass getSdfAccumulator();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.sdflib.SdfAccumulator#getInitialAccumulatorValue <em>Initial Accumulator Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Initial Accumulator Value</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfAccumulator#getInitialAccumulatorValue()
	 * @see #getSdfAccumulator()
	 * @generated
	 */
	EAttribute getSdfAccumulator_InitialAccumulatorValue();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.sdflib.SdfThreshold <em>Sdf Threshold</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdf Threshold</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfThreshold
	 * @generated
	 */
	EClass getSdfThreshold();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.sdflib.SdfLimiter <em>Sdf Limiter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdf Limiter</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfLimiter
	 * @generated
	 */
	EClass getSdfLimiter();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.sdflib.SdfLimiter#getLowerBound <em>Lower Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Lower Bound</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfLimiter#getLowerBound()
	 * @see #getSdfLimiter()
	 * @generated
	 */
	EAttribute getSdfLimiter_LowerBound();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.sdflib.SdfLimiter#getUpperBound <em>Upper Bound</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Upper Bound</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfLimiter#getUpperBound()
	 * @see #getSdfLimiter()
	 * @generated
	 */
	EAttribute getSdfLimiter_UpperBound();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.sdflib.SdfMultiplier <em>Sdf Multiplier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdf Multiplier</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfMultiplier
	 * @generated
	 */
	EClass getSdfMultiplier();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.sdflib.SdfDelay <em>Sdf Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdf Delay</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfDelay
	 * @generated
	 */
	EClass getSdfDelay();

	/**
	 * Returns the meta object for the attribute list '{@link fr.supelec.modhelx.mocs.sdflib.SdfDelay#getInitialData <em>Initial Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Initial Data</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfDelay#getInitialData()
	 * @see #getSdfDelay()
	 * @generated
	 */
	EAttribute getSdfDelay_InitialData();

	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.sdflib.SdfRamp <em>Sdf Ramp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Sdf Ramp</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfRamp
	 * @generated
	 */
	EClass getSdfRamp();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.sdflib.SdfRamp#getInitialValue <em>Initial Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Initial Value</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfRamp#getInitialValue()
	 * @see #getSdfRamp()
	 * @generated
	 */
	EAttribute getSdfRamp_InitialValue();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.sdflib.SdfRamp#getStep <em>Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Step</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfRamp#getStep()
	 * @see #getSdfRamp()
	 * @generated
	 */
	EAttribute getSdfRamp_Step();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.sdflib.SdfRamp#getModulo <em>Modulo</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Modulo</em>'.
	 * @see fr.supelec.modhelx.mocs.sdflib.SdfRamp#getModulo()
	 * @see #getSdfRamp()
	 * @generated
	 */
	EAttribute getSdfRamp_Modulo();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	SdflibFactory getSdflibFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfConstantEmitterImpl <em>Sdf Constant Emitter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfConstantEmitterImpl
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfConstantEmitter()
		 * @generated
		 */
		EClass SDF_CONSTANT_EMITTER = eINSTANCE.getSdfConstantEmitter();

		/**
		 * The meta object literal for the '<em><b>Value To Emit</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDF_CONSTANT_EMITTER__VALUE_TO_EMIT = eINSTANCE.getSdfConstantEmitter_ValueToEmit();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfDuplicatorImpl <em>Sdf Duplicator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfDuplicatorImpl
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfDuplicator()
		 * @generated
		 */
		EClass SDF_DUPLICATOR = eINSTANCE.getSdfDuplicator();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfAdderImpl <em>Sdf Adder</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfAdderImpl
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfAdder()
		 * @generated
		 */
		EClass SDF_ADDER = eINSTANCE.getSdfAdder();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfPrinterImpl <em>Sdf Printer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfPrinterImpl
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfPrinter()
		 * @generated
		 */
		EClass SDF_PRINTER = eINSTANCE.getSdfPrinter();

		/**
		 * The meta object literal for the '<em><b>Print Stream</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDF_PRINTER__PRINT_STREAM = eINSTANCE.getSdfPrinter_PrintStream();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfAccumulatorImpl <em>Sdf Accumulator</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfAccumulatorImpl
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfAccumulator()
		 * @generated
		 */
		EClass SDF_ACCUMULATOR = eINSTANCE.getSdfAccumulator();

		/**
		 * The meta object literal for the '<em><b>Initial Accumulator Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDF_ACCUMULATOR__INITIAL_ACCUMULATOR_VALUE = eINSTANCE.getSdfAccumulator_InitialAccumulatorValue();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfThresholdImpl <em>Sdf Threshold</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfThresholdImpl
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfThreshold()
		 * @generated
		 */
		EClass SDF_THRESHOLD = eINSTANCE.getSdfThreshold();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfLimiterImpl <em>Sdf Limiter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfLimiterImpl
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfLimiter()
		 * @generated
		 */
		EClass SDF_LIMITER = eINSTANCE.getSdfLimiter();

		/**
		 * The meta object literal for the '<em><b>Lower Bound</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDF_LIMITER__LOWER_BOUND = eINSTANCE.getSdfLimiter_LowerBound();

		/**
		 * The meta object literal for the '<em><b>Upper Bound</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDF_LIMITER__UPPER_BOUND = eINSTANCE.getSdfLimiter_UpperBound();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfMultiplierImpl <em>Sdf Multiplier</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfMultiplierImpl
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfMultiplier()
		 * @generated
		 */
		EClass SDF_MULTIPLIER = eINSTANCE.getSdfMultiplier();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfDelayImpl <em>Sdf Delay</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfDelayImpl
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfDelay()
		 * @generated
		 */
		EClass SDF_DELAY = eINSTANCE.getSdfDelay();

		/**
		 * The meta object literal for the '<em><b>Initial Data</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDF_DELAY__INITIAL_DATA = eINSTANCE.getSdfDelay_InitialData();

		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfRampImpl <em>Sdf Ramp</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdfRampImpl
		 * @see fr.supelec.modhelx.mocs.sdflib.impl.SdflibPackageImpl#getSdfRamp()
		 * @generated
		 */
		EClass SDF_RAMP = eINSTANCE.getSdfRamp();

		/**
		 * The meta object literal for the '<em><b>Initial Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDF_RAMP__INITIAL_VALUE = eINSTANCE.getSdfRamp_InitialValue();

		/**
		 * The meta object literal for the '<em><b>Step</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDF_RAMP__STEP = eINSTANCE.getSdfRamp_Step();

		/**
		 * The meta object literal for the '<em><b>Modulo</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SDF_RAMP__MODULO = eINSTANCE.getSdfRamp_Modulo();

	}

} //SdflibPackage
