/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: SdfLimiterImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.sdflib.impl;

import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Token;

import fr.supelec.modhelx.core.impl.AtomicBlockImpl;

import fr.supelec.modhelx.core.time.InstantValue;

import fr.supelec.modhelx.mocs.sdf.SdfModelOfComputation;
import fr.supelec.modhelx.mocs.sdflib.SdfLimiter;
import fr.supelec.modhelx.mocs.sdflib.SdflibPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Sdf Limiter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfLimiterImpl#getLowerBound <em>Lower Bound</em>}</li>
 *   <li>{@link fr.supelec.modhelx.mocs.sdflib.impl.SdfLimiterImpl#getUpperBound <em>Upper Bound</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SdfLimiterImpl extends AtomicBlockImpl implements SdfLimiter {
	/**
	 * The default value of the '{@link #getLowerBound() <em>Lower Bound</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLowerBound()
	 * @generated
	 * @ordered
	 */
	protected static final Object LOWER_BOUND_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getLowerBound() <em>Lower Bound</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLowerBound()
	 * @generated
	 * @ordered
	 */
	protected Object lowerBound = LOWER_BOUND_EDEFAULT;

	/**
	 * The default value of the '{@link #getUpperBound() <em>Upper Bound</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUpperBound()
	 * @generated
	 * @ordered
	 */
	protected static final Object UPPER_BOUND_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getUpperBound() <em>Upper Bound</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getUpperBound()
	 * @generated
	 * @ordered
	 */
	protected Object upperBound = UPPER_BOUND_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SdfLimiterImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return SdflibPackage.Literals.SDF_LIMITER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Object getLowerBound() {
		Object value = getValueOfParameter("lowerBound");
		if (value == null) {
			return LOWER_BOUND_EDEFAULT;
		}
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setLowerBound(Object newLowerBound) {
		Object oldLowerBound = getLowerBound();
		setValueOfParameter("lowerBound", newLowerBound);
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SdflibPackage.SDF_LIMITER__LOWER_BOUND, oldLowerBound, lowerBound));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public Object getUpperBound() {
		Object value = getValueOfParameter("upperBound");
		if (value == null) {
			return UPPER_BOUND_EDEFAULT;
		}
		return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	public void setUpperBound(Object newUpperBound) {
		Object oldUpperBound = getUpperBound();
		setValueOfParameter("upperBound", newUpperBound);
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, SdflibPackage.SDF_LIMITER__UPPER_BOUND, oldUpperBound, upperBound));
	}

	private SdfModelOfComputation getMoc(ModelOfComputation moc) {
		try {
			SdfModelOfComputation m = (SdfModelOfComputation)moc;
			return m;
		}
		catch (ClassCastException ex) {
			throw new Error("SdfConstantEmitter : moc is not SDF");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@SuppressWarnings("unchecked")
	public void update(ModelOfComputation moc) {		
		SdfModelOfComputation sdfMoC = getMoc(moc);
		super.update(sdfMoC);

		Token t = this.getPinsIn().get(0).getToken(true);
		Comparable<Object> tokenValue = (Comparable<Object>)(sdfMoC.getValueOfToken(t));
		Object outvalue = tokenValue;
		if(tokenValue.compareTo(this.getLowerBound())<0){
			outvalue = this.getLowerBound();
		}else if(tokenValue.compareTo(this.getUpperBound())>0){
			outvalue = this.getUpperBound();
		}
		this.getPinsOut().get(0).addToken(sdfMoC.createDataToken(outvalue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@SuppressWarnings ("unchecked")
	public void setup(ModelOfComputation moc, InstantValue initialTime) {
		// This block works with only one input pin and one output pin
		if ((getPinsIn().size() != 1) || (getPinsOut().size() != 1)) {
			throw new Error(getClass().getName() + " blocks must have exactly one input and one output");
		}
		SdfModelOfComputation sdfMoc = (SdfModelOfComputation)moc;
		// It consumes one token on the input pin and produces one token on the output pin at each update
		if ((sdfMoc.getPinRate(getPinsIn().get(0)) != 1) || (sdfMoc.getPinRate(getPinsOut().get(0)) != 1)) {
			throw new Error(getClass().getName() + " input and output pins must have a rate of 1");
		}
		// Its lowerBound and upperBound parameters have to be Comparable (ideally with the same type parameter)
		if (!(getLowerBound() instanceof Comparable<?>) || !(getUpperBound() instanceof Comparable<?>)) {
			throw new Error(getClass().getName() + " lowerBound and upperBound parameters must implement the Comparable interface");
		}
		// The lower bound must be lower or equal to the upper bound 
		Comparable<Object> low = (Comparable<Object>) getLowerBound();
		if (low.compareTo(getUpperBound()) > 0) {
			throw new Error(getClass().getName() + " lowerBound must be lower or equal to upperBound");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case SdflibPackage.SDF_LIMITER__LOWER_BOUND:
				return getLowerBound();
			case SdflibPackage.SDF_LIMITER__UPPER_BOUND:
				return getUpperBound();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case SdflibPackage.SDF_LIMITER__LOWER_BOUND:
				setLowerBound(newValue);
				return;
			case SdflibPackage.SDF_LIMITER__UPPER_BOUND:
				setUpperBound(newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case SdflibPackage.SDF_LIMITER__LOWER_BOUND:
				setLowerBound(LOWER_BOUND_EDEFAULT);
				return;
			case SdflibPackage.SDF_LIMITER__UPPER_BOUND:
				setUpperBound(UPPER_BOUND_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case SdflibPackage.SDF_LIMITER__LOWER_BOUND:
				return LOWER_BOUND_EDEFAULT == null ? lowerBound != null : !LOWER_BOUND_EDEFAULT.equals(lowerBound);
			case SdflibPackage.SDF_LIMITER__UPPER_BOUND:
				return UPPER_BOUND_EDEFAULT == null ? upperBound != null : !UPPER_BOUND_EDEFAULT.equals(upperBound);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (lowerBound: ");
		result.append(this.getLowerBound());
		result.append(", upperBound: ");
		result.append(this.getUpperBound());
		result.append(')');
		return result.toString();
	}

} //SdfLimiterImpl
