/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: SdflibFactoryImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.sdflib.impl;

import fr.supelec.modhelx.mocs.sdflib.*;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;

import fr.supelec.modhelx.mocs.sdflib.SdfAdder;
import fr.supelec.modhelx.mocs.sdflib.SdfConstantEmitter;
import fr.supelec.modhelx.mocs.sdflib.SdfDuplicator;
import fr.supelec.modhelx.mocs.sdflib.SdfPrinter;
import fr.supelec.modhelx.mocs.sdflib.SdflibFactory;
import fr.supelec.modhelx.mocs.sdflib.SdflibPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class SdflibFactoryImpl extends EFactoryImpl implements SdflibFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SdflibFactory init() {
		try {
			SdflibFactory theSdflibFactory = (SdflibFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.supelec.fr/modhelx/2009/sdflib"); 
			if (theSdflibFactory != null) {
				return theSdflibFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new SdflibFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdflibFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case SdflibPackage.SDF_CONSTANT_EMITTER: return createSdfConstantEmitter();
			case SdflibPackage.SDF_DUPLICATOR: return createSdfDuplicator();
			case SdflibPackage.SDF_ADDER: return createSdfAdder();
			case SdflibPackage.SDF_PRINTER: return createSdfPrinter();
			case SdflibPackage.SDF_ACCUMULATOR: return createSdfAccumulator();
			case SdflibPackage.SDF_THRESHOLD: return createSdfThreshold();
			case SdflibPackage.SDF_LIMITER: return createSdfLimiter();
			case SdflibPackage.SDF_MULTIPLIER: return createSdfMultiplier();
			case SdflibPackage.SDF_DELAY: return createSdfDelay();
			case SdflibPackage.SDF_RAMP: return createSdfRamp();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdfConstantEmitter createSdfConstantEmitter() {
		SdfConstantEmitterImpl sdfConstantEmitter = new SdfConstantEmitterImpl();
		return sdfConstantEmitter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdfDuplicator createSdfDuplicator() {
		SdfDuplicatorImpl sdfDuplicator = new SdfDuplicatorImpl();
		return sdfDuplicator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdfAdder createSdfAdder() {
		SdfAdderImpl sdfAdder = new SdfAdderImpl();
		return sdfAdder;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdfPrinter createSdfPrinter() {
		SdfPrinterImpl sdfPrinter = new SdfPrinterImpl();
		return sdfPrinter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdfAccumulator createSdfAccumulator() {
		SdfAccumulatorImpl sdfAccumulator = new SdfAccumulatorImpl();
		return sdfAccumulator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdfThreshold createSdfThreshold() {
		SdfThresholdImpl sdfThreshold = new SdfThresholdImpl();
		return sdfThreshold;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdfLimiter createSdfLimiter() {
		SdfLimiterImpl sdfLimiter = new SdfLimiterImpl();
		return sdfLimiter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdfMultiplier createSdfMultiplier() {
		SdfMultiplierImpl sdfMultiplier = new SdfMultiplierImpl();
		return sdfMultiplier;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdfDelay createSdfDelay() {
		SdfDelayImpl sdfDelay = new SdfDelayImpl();
		return sdfDelay;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdfRamp createSdfRamp() {
		SdfRampImpl sdfRamp = new SdfRampImpl();
		return sdfRamp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdflibPackage getSdflibPackage() {
		return (SdflibPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static SdflibPackage getPackage() {
		return SdflibPackage.eINSTANCE;
	}

} //SdflibFactoryImpl
