/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: SdflibPackageImpl.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.sdflib.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import fr.supelec.modhelx.core.CorePackage;
import fr.supelec.modhelx.core.impl.CorePackageImpl;
import fr.supelec.modhelx.core.java.JavaPackage;
import fr.supelec.modhelx.core.java.impl.JavaPackageImpl;
import fr.supelec.modhelx.core.time.TimePackage;
import fr.supelec.modhelx.core.time.impl.TimePackageImpl;
import fr.supelec.modhelx.corelib.CorelibPackage;
import fr.supelec.modhelx.corelib.impl.CorelibPackageImpl;
import fr.supelec.modhelx.mocs.adapterlib.AdapterlibPackage;
import fr.supelec.modhelx.mocs.adapterlib.impl.AdapterlibPackageImpl;
import fr.supelec.modhelx.mocs.autosar.AutosarPackage;
import fr.supelec.modhelx.mocs.autosar.impl.AutosarPackageImpl;
import fr.supelec.modhelx.mocs.de.DePackage;
import fr.supelec.modhelx.mocs.de.impl.DePackageImpl;
import fr.supelec.modhelx.mocs.delib.DelibPackage;
import fr.supelec.modhelx.mocs.delib.impl.DelibPackageImpl;
import fr.supelec.modhelx.mocs.fsm.FsmPackage;
import fr.supelec.modhelx.mocs.fsm.impl.FsmPackageImpl;
import fr.supelec.modhelx.mocs.fsmlib.FsmlibPackage;
import fr.supelec.modhelx.mocs.fsmlib.impl.FsmlibPackageImpl;
import fr.supelec.modhelx.mocs.petrinet.PetrinetPackage;
import fr.supelec.modhelx.mocs.petrinet.impl.PetrinetPackageImpl;
import fr.supelec.modhelx.mocs.polymoclib.PolymoclibPackage;
import fr.supelec.modhelx.mocs.polymoclib.impl.PolymoclibPackageImpl;
import fr.supelec.modhelx.mocs.sdf.SdfPackage;
import fr.supelec.modhelx.mocs.sdf.impl.SdfPackageImpl;
import fr.supelec.modhelx.mocs.sdflib.SdfAccumulator;
import fr.supelec.modhelx.mocs.sdflib.SdfAdder;
import fr.supelec.modhelx.mocs.sdflib.SdfConstantEmitter;
import fr.supelec.modhelx.mocs.sdflib.SdfDelay;
import fr.supelec.modhelx.mocs.sdflib.SdfDuplicator;
import fr.supelec.modhelx.mocs.sdflib.SdfLimiter;
import fr.supelec.modhelx.mocs.sdflib.SdfMultiplier;
import fr.supelec.modhelx.mocs.sdflib.SdfPrinter;
import fr.supelec.modhelx.mocs.sdflib.SdfRamp;
import fr.supelec.modhelx.mocs.sdflib.SdfThreshold;
import fr.supelec.modhelx.mocs.sdflib.SdflibFactory;
import fr.supelec.modhelx.mocs.sdflib.SdflibPackage;
import fr.supelec.modhelx.mocs.simple.SimplePackage;
import fr.supelec.modhelx.mocs.simple.impl.SimplePackageImpl;
import fr.supelec.modhelx.mocs.tfsm.TfsmPackage;
import fr.supelec.modhelx.mocs.tfsm.impl.TfsmPackageImpl;
import fr.supelec.modhelx.mocs.tfsmlib.TfsmlibPackage;
import fr.supelec.modhelx.mocs.tfsmlib.impl.TfsmlibPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class SdflibPackageImpl extends EPackageImpl implements SdflibPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdfConstantEmitterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdfDuplicatorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdfAdderEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdfPrinterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdfAccumulatorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdfThresholdEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdfLimiterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdfMultiplierEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdfDelayEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass sdfRampEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see fr.supelec.modhelx.mocs.sdflib.SdflibPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private SdflibPackageImpl() {
		super(eNS_URI, SdflibFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link SdflibPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static SdflibPackage init() {
		if (isInited) return (SdflibPackage)EPackage.Registry.INSTANCE.getEPackage(SdflibPackage.eNS_URI);

		// Obtain or create and register package
		SdflibPackageImpl theSdflibPackage = (SdflibPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof SdflibPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new SdflibPackageImpl());

		isInited = true;

		// Obtain or create and register interdependencies
		CorePackageImpl theCorePackage = (CorePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI) instanceof CorePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI) : CorePackage.eINSTANCE);
		TimePackageImpl theTimePackage = (TimePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI) instanceof TimePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI) : TimePackage.eINSTANCE);
		JavaPackageImpl theJavaPackage = (JavaPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(JavaPackage.eNS_URI) instanceof JavaPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(JavaPackage.eNS_URI) : JavaPackage.eINSTANCE);
		DePackageImpl theDePackage = (DePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(DePackage.eNS_URI) instanceof DePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(DePackage.eNS_URI) : DePackage.eINSTANCE);
		SimplePackageImpl theSimplePackage = (SimplePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SimplePackage.eNS_URI) instanceof SimplePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SimplePackage.eNS_URI) : SimplePackage.eINSTANCE);
		DelibPackageImpl theDelibPackage = (DelibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(DelibPackage.eNS_URI) instanceof DelibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(DelibPackage.eNS_URI) : DelibPackage.eINSTANCE);
		FsmPackageImpl theFsmPackage = (FsmPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FsmPackage.eNS_URI) instanceof FsmPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FsmPackage.eNS_URI) : FsmPackage.eINSTANCE);
		FsmlibPackageImpl theFsmlibPackage = (FsmlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FsmlibPackage.eNS_URI) instanceof FsmlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FsmlibPackage.eNS_URI) : FsmlibPackage.eINSTANCE);
		AdapterlibPackageImpl theAdapterlibPackage = (AdapterlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AdapterlibPackage.eNS_URI) instanceof AdapterlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AdapterlibPackage.eNS_URI) : AdapterlibPackage.eINSTANCE);
		SdfPackageImpl theSdfPackage = (SdfPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SdfPackage.eNS_URI) instanceof SdfPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SdfPackage.eNS_URI) : SdfPackage.eINSTANCE);
		PetrinetPackageImpl thePetrinetPackage = (PetrinetPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PetrinetPackage.eNS_URI) instanceof PetrinetPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PetrinetPackage.eNS_URI) : PetrinetPackage.eINSTANCE);
		PolymoclibPackageImpl thePolymoclibPackage = (PolymoclibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PolymoclibPackage.eNS_URI) instanceof PolymoclibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PolymoclibPackage.eNS_URI) : PolymoclibPackage.eINSTANCE);
		AutosarPackageImpl theAutosarPackage = (AutosarPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) instanceof AutosarPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(AutosarPackage.eNS_URI) : AutosarPackage.eINSTANCE);
		TfsmPackageImpl theTfsmPackage = (TfsmPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TfsmPackage.eNS_URI) instanceof TfsmPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TfsmPackage.eNS_URI) : TfsmPackage.eINSTANCE);
		TfsmlibPackageImpl theTfsmlibPackage = (TfsmlibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TfsmlibPackage.eNS_URI) instanceof TfsmlibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TfsmlibPackage.eNS_URI) : TfsmlibPackage.eINSTANCE);
		CorelibPackageImpl theCorelibPackage = (CorelibPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CorelibPackage.eNS_URI) instanceof CorelibPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CorelibPackage.eNS_URI) : CorelibPackage.eINSTANCE);

		// Create package meta-data objects
		theSdflibPackage.createPackageContents();
		theCorePackage.createPackageContents();
		theTimePackage.createPackageContents();
		theJavaPackage.createPackageContents();
		theDePackage.createPackageContents();
		theSimplePackage.createPackageContents();
		theDelibPackage.createPackageContents();
		theFsmPackage.createPackageContents();
		theFsmlibPackage.createPackageContents();
		theAdapterlibPackage.createPackageContents();
		theSdfPackage.createPackageContents();
		thePetrinetPackage.createPackageContents();
		thePolymoclibPackage.createPackageContents();
		theAutosarPackage.createPackageContents();
		theTfsmPackage.createPackageContents();
		theTfsmlibPackage.createPackageContents();
		theCorelibPackage.createPackageContents();

		// Initialize created meta-data
		theSdflibPackage.initializePackageContents();
		theCorePackage.initializePackageContents();
		theTimePackage.initializePackageContents();
		theJavaPackage.initializePackageContents();
		theDePackage.initializePackageContents();
		theSimplePackage.initializePackageContents();
		theDelibPackage.initializePackageContents();
		theFsmPackage.initializePackageContents();
		theFsmlibPackage.initializePackageContents();
		theAdapterlibPackage.initializePackageContents();
		theSdfPackage.initializePackageContents();
		thePetrinetPackage.initializePackageContents();
		thePolymoclibPackage.initializePackageContents();
		theAutosarPackage.initializePackageContents();
		theTfsmPackage.initializePackageContents();
		theTfsmlibPackage.initializePackageContents();
		theCorelibPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theSdflibPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(SdflibPackage.eNS_URI, theSdflibPackage);
		return theSdflibPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdfConstantEmitter() {
		return sdfConstantEmitterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdfConstantEmitter_ValueToEmit() {
		return (EAttribute)sdfConstantEmitterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdfDuplicator() {
		return sdfDuplicatorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdfAdder() {
		return sdfAdderEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdfPrinter() {
		return sdfPrinterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdfPrinter_PrintStream() {
		return (EAttribute)sdfPrinterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdfAccumulator() {
		return sdfAccumulatorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdfAccumulator_InitialAccumulatorValue() {
		return (EAttribute)sdfAccumulatorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdfThreshold() {
		return sdfThresholdEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdfLimiter() {
		return sdfLimiterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdfLimiter_LowerBound() {
		return (EAttribute)sdfLimiterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdfLimiter_UpperBound() {
		return (EAttribute)sdfLimiterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdfMultiplier() {
		return sdfMultiplierEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdfDelay() {
		return sdfDelayEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdfDelay_InitialData() {
		return (EAttribute)sdfDelayEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSdfRamp() {
		return sdfRampEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdfRamp_InitialValue() {
		return (EAttribute)sdfRampEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdfRamp_Step() {
		return (EAttribute)sdfRampEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSdfRamp_Modulo() {
		return (EAttribute)sdfRampEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SdflibFactory getSdflibFactory() {
		return (SdflibFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		sdfConstantEmitterEClass = createEClass(SDF_CONSTANT_EMITTER);
		createEAttribute(sdfConstantEmitterEClass, SDF_CONSTANT_EMITTER__VALUE_TO_EMIT);

		sdfDuplicatorEClass = createEClass(SDF_DUPLICATOR);

		sdfAdderEClass = createEClass(SDF_ADDER);

		sdfPrinterEClass = createEClass(SDF_PRINTER);
		createEAttribute(sdfPrinterEClass, SDF_PRINTER__PRINT_STREAM);

		sdfAccumulatorEClass = createEClass(SDF_ACCUMULATOR);
		createEAttribute(sdfAccumulatorEClass, SDF_ACCUMULATOR__INITIAL_ACCUMULATOR_VALUE);

		sdfThresholdEClass = createEClass(SDF_THRESHOLD);

		sdfLimiterEClass = createEClass(SDF_LIMITER);
		createEAttribute(sdfLimiterEClass, SDF_LIMITER__LOWER_BOUND);
		createEAttribute(sdfLimiterEClass, SDF_LIMITER__UPPER_BOUND);

		sdfMultiplierEClass = createEClass(SDF_MULTIPLIER);

		sdfDelayEClass = createEClass(SDF_DELAY);
		createEAttribute(sdfDelayEClass, SDF_DELAY__INITIAL_DATA);

		sdfRampEClass = createEClass(SDF_RAMP);
		createEAttribute(sdfRampEClass, SDF_RAMP__INITIAL_VALUE);
		createEAttribute(sdfRampEClass, SDF_RAMP__STEP);
		createEAttribute(sdfRampEClass, SDF_RAMP__MODULO);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		CorePackage theCorePackage = (CorePackage)EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI);
		TimePackage theTimePackage = (TimePackage)EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		sdfConstantEmitterEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		sdfDuplicatorEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		sdfAdderEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		sdfPrinterEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		sdfAccumulatorEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		sdfThresholdEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		sdfLimiterEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		sdfMultiplierEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		sdfDelayEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());
		sdfRampEClass.getESuperTypes().add(theCorePackage.getAtomicBlock());

		// Initialize classes and features; add operations and parameters
		initEClass(sdfConstantEmitterEClass, SdfConstantEmitter.class, "SdfConstantEmitter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSdfConstantEmitter_ValueToEmit(), ecorePackage.getEJavaObject(), "valueToEmit", null, 0, 1, SdfConstantEmitter.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		EOperation op = addEOperation(sdfConstantEmitterEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfConstantEmitterEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(sdfDuplicatorEClass, SdfDuplicator.class, "SdfDuplicator", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(sdfDuplicatorEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfDuplicatorEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(sdfAdderEClass, SdfAdder.class, "SdfAdder", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(sdfAdderEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfAdderEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfAdderEClass, null, "setMultFactor", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "multFactor", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfAdderEClass, ecorePackage.getEDouble(), "getMultFactor", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfAdderEClass, ecorePackage.getEBoolean(), "hasMultFactor", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(sdfPrinterEClass, SdfPrinter.class, "SdfPrinter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSdfPrinter_PrintStream(), ecorePackage.getEJavaObject(), "printStream", null, 0, 1, SdfPrinter.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = addEOperation(sdfPrinterEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfPrinterEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(sdfAccumulatorEClass, SdfAccumulator.class, "SdfAccumulator", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSdfAccumulator_InitialAccumulatorValue(), ecorePackage.getEDouble(), "initialAccumulatorValue", "0.0", 0, 1, SdfAccumulator.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		op = addEOperation(sdfAccumulatorEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfAccumulatorEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(sdfAccumulatorEClass, ecorePackage.getEDouble(), "getCurrentValue", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(sdfThresholdEClass, SdfThreshold.class, "SdfThreshold", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(sdfThresholdEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfThresholdEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfThresholdEClass, null, "setThresholdGT", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "threshold", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfThresholdEClass, null, "setThresholdGEQ", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "threshold", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfThresholdEClass, null, "setThresholdLEQ", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "threshold", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfThresholdEClass, null, "setThresholdLT", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "threshold", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfThresholdEClass, ecorePackage.getEDouble(), "getThresholdGT", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfThresholdEClass, ecorePackage.getEDouble(), "getThresholdGEQ", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfThresholdEClass, ecorePackage.getEDouble(), "getThresholdLT", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfThresholdEClass, ecorePackage.getEDouble(), "getThresholdLEQ", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(sdfLimiterEClass, SdfLimiter.class, "SdfLimiter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSdfLimiter_LowerBound(), ecorePackage.getEJavaObject(), "lowerBound", null, 0, 1, SdfLimiter.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getSdfLimiter_UpperBound(), ecorePackage.getEJavaObject(), "upperBound", null, 0, 1, SdfLimiter.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		op = addEOperation(sdfLimiterEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfLimiterEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(sdfMultiplierEClass, SdfMultiplier.class, "SdfMultiplier", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = addEOperation(sdfMultiplierEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfMultiplierEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfMultiplierEClass, null, "setExponent", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDouble(), "exponent", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfMultiplierEClass, ecorePackage.getEDouble(), "getExponent", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfMultiplierEClass, ecorePackage.getEBoolean(), "hasExponent", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getPin(), "pin", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(sdfDelayEClass, SdfDelay.class, "SdfDelay", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSdfDelay_InitialData(), ecorePackage.getEJavaObject(), "initialData", null, 0, -1, SdfDelay.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		op = addEOperation(sdfDelayEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfDelayEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfDelayEClass, null, "endOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfDelayEClass, null, "reset", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "time", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(sdfRampEClass, SdfRamp.class, "SdfRamp", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSdfRamp_InitialValue(), ecorePackage.getEJavaObject(), "initialValue", null, 0, 1, SdfRamp.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getSdfRamp_Step(), ecorePackage.getEJavaObject(), "step", null, 0, 1, SdfRamp.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getSdfRamp_Modulo(), ecorePackage.getEJavaObject(), "modulo", null, 0, 1, SdfRamp.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		op = addEOperation(sdfRampEClass, null, "update", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfRampEClass, null, "setup", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "initialTime", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfRampEClass, null, "reset", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theTimePackage.getInstantValue(), "time", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(sdfRampEClass, null, "endOfSnapshot", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theCorePackage.getModelOfComputation(), "moc", 0, 1, IS_UNIQUE, IS_ORDERED);

		// Create resource
		createResource(eNS_URI);
	}

} //SdflibPackageImpl
