/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: TfsmlibPackage.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.mocs.tfsmlib;

import fr.supelec.modhelx.core.CorePackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see fr.supelec.modhelx.mocs.tfsmlib.TfsmlibFactory
 * @model kind="package"
 * @generated
 */
public interface TfsmlibPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "tfsmlib";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.supelec.fr/modhelx/2009/tfsmlib";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "modhelx_tfsmlib";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	TfsmlibPackage eINSTANCE = fr.supelec.modhelx.mocs.tfsmlib.impl.TfsmlibPackageImpl.init();

	/**
	 * The meta object id for the '{@link fr.supelec.modhelx.mocs.tfsmlib.impl.TFsmAfterGuardImpl <em>TFsm After Guard</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see fr.supelec.modhelx.mocs.tfsmlib.impl.TFsmAfterGuardImpl
	 * @see fr.supelec.modhelx.mocs.tfsmlib.impl.TfsmlibPackageImpl#getTFsmAfterGuard()
	 * @generated
	 */
	int TFSM_AFTER_GUARD = 0;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TFSM_AFTER_GUARD__PARAMETERS = CorePackage.ATOMIC_BLOCK__PARAMETERS;

	/**
	 * The feature id for the '<em><b>Pins In</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TFSM_AFTER_GUARD__PINS_IN = CorePackage.ATOMIC_BLOCK__PINS_IN;

	/**
	 * The feature id for the '<em><b>Pins Out</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TFSM_AFTER_GUARD__PINS_OUT = CorePackage.ATOMIC_BLOCK__PINS_OUT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TFSM_AFTER_GUARD__NAME = CorePackage.ATOMIC_BLOCK__NAME;

	/**
	 * The feature id for the '<em><b>Container</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TFSM_AFTER_GUARD__CONTAINER = CorePackage.ATOMIC_BLOCK__CONTAINER;

	/**
	 * The feature id for the '<em><b>Duration</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TFSM_AFTER_GUARD__DURATION = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>TFsm After Guard</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TFSM_AFTER_GUARD_FEATURE_COUNT = CorePackage.ATOMIC_BLOCK_FEATURE_COUNT + 1;


	/**
	 * Returns the meta object for class '{@link fr.supelec.modhelx.mocs.tfsmlib.TFsmAfterGuard <em>TFsm After Guard</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>TFsm After Guard</em>'.
	 * @see fr.supelec.modhelx.mocs.tfsmlib.TFsmAfterGuard
	 * @generated
	 */
	EClass getTFsmAfterGuard();

	/**
	 * Returns the meta object for the attribute '{@link fr.supelec.modhelx.mocs.tfsmlib.TFsmAfterGuard#getDuration <em>Duration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Duration</em>'.
	 * @see fr.supelec.modhelx.mocs.tfsmlib.TFsmAfterGuard#getDuration()
	 * @see #getTFsmAfterGuard()
	 * @generated
	 */
	EAttribute getTFsmAfterGuard_Duration();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	TfsmlibFactory getTfsmlibFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link fr.supelec.modhelx.mocs.tfsmlib.impl.TFsmAfterGuardImpl <em>TFsm After Guard</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see fr.supelec.modhelx.mocs.tfsmlib.impl.TFsmAfterGuardImpl
		 * @see fr.supelec.modhelx.mocs.tfsmlib.impl.TfsmlibPackageImpl#getTFsmAfterGuard()
		 * @generated
		 */
		EClass TFSM_AFTER_GUARD = eINSTANCE.getTFsmAfterGuard();

		/**
		 * The meta object literal for the '<em><b>Duration</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TFSM_AFTER_GUARD__DURATION = eINSTANCE.getTFsmAfterGuard_Duration();

	}

} //TfsmlibPackage
