package fr.supelec.modhelx.qdgui;

import java.util.ArrayList;
import java.util.List;
import java.util.Map.Entry;

import org.eclipse.emf.common.util.EMap;

import fr.supelec.graphbench.Vertex;
import fr.supelec.modhelx.core.Block;
import fr.supelec.modhelx.core.ModHelXObject;
import fr.supelec.modhelx.core.Pin;

public class Common {
	public static String getToolTip(ModHelXObject object, String toAdd) {
		EMap<String, Object> params = object.getParameters();
		if(params.size() == 0 && toAdd == null) return null;
		StringBuffer res = new StringBuffer("<html>").append(object.getClass().getSimpleName()).append("<br>Parameters:<br>");
		boolean first = true;
		for(Entry<String, Object> e : params.entrySet()) {
			if(!first) res.append("<br>");
			first = false;
			res.append("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;").append(e.getKey()).append(" = ").append(e.getValue());
		}

		if(toAdd != null) res.append(toAdd);
		
		res.append("</html>");
		return res.toString();
	}
	
	public static StringBuffer serializeVertexPlacement(VertexAdapter v, StringBuffer contents) {
    	StringBuffer res = new StringBuffer("<block name=\"")
		    	.append(v.getBlock().getName())
				.append("\" x=\"")
				.append(((Vertex)v).getX())
				.append("\" y=\"")
				.append(((Vertex)v).getY());
    	if(v instanceof CompositeVertexAdapter) {
			res.append("\" width=\"")
				.append(((Vertex)v).getWidth())
				.append("\" height=\"")
				.append(((Vertex)v).getHeight());
    	}
    	res.append("\"");
    	if(contents == null || contents.length() == 0)
    		return res.append(" />");
    	else return res.append(">\n").append(contents).append("</block>");
	}
	
	public static void setSockets(Block block, Vertex vertex, List<SocketAdapter> sockets, boolean renderPinNames) {
		// create a list of all (in- and out-) pins
		List<Pin> pins = new ArrayList<Pin>(block.getPinsIn());
		pins.addAll(block.getPinsOut());
		
		for(Pin p : pins) {
			SocketAdapter socket = new SocketAdapter(p, vertex, renderPinNames);
			sockets.add(socket);
		}
	}
}
