package fr.supelec.modhelx.qdgui;

import java.io.PrintStream;

import fr.supelec.graphbench.ControlPoint;
import fr.supelec.graphbench.DefaultEdge;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.Relation;

public class EdgeAdapter extends DefaultEdge {
	private final Relation relation;
	
	public EdgeAdapter(CompositeVertexAdapter composite, Relation relation) {
		super(
				composite,
				composite.getSocketForPin(relation.getSource()),
				composite.getSocketForPin(relation.getTarget()));
		
		this.relation = relation;
//		this.composite = composite;
		
		if(getFromSocket() == null || getToSocket() == null)
			throw new Error("Failed to create an edge adapter for relation " + relation +
					": from=" + getFromSocket() + " (should be " + relation.getSource() + 
					"), to=" + getToSocket() + " (should be " + relation.getTarget() + ")");
	}

	@Override
	public void writeElementAttributes(PrintStream s) {
		// TODO Auto-generated method stub

	}

	public String toString() {
		return "Relation " + relation.getName();
	}
	
	public Relation getRelation() {
		return relation;
	}
	
    @Override
    public String getToolTip() {
    	return Common.getToolTip(relation, null);
    }

	public StringBuffer serializePlacement() {
		if(controlPoints.size() == 0) return null;
		StringBuffer res = new StringBuffer("\t<edge ").append(serializePin(relation.getSource(), "from"));
		res.append(' ').append(serializePin(relation.getTarget(), "to")).append(">\n");
		for(ControlPoint p : controlPoints) {
			res.append("\t\t<point x=\"").append(p.getX()).append("\" y=\"").append(p.getY()).append("\" />\n");
		}
		res.append("\t</edge>");
		return res;
	}
	
	private static StringBuffer serializePin(Pin p, String prefix) {
		StringBuffer res = new StringBuffer(prefix).append("Block=\"");
		if(p.getInputOf() != null) res.append(p.getInputOf().getName());
		else res.append(p.getOutputOf().getName());
		res.append("\" ").append(prefix).append("Pin=\"").append(p.getName()).append('"');
		return res;
	}
}
