package fr.supelec.modhelx.qdgui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;

import javax.swing.JPanel;

import fr.supelec.modhelx.engine.Platform.LagListener;

public class LagGauge extends JPanel implements LagListener {
	private static final long serialVersionUID = 923190737215705258L;
	
	private double lag;

	public LagGauge() {
		setPreferredSize(new Dimension(100, 20));
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		
		Color c;
		int totalWidth = getWidth() - 10;
		int barWidth;
		int barHeight = getHeight() - 10;
		
		synchronized(this) {
			if(lag < .7) c = Color.GREEN;
			else if(lag < .9) c = Color.ORANGE;
			else c = Color.RED;
			
			barWidth = (int)(totalWidth * lag);
		}
		
		g.setColor(c);
		g.fillRect(5, 5, barWidth, barHeight);
		
		g.setColor(Color.GRAY);
		g.drawRect(5, 5, totalWidth, barHeight);
	}

	public void updateLag(double lag) {
		synchronized(this) {
			this.lag = lag;
		}
		repaint();
	}
}
