package fr.supelec.modhelx.qdgui.rendering;

import java.awt.Color;
import java.awt.Graphics;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JMenuItem;

import fr.supelec.graphbench.Vertex;
import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.qdgui.CompositeVertexAdapter;

public abstract class AbstractVertexRenderer implements VertexRenderer {
	private final static Color[] SHADOW_COLOR = new Color[] {
		new Color(.3f, .3f, .3f),
		new Color(.5f, .5f, .5f),
		new Color(.7f, .7f, .7f)
	};

	public List<JMenuItem> getMenuItems(RendererParameters params) {
		return new ArrayList<JMenuItem>(0);
	}

	public boolean renderPinNames() {
		return true;
	}

	public RenderInternals renderInternals() {
		return RenderInternals.RENDER_ALL;
	}
	
	protected ModelOfComputation getMoc(RendererParameters params) {
		return ((CompositeVertexAdapter)((Vertex)params.vertex).getParent()).getMoc();
	}
	
	protected void drawRectShadow(Graphics g, int x, int y, int width, int height) {
		for(int i=0; i<3; i++) {
			g.setColor(SHADOW_COLOR[i]);
			g.drawLine(x+i, y+height+i, x+width+i, y+height+i);
			g.drawLine(x+width+i, y+i, x+width+i, y+height+i);
		}
	}

	protected void drawOvalShadow(Graphics g, int x, int y, int width, int height) {
		for(int i=0; i<3; i++) {
			g.setColor(SHADOW_COLOR[i]);
			g.fillOval(x+i, y+i+1, width, height);
		}
		
	}
}
