package fr.supelec.modhelx.qdgui.rendering;

import java.awt.Graphics;
import java.awt.Graphics2D;

import fr.supelec.modhelx.core.Block;
import fr.supelec.modhelx.mocs.delib.DeRampEmitter;
import fr.supelec.modhelx.mocs.delib.impl.DeRampEmitterImpl;

public class DERampEmitterR extends DefaultAtomicVertexRenderer {

	public void render(RendererParameters params, Graphics g_, int x, int y, boolean selected) {
		Graphics2D g = (Graphics2D)g_;
		
		super.render(params, g, x, y, selected);
		
		g.translate(x, y);
		
		
		
		Object val = ((DeRampEmitterImpl)(params.vertex.getBlock())).getCurrentValue();
		
		g.drawString(val == null ? "" : val.toString(), 10, 20);
		
		g.translate(-x, -y);
	}
	
	public boolean renderPinNames() {
		return true;
	}

	private DERampEmitterR() {
		super(DeRampEmitter.class, null);
	}
	
	private final static DERampEmitterR instance;
	
	static {
		instance = new DERampEmitterR();
	}
	
	public static void register() {
		VertexRenderers.register(instance);
	}

	@Override
	public boolean accept(Block block) {
		return block instanceof DeRampEmitter;
	}
}
