package fr.supelec.modhelx.qdgui.rendering;

import java.awt.Color;
import java.awt.Graphics;

import fr.supelec.modhelx.core.Block;
import fr.supelec.modhelx.qdgui.CompositeVertexAdapter;

public class DefaultCompositeRenderer extends DefaultGenericVertexRenderer {
	public final static DefaultCompositeRenderer DEFAULT_COMPOSITE_RENDERER = new DefaultCompositeRenderer();
	private final static int resizePadSize = CompositeVertexAdapter.RESIZE_PAD_SIZE;
	
	public boolean accept(Block block) {
		return true;
	}

	public void render(RendererParameters params, Graphics g, int x, int y, boolean selected) {
		super.render(params, g, x, y, selected, ((CompositeVertexAdapter)params.vertex).getBackgroundColor());
		
		final int width = params.width;
		final int height = params.height;

		g.setColor(selected ? Color.RED : Color.BLACK);
		g.fillRect(x+width-resizePadSize, y+height-resizePadSize, resizePadSize, resizePadSize);
	}
}
