package fr.supelec.modhelx.qdgui.rendering;

import java.awt.Image;
import java.awt.Toolkit;
import java.net.URL;

public class Icons {
	public static Image INT = getIcon("int.png");
	public static Image PLUS = getIcon("plus.png");
	public static Image SUM = getIcon("sum.png");
	public static Image TIMES = getIcon("times.png");
	
	private static Image getIcon(String iconFilename) {
		if(iconFilename == null) return null;
		// In workspace
		URL url = Icons.class.getResource( "/fr/supelec/modhelx/qdgui/icons/" + iconFilename );
		if( url == null ) {
			// In installed plugin
			url = Icons.class.getResource( "/src/fr/supelec/modhelx/qdgui/icons/" + iconFilename );
		}
		if( url == null ) {
			System.err.println( "Unable to get icon " + iconFilename );
			return null;
		}
		Image img = Toolkit.getDefaultToolkit().getImage(url);
				
		return img;
	}
}
