package fr.supelec.modhelx.qdgui.rendering;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;

import fr.supelec.graphbench.Socket;
import fr.supelec.modhelx.core.Block;
import fr.supelec.modhelx.mocs.petrinet.PetriNetModelOfComputation;
import fr.supelec.modhelx.qdgui.VertexAdapter;


public class PetriNetTransitionR extends AbstractVertexRenderer {
	public RendererParameters calculateRendererParameters(VertexAdapter vertex) {
		RendererParameters params = new RendererParameters(vertex, 30, 40);
		recalculatePortPositions(params);
		return params;
	}


	public void recalculatePortPositions(RendererParameters params) {
		for(Socket s : params.vertex.getSocketList()) {
			switch(s.getDirection()) {
			case IN: s.setPosition(0, 20); break;
			case OUT: s.setPosition(30, 20); break;
			}
		}
	}

	public void render(RendererParameters params, Graphics g_, int x, int y, boolean selected) {
		Graphics2D g = (Graphics2D)g_;
		
		g.translate(x, y);
		
		g.setColor(selected ? Color.RED : Color.BLACK);
		g.drawLine(0, 20, 30, 20);
		
		g.drawString(params.vertex.getBlock().getName(), 23, -1);

		g.fillRect(12, 0, 6, 40);
		
		g.translate(-x, -y);
	}
	
	public boolean renderPinNames() {
		return false;
	}
	
	private PetriNetTransitionR() {}
	
	private final static PetriNetTransitionR instance;
	
	static {
		instance = new PetriNetTransitionR();
	}
	
	public static void register() {
		VertexRenderers.register(instance);
	}

	public boolean accept(Block block) {
		return PetriNetModelOfComputation.ROLE_TRANSITION.equals(
				block.getParameters().get(PetriNetModelOfComputation.ROLE_ATTRIBUTE));
	}
}
