package fr.supelec.modhelx.qdgui.rendering;

import java.awt.Graphics;
import java.util.List;

import javax.swing.JMenuItem;

import fr.supelec.modhelx.core.Block;
import fr.supelec.modhelx.qdgui.VertexAdapter;

public interface VertexRenderer {
	public RendererParameters calculateRendererParameters(VertexAdapter vertex);
	public void recalculatePortPositions(RendererParameters params);
	public void render(RendererParameters params, Graphics g, int x, int y, boolean selected);
	public boolean renderPinNames();
    public List<JMenuItem> getMenuItems(RendererParameters params);
    public RenderInternals renderInternals();
	public abstract boolean accept(Block block);
	

    /*
    
    protected void drawRectangle(VertexAdapter va, Graphics g, int x, int y, boolean selected) {
		g.setColor(Color.WHITE);
		g.fillRect(x, y, getWidth(), getHeight());
		g.setColor(selected ? Color.RED : Color.BLACK);
		g.drawRect(x, y, getWidth(), getHeight());
		
		
		g.drawString(va.getBlock().getName(), x, y-1);
		
    }
    
    */

	public static enum RenderInternals {
		RENDER_NOTHING(0),
		RENDER_BLOCKS(1),
		RENDER_BLOCKS_AND_INTER_BLOCK_RELATIONS(2),
		RENDER_ALL(3);
		
		private final int level;
		
		private RenderInternals(int level) {
			this.level = level;
		}
		
		public boolean atLeast(RenderInternals minValue) {
			return level >= minValue.level;
		}
	}
}
