package fr.supelec.modhelx.qdgui.rendering;

import java.util.LinkedList;
import java.util.List;

import fr.supelec.modhelx.core.AtomicBlock;
import fr.supelec.modhelx.core.Block;

public class VertexRenderers {
	private final static List<VertexRenderer> customVertexRenderers =
		new LinkedList<VertexRenderer> ();
	
	public static void register(VertexRenderer renderer) {
		customVertexRenderers.add(renderer);
	}
	
	public static VertexRenderer forBlock(Block block) {
		for(VertexRenderer r : customVertexRenderers) {
			if(r.accept(block))	return r;
		}
		
		if(block instanceof AtomicBlock)
			return DefaultAtomicVertexRenderer.DEFAULT_ATOMIC_RENDERER;
		else return DefaultCompositeRenderer.DEFAULT_COMPOSITE_RENDERER;
	}

}
