/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: TestDE_1_GUI.java 331 2011-03-11 12:01:35Z marcadet $
 */

package fr.supelec.modhelx.tests;

import fr.supelec.graphbench.CompositeVertex;
import fr.supelec.graphbench.Vertex;
import fr.supelec.graphbench.ui.DndSource;
import fr.supelec.graphbench.ui.VertexInstantiator;
import fr.supelec.modhelx.core.CoreFactory;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.mocs.de.DeModelOfComputation;
import fr.supelec.modhelx.mocs.delib.DeConstantEmitter;
import fr.supelec.modhelx.mocs.delib.DeEventPrinter;
import fr.supelec.modhelx.mocs.delib.DelibFactory;
import fr.supelec.modhelx.qdgui.AtomicVertexAdapter;
import fr.supelec.modhelx.qdgui.CompositeVertexAdapter;
import fr.supelec.modhelx.qdgui.ModelWindow;

public class TestDE_1_GUI extends TestDE_1 {

	// this was a test to add a toolbox
	// it does not matter for visualization
	private static final DndSource[] deToolbox = {
		new DndSource(new VertexInstantiator() { 
			public Vertex newInstance(CompositeVertex parent) {
				DeConstantEmitter ce = DelibFactory.eINSTANCE.createDeConstantEmitter();
				ce.setName("CE");
				ce.setTimeStep(1);
				ce.setValueToEmit(new Integer(1));
				Pin opce1 = CoreFactory.eINSTANCE.createPin();
				opce1.setName("CE_OP");
				ce.getPinsOut().add(opce1);
				AtomicVertexAdapter va = new AtomicVertexAdapter((CompositeVertexAdapter) parent, ce);
				return va;
			}
		}, "ConstEmit"),
		new DndSource(new VertexInstantiator() {
			public Vertex newInstance(CompositeVertex parent) {
				DeEventPrinter print = DelibFactory.eINSTANCE.createDeEventPrinter();
				print.setName("PRINT");
				print.setPrintStream(System.out);
				Pin opp = CoreFactory.eINSTANCE.createPin();
				opp.setName("PRINT_OP");
				print.getPinsIn().add(opp);
				return new AtomicVertexAdapter((CompositeVertexAdapter) parent, print);
			}
		}, "DeEventPrinter"),
	};
	
	
	public static void main(String[] args) {	
		buildModel();
		ModelWindow w = new ModelWindow(deToolbox, model, ((DeModelOfComputation)model.getMoc()).getClock(), "tests/de1.xy");
		w.setVisible(true);
	}
}
