package fr.supelec.modhelx.tests;

import java.io.Serializable;

import fr.supelec.modhelx.util.StateWithBackup;

public class Test_StateBackup {
	
	private static class TestState extends StateWithBackup<TestState> implements Serializable {
		private static final long serialVersionUID = 1L;
		public int sampleValue = 0;
	}

	private void doTest() {
		TestState s = new TestState();
		s.sampleValue = 2;
		System.out.println("Before backup: sampleValue = " + s.sampleValue);
		s.backup();
		System.out.println("After backup: sampleValue = " + s.sampleValue);
		s.sampleValue = 10;
		System.out.println("Before restore: sampleValue = " + s.sampleValue);
		s = s.restore();
		System.out.println("After restore: sampleValue = " + s.sampleValue);
	}
	
	public static void main(String[] args) {
		new Test_StateBackup().doTest();
	}

}
