package fr.supelec.modhelx.util;

import java.util.List;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.EMap;

import fr.supelec.modhelx.core.CompositeBlock;
import fr.supelec.modhelx.core.ModelOfComputation;
import fr.supelec.modhelx.core.Pin;
import fr.supelec.modhelx.core.impl.AtomicBlockImpl;
import fr.supelec.modhelx.corelib.PluginBlock;

public abstract class PluggableBlock extends AtomicBlockImpl {
	private PluginBlock handle_ = null;
	
	public void handledBy(PluginBlock handle) {
		handle_ = handle;
	}
	
	public PluginBlock getHandle() {
		return handle_;
	}
	
	public final EList<Pin> getPinsIn() {
		return handle_.getPinsIn();
	}
	
	public final EList<Pin> getPinsOut() {
		return handle_.getPinsOut();
	}
	
	public final EMap<String, Object> getParameters() {
		return handle_.getParameters();
	}
	
	public final String getName() {
		return handle_.getName();
	}
	
	public final void setName(String name) {
		handle_.setName(name);
	}
	
	public final CompositeBlock getContainer() {
		return handle_.getContainer();
	}
	
	public final void setContainer(CompositeBlock container) {
		handle_.setContainer(container);
	}
	
	public final Object getValueOfParameter(String parameterName) {
		return handle_.getValueOfParameter(parameterName);
	}
	
	public final void setValueOfParameter(String parameterName, Object value) {
		handle_.setValueOfParameter(parameterName, value);
	}
	
	public ModelOfComputation getMoC() {
		return handle_.getMoC();
	}
	
	public abstract List<String> parameterNames();
}
