/**
 * Copyright (c) 2008-2011 Supélec.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * This file is part of the ModHel'X tool
 * 
 * Contributors:
 *     Computer Science Department, Supélec : initial implementation
 * Contacts:
 *     Cecile.Hardebolle@supelec.fr
 *     Christophe.Jacquet@supelec.fr
 *     Dominique.Marcadet@supelec.fr
 *     Frederic.Boulanger@supelec.fr
 *
 * $Id: Selector.java 331 2011-03-11 12:01:35Z marcadet $
 */
package fr.supelec.modhelx.util;

import java.util.ArrayList;
import java.util.Collection;

public abstract class Selector<T> {
	   public abstract boolean select(T item);

	   public ArrayList<T> selectAll(Collection<T> coll) {
		   ArrayList<T> result = new ArrayList<T>();
		   for (T elt : coll) {
			   if (select(elt)) result.add(elt);
		   }
		   return result;
	   }
}

